var List = System.Collections.Generic.List;
var Dictionary = System.Collections.Generic.Dictionary;
var ViewPoint;
(function (ViewPoint) {
    var Util;
    (function (Util) {
        var CommonUtilities = /** @class */ (function () {
            function CommonUtilities() {
            }
            /// <summary>
            ///     Checks to see if cookies are enabled in this browser.
            /// </summary>
            /// 
            /// <returns>
            ///     Returns "true" if cookies are eanbled, "false" if not.
            /// </returns>
            CommonUtilities.CookiesEnabled = function () {
                try {
                    var cookieEnabled;
                    if (CurrentBrowser.browserName() == 'Chrome') {
                        cookieEnabled = (navigator.cookieEnabled) ? true : false;
                    }
                    else {
                        document.cookie = "ftvptestcookie=yes";
                        cookieEnabled = (document.cookie.indexOf("ftvptestcookie") != -1) ? true : false;
                    }
                    return (cookieEnabled);
                }
                catch (_) {
                    return false;
                }
            };
            CommonUtilities.IsNotSupportCookieEnabledProperty = function () {
                return typeof navigator.cookieEnabled == "undefined";
            };
            /* AIS_NOTE: Unused function
            /// <summary>
            ///     Searches the visual tree for a FrameworkElement with a given name.
            /// </summary>
            ///
            /// <returns>
            ///     Returns the found 'FrameworkElement' or null
            /// </returns>
            ///
            /// <remarks>
            ///     This method will take some time given a parent element with many nested children
            /// </remarks>
            static GetTemplateChildByName(parent,name) {
                var childnum = VisualTreeHelper.GetChildrenCount(parent);
                for(var i = 0;i < childnum;i++) {
                    var child = VisualTreeHelper.GetChild(parent,i);
                    var feChild = helpers.asType(child,System.Windows.FrameworkElement);
                    if ((null != feChild) && (feChild.getName() == name)) {
                        return feChild;
                    } else {
                        var s = ViewPoint.Util.CommonUtilities.GetTemplateChildByName(child,name);
                        if (s != null)return s;
                    }
                }
                return null;
            }*/
            /// <summary>
            ///     For trend use,covert the datetime to datalogtime
            /// </summary>
            /// 
            /// <returns>
            ///     Returns datalogtime
            /// </returns>
            CommonUtilities.DateTimeToDatalogTime = function (theDateTime) {
                var tm1970 = System.DateTime.GetTm1970(theDateTime);
                var subtract = theDateTime.Date.valueOf() - tm1970;
                return Math.round(subtract / 1000);
            };
            /// <summary>
            ///     For trend use,covert the datalogtime to datetime
            /// </summary>
            /// 
            /// <returns>
            ///     Returns datetime
            /// </returns>
            CommonUtilities.DatalogTimeToDateTime = function (dlgtimeHi, dlgtimeLo) {
                var bigTicks = dlgtimeHi * 1000;
                var theDateTime = new System.DateTime(bigTicks).ToUniversalTime();
                var tm1970 = System.DateTime.GetTm1970(theDateTime);
                var adjTime = new System.DateTime(tm1970 + bigTicks);
                return adjTime;
            };
            CommonUtilities.ParseTime = function (timeticks) {
                // the number of .net ticks at the unix epoch
                var epochTicks = 621355968000000000;
                // there are 10000 .net ticks per millisecond
                var ticksPerMillisecond = 10000;
                // calculate the total number of .net ticks for your date
                var ticks = (timeticks - epochTicks) / ticksPerMillisecond;
                var datum = new Date(ticks);
                return new System.DateTime(datum);
            };
            CommonUtilities.CalculateDraggableArea = function (dlg) {
                try {
                    var x1, x2, y1, y2;
                    var VpBanner = $("#_vpBanner");
                    var VpBannerHeight = VpBanner.height();
                    var StatusBar = $("#StatusBar");
                    var StatusBarHeight = StatusBar.height();
                    var Splitter = $("#GridSplitter .hsplitter");
                    var SplitterHeight = Splitter.height();
                    x1 = 0;
                    y1 = VpBannerHeight;
                    x2 = $(window).width() - dlg.outerWidth();
                    var DisplayAreaHeight = $(window).height() - StatusBarHeight - SplitterHeight;
                    if (DisplayAreaHeight < dlg.outerHeight()) {
                        y2 = VpBannerHeight + dlg.outerHeight();
                    }
                    else {
                        y2 = $(window).height() - StatusBarHeight - SplitterHeight - dlg.outerHeight();
                    }
                    return [x1, y1, x2, y2];
                }
                catch (e) {
                    return $("#DisplayArea");
                }
            };
            /// <summary>
            ///     Replace decimal separator to current culture format.
            /// </summary>
            /// 
            /// <returns>
            ///     Returns converted string value in current culture.
            /// </returns>
            CommonUtilities.ReplaceSeparator = function (convertValue) {
                var separator = System.Globalization.CultureInfo.CurrentCulture.NumberFormat.NumberDecimalSeparator;
                if (separator != ".") {
                    convertValue = convertValue.replace(".", separator);
                }
                return convertValue;
            };
            return CommonUtilities;
        }());
        Util.CommonUtilities = CommonUtilities;
    })(Util = ViewPoint.Util || (ViewPoint.Util = {}));
})(ViewPoint || (ViewPoint = {}));
/// <reference path="../Client/VPAdmin/jquery.d.ts" />
var helpers = /** @class */ (function () {
    function helpers() {
    }
    helpers.TryParse = function (s, result) {
        result = Number(s);
        return {
            refs: [result],
            result: !isNaN(result)
        };
    };
    helpers.Compare = function (string1, string2, ignoreCase, useLocale, useOrdinal) {
        if (ignoreCase === void 0) { ignoreCase = false; }
        if (useLocale === void 0) { useLocale = false; }
        if (useOrdinal === void 0) { useOrdinal = false; }
        console.assert(!useOrdinal);
        if (ignoreCase) {
            if (useLocale) {
                string1 = string1.toLocaleLowerCase();
                string2 = string2.toLocaleLowerCase();
            }
            else {
                string1 = string1.toLowerCase();
                string2 = string2.toLowerCase();
            }
        }
        return string1 === string2 ? 0 : -1;
    };
    helpers.Format = function (format) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        for (var s in args) {
            var key = "{" + s + "}";
            while (format.indexOf(key) >= 0) {
                format = format.replace(key, args[s]);
            }
        }
        return format;
    };
    helpers.guid = function () {
        return this._p8() + this._p8(true) + this._p8(true) + this._p8();
    };
    helpers._p8 = function (s) {
        if (s === void 0) { s = false; }
        var p = (Math.random().toString(16) + "000000000").substr(2, 8);
        return s ? "-" + p.substr(0, 4) + "-" + p.substr(4, 4) : p;
    };
    helpers.showMessage = function (msg) {
        helpers.MessageToHtml(document.getElementById('message'), msg);
        var tag = "#MessageBox";
        $(tag).modal('show');
    };
    helpers.showErrorMessage = function (msg) {
        helpers.MessageToHtml(document.getElementById('errorMessage'), msg);
        var tag = "#errorWindow";
        $(tag).modal('show');
    };
    helpers.MessageToHtml = function (element, msg) {
        while (element.firstChild)
            element.removeChild(element.firstChild);
        var paragraphs = msg.split("\n");
        for (var i = 0; i < paragraphs.length; i++) {
            var paragraph = document.createElement("p");
            paragraph.textContent = paragraphs[i];
            element.appendChild(paragraph);
        }
    };
    return helpers;
}());
/// <reference path="../clientutil/commonutilities.ts" />
/// <reference path="../../helpers/helpers.ts" />
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            //region DELEGATES
            var ApplicationChangedEventArgs = /** @class */ (function () {
                function ApplicationChangedEventArgs(eScope, ePlatform, strFTDApplication) {
                    this.NewScope = eScope;
                    this.NewPlatform = ePlatform;
                    this.NewFTDApplication = strFTDApplication;
                }
                return ApplicationChangedEventArgs;
            }());
            VPAdmin.ApplicationChangedEventArgs = ApplicationChangedEventArgs;
            var ScopeChangedEventArgs = /** @class */ (function () {
                function ScopeChangedEventArgs(eScope) {
                    this.NewScope = eScope;
                }
                return ScopeChangedEventArgs;
            }());
            VPAdmin.ScopeChangedEventArgs = ScopeChangedEventArgs;
            var PlatformChangedEventArgs = /** @class */ (function () {
                function PlatformChangedEventArgs(ePlatform) {
                    this.NewPlatform = ePlatform;
                }
                return PlatformChangedEventArgs;
            }());
            VPAdmin.PlatformChangedEventArgs = PlatformChangedEventArgs;
            var Application = /** @class */ (function () {
                function Application() {
                }
                Application.GetViewPointAdminApp = function () {
                    if (Application.viewPointAdminApp == null) {
                        Application.viewPointAdminApp = new ViewPointAdminApp();
                    }
                    return Application.viewPointAdminApp;
                };
                Application.GetSelectApp = function () {
                    if (Application.selectApp == null) {
                        Application.selectApp = new VPAdmin.SelectApp();
                    }
                    return Application.selectApp;
                };
                Application.viewPointAdminApp = null;
                Application.selectApp = null;
                return Application;
            }());
            VPAdmin.Application = Application;
            var ViewPointAdminApp = /** @class */ (function () {
                function ViewPointAdminApp() {
                    this.userScope = null;
                    this.ScopeStrings = ["Site Edition (Network Distributed)", "Site Edition (Network Station)", "Site Edition (Local)"];
                    this._CurrentFTDApplication = "";
                    this._CurrentScope = 0;
                    this._CurrentPlatform = 0;
                    this._CurrentFTDServerName = "";
                    this.m_initParams = null;
                    this.m_PingThread = null;
                    this.m_PingCompleted = null;
                    this.m_PingRate = ViewPoint.Client.VPAdmin.ViewPointAdminApp.DEFAULT_PING_RATE_IN_MILLISECONDS;
                    this.m_UserName = null;
                    this.userScope = null;
                    this.m_UserHost = null;
                    this.m_ASPNETSessionId = null;
                    ViewPointAdminApp.m_strInstanceID = helpers.guid();
                    this.Services = null;
                    this.Grid = null;
                    this.publishLastPageIndex = 0;
                    this.republish = true;
                    this.success = false;
                    this.showErrorReport = false;
                }
                ViewPointAdminApp.prototype.ResetPublish = function () {
                    this.lblCurrentStatus = undefined;
                    this.btnPublish = undefined;
                    this.btnPublishWebM = undefined;
                    this.hlErrors = undefined;
                    this.progressBar = undefined;
                    this.rpAppButtonSelectDisplayBack = undefined;
                    this.home = undefined;
                    this.lpAppSelect = undefined;
                    this.lpAppSelectDisplay = undefined;
                    this.publishClass = null;
                };
                Object.defineProperty(ViewPointAdminApp.prototype, "CurrentFTDApplication", {
                    get: function () {
                        return this._CurrentFTDApplication;
                    },
                    set: function (value) {
                        this._CurrentFTDApplication = value;
                        // Fire out to Listeners
                        /*AIS_NOTE this.FireApplicationChanged(this.CurrentFTDScope,this.CurrentFTDPlatform,this._CurrentFTDApplication);*/
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(ViewPointAdminApp.prototype, "CurrentFTDScope", {
                    get: function () {
                        return this._CurrentScope;
                    },
                    set: function (value) {
                        this._CurrentScope = value;
                        /*AIS_NOTE this.FireScopeChanged(this._CurrentScope);*/
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(ViewPointAdminApp.prototype, "CurrentFTDPlatform", {
                    get: function () {
                        return this._CurrentPlatform;
                    },
                    set: function (value) {
                        this._CurrentPlatform = value;
                        /*AIS_NOTE this.FirePlatformChanged(this._CurrentPlatform);*/
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(ViewPointAdminApp.prototype, "CurrentFTDServerName", {
                    get: function () {
                        return this._CurrentFTDServerName;
                    },
                    set: function (value) {
                        this._CurrentFTDServerName = value;
                        /*AIS_NOTE if (CurrentFTDServerChanged != null) {
                            CurrentFTDServerChanged(this);
                        }*/
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(ViewPointAdminApp.prototype, "InitParams", {
                    get: function () {
                        return this.m_initParams;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(ViewPointAdminApp.prototype, "StringUser", {
                    get: function () {
                        return this.m_UserName;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(ViewPointAdminApp.prototype, "UserScope", {
                    get: function () {
                        return this.userScope;
                    },
                    enumerable: true,
                    configurable: true
                });
                ViewPointAdminApp.prototype.FireApplicationChanged = function (scNewScope, scNewPlatform, strNewFTDApplication) {
                    if (this.CurrentApplicationChanged != null) {
                        this.CurrentApplicationChanged(this, new ViewPoint.Client.VPAdmin.ApplicationChangedEventArgs(scNewScope, scNewPlatform, strNewFTDApplication));
                    }
                };
                ViewPointAdminApp.prototype.FireScopeChanged = function (newScope) {
                    if (this.CurrentScopeChanged != null) {
                        this.CurrentScopeChanged(this, new ViewPoint.Client.VPAdmin.ScopeChangedEventArgs(newScope));
                    }
                };
                ViewPointAdminApp.prototype.FirePlatformChanged = function (newPlatform) {
                    if (this.CurrentPlatformChanged != null) {
                        this.CurrentPlatformChanged(this, new ViewPoint.Client.VPAdmin.PlatformChangedEventArgs(newPlatform));
                    }
                };
                ViewPointAdminApp.prototype.serialize = function (selectedStartupMacro, ftViewApplication) {
                    var serializer = new XMLSerializer();
                    ftViewApplication.find('StartupMacro').remove();
                    if (selectedStartupMacro == "None")
                        return serializer.serializeToString(ftViewApplication[0]);
                    var xmlnode = '<StartupMacro>' + ((selectedStartupMacro) ? selectedStartupMacro : "") + '</StartupMacro>';
                    var parser = new DOMParser();
                    var startup = parser.parseFromString(xmlnode, 'text/xml');
                    var temp = ftViewApplication.append(startup.childNodes[0]);
                    return serializer.serializeToString(temp[0]);
                };
                /// <summary>
                ///     Get the ConnectionHelper properly initialized with the user name and user host.
                /// </summary>
                ///
                /// <returns>
                ///     ConnectionHelper.
                /// </returns>
                ViewPointAdminApp.prototype.GetConnectionHelper = function () {
                    return VPAdmin.ConnectionHelper.GetInstance(this.m_UserName, this.m_UserHost);
                };
                ViewPointAdminApp.prototype.GetASPNETSessionID = function () {
                    return this.m_ASPNETSessionId;
                };
                /// <summary>
                ///     Application statup handler.
                /// </summary>
                ///
                /// <param name="sender">
                ///     Sender.
                /// </param>
                ///
                /// <param name="e">
                ///     Event arguments.
                /// </param>
                ViewPointAdminApp.prototype.Application_Startup = function (sender, e, Services, BannerControlService, scope) {
                    // Save the initial parameters passed in.
                    this.Services = Services;
                    this.m_initParams = e.InitParams;
                    var securityScope;
                    if (this.m_initParams.hasItem("SecuredScope")) {
                        securityScope = decodeURIComponent(this.m_initParams.getItem("SecuredScope"));
                        //userScope = securityScope;
                        if (securityScope == "$Global") {
                            this.userScope = ViewPoint.Client.VPAdmin.WebService.Scope.Global;
                        }
                        else if (securityScope == "$Local") {
                            this.userScope = ViewPoint.Client.VPAdmin.WebService.Scope.Local;
                        }
                    }
                    var applicationScopeString;
                    var applicationScope = null;
                    if (this.m_initParams.hasItem("CurrentScope")) {
                        applicationScopeString = this.m_initParams.getItem("CurrentScope");
                        if (applicationScopeString == "$Global") {
                            applicationScope = ViewPoint.Client.VPAdmin.WebService.Scope.Global;
                        }
                        else if (applicationScopeString == "$Local") {
                            applicationScope = ViewPoint.Client.VPAdmin.WebService.Scope.Local;
                        }
                    }
                    if (this.UserScope != null) {
                        this._CurrentScope = this.UserScope;
                    }
                    else if (applicationScope != null) {
                        this._CurrentScope = applicationScope;
                    }
                    if (!this.UserScope || (applicationScope && (this.UserScope == applicationScope))) {
                        var strTryGetFTDApplication;
                        if (this.m_initParams.hasItem("CurrentFTDApplication")) {
                            strTryGetFTDApplication = this.m_initParams.getItem("CurrentFTDApplication");
                            // Since we are setting the member variable instead of the
                            // Property, no Event will fire out. This is the intended behaviour
                            // becaue we are at startup, and any listenr may be in a pseudo state
                            // of awareness.
                            this._CurrentFTDApplication = strTryGetFTDApplication;
                            BannerControlService.SelectedAppName = strTryGetFTDApplication;
                        }
                    }
                    var strTryGetTargetPlatform;
                    if (this.m_initParams.hasItem("CurrentTargetPlatform")) {
                        strTryGetTargetPlatform = this.m_initParams.getItem("CurrentTargetPlatform");
                        if (helpers.Compare(strTryGetTargetPlatform, "Station", true, true) == 0) {
                            this._CurrentPlatform = ViewPoint.Client.VPAdmin.WebService.TargetPlatform.Station;
                        }
                        else if (helpers.Compare(strTryGetTargetPlatform, "Distributed", true, true) == 0) {
                            this._CurrentPlatform = ViewPoint.Client.VPAdmin.WebService.TargetPlatform.Distributed;
                        }
                        else
                            this._CurrentPlatform = ViewPoint.Client.VPAdmin.WebService.TargetPlatform.StandAlone;
                        BannerControlService.SelectedAppType = this.ScopeStrings[this._CurrentPlatform];
                    }
                    var strTryGetFTDServerName;
                    if (this.m_initParams.hasItem("FTDServerName")) {
                        strTryGetFTDServerName = this.m_initParams.getItem("FTDServerName");
                        // Since we are setting the member variable instead of the
                        // Property, no Event will fire out. This is the intended behaviour
                        // becaue we are at startup, and any listener may be in a pseudo state
                        // of awareness.
                        this._CurrentFTDServerName = strTryGetFTDServerName;
                    }
                    var strUserName;
                    if (this.m_initParams.hasItem("User")) {
                        strUserName = this.m_initParams.getItem("User");
                        scope.username = strUserName;
                        this.m_UserName = strUserName;
                    }
                    var strUserHost;
                    if (this.m_initParams.hasItem("UserHost")) {
                        strUserHost = this.m_initParams.getItem("UserHost");
                        this.m_UserHost = strUserHost;
                    }
                    var strASPNETSessionId;
                    if (this.m_initParams.hasItem("SessionID")) {
                        strASPNETSessionId = this.m_initParams.getItem("SessionID");
                        this.m_ASPNETSessionId = strASPNETSessionId;
                        VPAdmin.VPAdminUtil.SetCookie("ASP.NET_SessionId", strASPNETSessionId); /*TODO temporalt */
                    }
                    var strPingRate;
                    if (this.m_initParams.hasItem("PingRate")) {
                        strPingRate = this.m_initParams.getItem("PingRate");
                        var nPingRate;
                        if ((function () {
                            var _tmp = helpers.TryParse(strPingRate, nPingRate);
                            nPingRate = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(this)) {
                            // NOTE: The "PingRate" parameter value passed in is in "seconds".
                            //       Since all internal calculations on the ping rate are in milli-seconds,
                            //       lets convert the value passed in to milli-seconds.
                            nPingRate *= 1000;
                            // Check to see that the ping rate passed in is greater than
                            // the minimum ping rate.
                            if (nPingRate > ViewPoint.Client.VPAdmin.ViewPointAdminApp.MINIMUM_PING_RATE_IN_MILLISECONDS) {
                                // Save the ping rate passed in for future use.
                                this.m_PingRate = nPingRate;
                            }
                        }
                    }
                    // Create a new main page.
                    // Check to see if cookies are enabled in this browser.
                    if (!ViewPoint.Util.CommonUtilities.CookiesEnabled()) {
                        // Cookies are diabled. Inform the user that cookies need to be enabled before we can continue.
                        this.DisplayCookiesDisabledPageContent();
                        return;
                    }
                    var strSessionID = this.GetSessionIdentifierForThisComputer();
                    console.assert(!strSessionID);
                    VPAdmin.ConnectionHelper.UniqueClientIdentifier = strSessionID;
                    // Attempt to start a session with the FactoryTalk ViewPoint Administration Service.
                    this.BeginSession();
                };
                /// <summary>
                ///     Application exit handler.
                /// </summary>
                ///
                ViewPointAdminApp.prototype.Application_Exit = function () {
                    // If we acquired the session, release it now.
                    if (VPAdmin.ConnectionHelper.SessionIdentifierInUseByThisApplication) {
                        ViewPointAdminApp.ReleaseExclusiveUseOfSessionIdentifierForThisComputer();
                    }
                };
                /*TODO
                /// <summary>
                ///     Unhandled exception handler.
                /// </summary>
                ///
                /// <param name="sender">
                ///     Sender.
                /// </param>
                ///
                /// <param name="e">
                ///     Provides data for the UnhandledException event.
                /// </param>
                Application_UnhandledException(sender,e) {
                    // If we acquired the session, release it now.
                    if (ConnectionHelper.getSessionIdentifierInUseByThisApplication()) {
                        this.ReleaseExclusiveUseOfSessionIdentifierForThisComputer();
                    }
                    // If the app is running outside of the debugger then report the exception using
                    // the browser's exception mechanism. On IE this will display it a yellow alert
                    // icon in the status bar and Firefox will display a script error.
                    if (!System.Diagnostics.Debugger.getIsAttached()) {
                        // NOTE: This will allow the application to continue running after an exception has been thrown
                        // but not handled.
                        // For production applications this error handling should be replaced with something that will
                        // report the error to the website and stop the application.
                        e.setHandled(true);
                        try {
                            var errorMsg = e.getExceptionObject().message + e.getExceptionObject().getStackTrace();
                            errorMsg = errorMsg.Replace("\"","\'").Replace("\r\n","@\"\\n\"");
                            System.Windows.Browser.HtmlPage.getWindow().Eval("throw new Error(\"Unhandled Error in Silverlight 2 Application " + errorMsg + "\");");
                        }catch(_) {
                        }
                    }
                }*/
                /// <summary>
                ///     Attempt to establish a session with the FactoryTalk ViewPoint Administration Service.
                /// </summary>
                ViewPointAdminApp.prototype.BeginSession = function () {
                    // Startup and display a busy animation while we wait for a response from the FactoryTalk ViewPoint Administration Service.
                    this.DisplayBusyAnimation();
                    // Make an asynchronous call to BeginSession( ).
                    //this.GetConnectionHelper().SubscribeBeginSession(this.BeginSessionCompleted);
                    //this.GetConnectionHelper().TryBeginSession();
                    this.Services.BeginSession(this, this.BeginSessionCompleted, this.GetConnectionHelper().m_ClientIdentifier);
                };
                ViewPointAdminApp.parseResult = function (xml, serviceName) {
                    var xpath = serviceName + 'Result';
                    return xml.find(xpath).text();
                };
                ViewPointAdminApp.parseXML = function (data) {
                    try {
                        var xmlDoc = $.parseXML(data);
                    }
                    catch (e) {
                        xmlDoc = undefined;
                    }
                    if (!xmlDoc || !xmlDoc.documentElement || xmlDoc.getElementsByTagName("parsererror").length) {
                        jQuery.error("Invalid XML: " + data);
                    }
                    return $(xmlDoc);
                };
                ViewPointAdminApp.parseValue = function (xml, value) {
                    return xml.find(value).text();
                };
                /// <summary>
                ///     BeginSession( ) call completion handler.
                /// </summary>
                ViewPointAdminApp.prototype.BeginSessionCompleted = function (sender, args) {
                    // Shutdown and hide the busy animation.
                    this.HideBusyAnimation();
                    // Check to see if the asynchronous call to BeginSession( ) was cancelled or returned an error.
                    // If so, simply return.
                    if (args.getCancelled()) {
                        // Write a trace message.
                        console.log("BeginSessionCompleted( ): The call to BeginSession( ) was cancelled.");
                        // Display the "Server not available" page content.
                        this.DisplayServerNotAvailablePageContent();
                        return;
                    }
                    if (args.getError() != null) {
                        // Write a trace message.
                        console.log("BeginSessionCompleted( ): The call to BeginSession( ) returned an error. Exception: " + args.getError().message);
                        // Display the "Server not available" page content.
                        this.DisplayServerNotAvailablePageContent();
                        return;
                    }
                    var bSessionIdentierIsAvailableForAcquiring = false;
                    if (args.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.SessionIsAlreadyActive && !this.GetSessionIsInUseByForThisComputer()) {
                        bSessionIdentierIsAvailableForAcquiring = true;
                    }
                    // Check the result returned by the FactoryTalk ViewPoint Administration Service.
                    if (args.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success || args.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.SessionHasBeenRenewed || (args.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.SessionIsAlreadyActive && (VPAdmin.ConnectionHelper.SessionIdentifierInUseByThisApplication || bSessionIdentierIsAvailableForAcquiring))) {
                        // Start pinging the FactoryTalk ViewPoint Administration Service to keep the session alive.
                        if (this.m_PingThread == null) {
                            if (typeof (Worker) !== "undefined") {
                                this.m_PingThread = new Worker("./Scripts/app/pingThread.js"); //this.PingThreadMain
                                this.m_PingThread.onmessage = function (event) {
                                    var dom = ViewPoint.Client.VPAdmin.ViewPointAdminApp.parseXML(event.data);
                                    var args = new function () {
                                        this.getResult = function () {
                                            var result = ViewPoint.Client.VPAdmin.ViewPointAdminApp.parseResult(dom, 'Ping');
                                            return ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode[result];
                                        };
                                        this.getError = function () {
                                            return null;
                                        };
                                        this.getCancelled = function () {
                                            return null;
                                        };
                                    };
                                    ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().PingCompleted(null, args);
                                };
                                var clientIdentifier = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().GetConnectionHelper().m_ClientIdentifier;
                                var uniqueID = clientIdentifier.getItem("UniqueClientIdentifier");
                                var userhost = clientIdentifier.getItem("UserHost");
                                var username = clientIdentifier.getItem("UserName");
                                this.m_PingThread.postMessage({ "uniqueid": uniqueID, "userhost": userhost, "username": username, "pingrate": this.m_PingRate, 'url': ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().GetConnectionHelper().m_svcAddress });
                            }
                            else {
                                alert("Does not support the use of Web Worker");
                            }
                        }
                        var strSessionID;
                        strSessionID = this.AcquireExclusiveUseOfSessionIdentifierForThisComputer();
                        console.assert(!strSessionID);
                        VPAdmin.ConnectionHelper.UniqueClientIdentifier = strSessionID;
                        VPAdmin.ConnectionHelper.SessionIdentifierInUseByThisApplication = true;
                        // Display the main page content.
                        this.DisplayMainPageContent();
                    }
                    else if (args.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.SessionIsCurrentlyInUseByAnotherClient || args.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.SessionIsNotInUse || args.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.SessionIsAlreadyActive) {
                        // Display the "Server is in use" page content.
                        this.DisplayServerInUsePageContent(args.getsessionOwnersClientIdentifier());
                    }
                    else {
                        // Display the "Server not available" page content.
                        this.DisplayServerNotAvailablePageContent();
                    }
                };
                /// <summary>
                ///     Display the main page content.
                /// </summary>
                ViewPointAdminApp.prototype.DisplayMainPageContent = function () {
                    var mainPage = document.getElementById('MainPageContent');
                    console.assert(mainPage != null);
                    mainPage.style.visibility = "visible";
                };
                /// <summary>
                ///     Display the "Cookies are currently disabled" page content.
                /// </summary>
                ViewPointAdminApp.prototype.DisplayCookiesDisabledPageContent = function () {
                    var mainPage = document.getElementById('ErrorPageContent');
                    console.assert(mainPage != null);
                    mainPage.children['_ErrorPageHeading'].textContent = VPAdmin.ResourceBinder.getCookiesDisabledPageHeading();
                    mainPage.children['_ErrorPageMessage'].textContent = VPAdmin.ResourceBinder.getCookiesDisabledPageContents();
                    mainPage.style.visibility = "visible";
                };
                /// <summary>
                ///     Display the "Server not available" page content.
                /// </summary>
                ViewPointAdminApp.prototype.DisplayServerNotAvailablePageContent = function () {
                    var mainPage = document.getElementById('ErrorPageContent');
                    console.assert(mainPage != null);
                    mainPage.children['_ErrorPageHeading'].textContent = VPAdmin.ResourceBinder.getServerNotAvailablePageHeading();
                    mainPage.children['_ErrorPageMessage'].textContent = VPAdmin.ResourceBinder.getServerNotAvailablePageContents();
                    mainPage.style.visibility = "visible";
                };
                /// <summary>
                ///     Display the "Server in use" page content.
                /// </summary>
                ViewPointAdminApp.prototype.DisplayServerInUsePageContent = function (sessionOwnersClientIdentifier) {
                    var mainPage = document.getElementById('ErrorPageContent');
                    console.assert(mainPage != null);
                    mainPage.children['_ErrorPageHeading'].textContent = VPAdmin.ResourceBinder.getServerInUsePageHeading();
                    var strServerInUsePageContents = this.GetServerInUsePageContents(sessionOwnersClientIdentifier);
                    mainPage.children['_ErrorPageMessage'].textContent = strServerInUsePageContents;
                    mainPage.style.visibility = "visible";
                };
                /// <summary>
                ///     Returns the appropriately formatted page contents depending on the information
                ///     available in the client identifier passed in.
                /// </summary>
                ///
                /// <param name="sessionOwnersClientIdentifier">
                ///     Session owners client identifier.
                /// </param>
                ///
                /// <returns>
                ///     Appropriately formatted page contents.
                /// </returns>
                ViewPointAdminApp.prototype.GetServerInUsePageContents = function (sessionOwnersClientIdentifier) {
                    // If no client identifier is specified, simply return the generic page contents.
                    if (sessionOwnersClientIdentifier == null) {
                        return VPAdmin.ResourceBinder.getServerInUseNoUserOrHostPageContents();
                    }
                    var bUserAvailable = sessionOwnersClientIdentifier.children("username").text();
                    var bHostAvailable = sessionOwnersClientIdentifier.children("userhost").text();
                    // If no user or host is available, simply return the generic page contents.
                    if (!bUserAvailable && !bHostAvailable) {
                        return VPAdmin.ResourceBinder.getServerInUseNoUserOrHostPageContents();
                    }
                    // If a user and host are available, return the appropriately formatted page contents.
                    if (bUserAvailable && bHostAvailable) {
                        return helpers.Format(VPAdmin.ResourceBinder.getServerInUsePageContents(), bUserAvailable, bHostAvailable);
                    }
                    // If no user is available, but a host is available, return appropriately formatted page contents.
                    if (!bUserAvailable && bHostAvailable) {
                        return helpers.Format(VPAdmin.ResourceBinder.getServerInUseNoUserPageContents(), bHostAvailable);
                    }
                    // If a user is available, but no host is available, return appropriately formatted page contents.
                    if (bUserAvailable && !bHostAvailable) {
                        return helpers.Format(VPAdmin.ResourceBinder.getServerInUseNoHostPageContents(), bUserAvailable);
                    }
                    return null;
                };
                /// <summary>
                ///     Startup and display a "busy" animation to indicate that the client browser is waiting for a response from the
                ///     FactoryTalk ViewPoint Administration Service.
                /// </summary>
                ViewPointAdminApp.prototype.DisplayBusyAnimation = function () {
                    var busyIndicator = document.getElementById('busyIndicator');
                    console.assert(busyIndicator != null);
                    busyIndicator.style.display = "block";
                };
                /// <summary>
                ///     Shutdown and hide the "busy" animation.
                /// </summary>
                ViewPointAdminApp.prototype.HideBusyAnimation = function () {
                    var busyIndicator = document.getElementById('busyIndicator');
                    console.assert(busyIndicator != null);
                    busyIndicator.style.display = "none";
                };
                /// <summary>
                ///     Attempt to close the current session with the FactoryTalk ViewPoint Administration Service.
                /// </summary>
                /*TODO EndSession() {
                    // Was a session previously established?
                    if (ConnectionHelper.SessionIdentifierInUseByThisApplication) {
                        // Yes, it was. Attempt to end the session with the FactoryTalk ViewPoint Administration Service.
                        this.GetConnectionHelper().SubscribeEndSession(this.EndSessionCompleted);
                        this.GetConnectionHelper().TryEndSession();
                    }
                }*/
                /// <summary>
                ///     EndSession( ) call completion handler.
                /// </summary>
                ///
                /// <param name="sender">
                ///     Sender.
                /// </param>
                ///
                /// <param name="args">
                ///     Arguments.
                /// </param>
                ViewPointAdminApp.prototype.EndSessionCompleted = function (sender, args) {
                    // Check to see if the asynchronous call to EndSession( ) was cancelled or returned an error.
                    // If so, simply return.
                    if (args.getCancelled()) {
                        // Write a trace message.
                        console.log("EndSessionCompleted( ): The call to EndSession( ) was cancelled.");
                        return;
                    }
                    if (args.getError() != null) {
                        // Write a trace message.
                        console.log("EndSessionCompleted( ): The call to EndSession( ) returned an error. Exception: " + args.getError().message);
                        return;
                    }
                };
                /// <summary>
                ///     Body of the worker thread that pings the FactoryTalk ViewPoint Administration Service in order as to
                ///     keep the session alive.
                /// </summary>
                /*PingThreadMain() {
                    //this.m_PingCompleted = new System.Threading.AutoResetEvent(false);
                    //this.GetConnectionHelper().SubscribePing(this.PingCompleted);
                    while ( true ) {
                        var startTime = new Date().getMilliseconds;
                        // Ping the FactoryTalk ViewPoint Administration Service.
                        this.GetConnectionHelper().TryPing();
                        // Wait for the Ping completion event.
                        this.m_PingCompleted.WaitOne();
                        var endTime = new Date().getMilliseconds;
                        var timeToCompleteAPing = +(endTime) - +(startTime);
                        var timeToCompleteAPingInMilliseconds = timeToCompleteAPing;
                        // Is the actual time to do the ping less than the ping interval?
                        if (timeToCompleteAPingInMilliseconds < this.m_PingRate) {
                            // Yes, it is. Wait for the remainder of the interval before doing the next ping.
                            //Thread.Sleep(this.m_PingRate - timeToCompleteAPingInMilliseconds);
                        }
                    }
                }*/
                /// <summary>
                ///     Ping( ) call completion handler.
                /// </summary>
                ///
                /// <param name="sender">
                ///     Sender.
                /// </param>
                ///
                /// <param name="args">
                ///     Arguments.
                /// </param>
                ViewPointAdminApp.prototype.PingCompleted = function (sender, args) {
                    try {
                        // Check to see if the asynchronous call to Ping( ) was cancelled or returned an error.
                        // If so, simply return.
                        if (args.getCancelled()) {
                            // Write a trace message.
                            console.log("PingCompleted( ): The call to Ping( ) was cancelled.");
                            return;
                        }
                        if (args.getError() != null) {
                            // Write a trace message.
                            console.log("PingCompleted( ): The call to Ping( ) returned an error. Exception: " + args.getError().message);
                            return;
                        }
                        // Validate that the call to Ping was successful.
                        if (args.getResult() != ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                            console.log("PingCompleted( ): The call to Ping( ) returned an error: " + args.getResult());
                        }
                    }
                    finally {
                        // Signal the Ping thread that we received a response.
                        //console.assert(this.m_PingCompleted != null);
                    }
                };
                /***region SESSION MANAGEMENT***/
                /// <summary>
                ///     Acquire exclusive use of the session identifier for this computer.
                /// </summary>
                ///
                /// <param name="strSessionID">
                ///     Session identifier for this computer.
                /// </param>
                ViewPointAdminApp.prototype.AcquireExclusiveUseOfSessionIdentifierForThisComputer = function () {
                    // Initialize the return values - they will be reset later, if need be.
                    var strSessionID = null;
                    var scope = ViewPoint.Client.VPAdmin.ViewPointAdminApp;
                    var docum = JSON.parse(localStorage.getItem(scope.SESSION_ELEMENT_NAME));
                    if (!docum) {
                        // Create the session identifier information and persist it
                        // in the session identifier information file in our isolated storage.
                        this.CreateSessionIdentifierForThisComputer();
                        console.assert(docum != null);
                        docum = JSON.parse(localStorage.getItem(scope.SESSION_ELEMENT_NAME));
                    }
                    try {
                        // Get the session identifer attribute.
                        console.assert(docum[scope.SESSION_ID_ATTRIBUTE_NAME] != null);
                        strSessionID = docum[scope.SESSION_ID_ATTRIBUTE_NAME];
                        // Set the session "is in use by" attribute to this instance of the Application.
                        console.assert(!ViewPointAdminApp.m_strInstanceID);
                        docum[scope.SESSION_IS_IN_USE_BY_ATTRIBUTE_NAME] = ViewPointAdminApp.m_strInstanceID;
                        // Save the document.
                        localStorage.setItem(scope.SESSION_ELEMENT_NAME, JSON.stringify(docum));
                    }
                    finally {
                    }
                    return strSessionID;
                };
                /// <summary>
                ///     Release our exclusive use of the session identifier for this computer.
                /// </summary>
                ViewPointAdminApp.ReleaseExclusiveUseOfSessionIdentifierForThisComputer = function () {
                    var scope = ViewPoint.Client.VPAdmin.ViewPointAdminApp;
                    var bUpdateDocument = false;
                    var docum = JSON.parse(localStorage.getItem(scope.SESSION_ELEMENT_NAME));
                    console.assert(docum != null);
                    // Does the session identifier exist?
                    if (!docum) {
                        return;
                    }
                    try {
                        // Open the contents of the session identifier information object.
                        var sessionIsInUseAttribute = docum[scope.SESSION_IS_IN_USE_BY_ATTRIBUTE_NAME];
                        console.assert(sessionIsInUseAttribute != null);
                        // Are we the Application that currently owns the session identifier on this computer?
                        console.assert(!ViewPointAdminApp.m_strInstanceID);
                        if (sessionIsInUseAttribute && helpers.Compare(ViewPointAdminApp.m_strInstanceID, sessionIsInUseAttribute, false, false, true) == 0) {
                            // Yes, we are. Set the session "is in use by" attribute to null.
                            docum[scope.SESSION_IS_IN_USE_BY_ATTRIBUTE_NAME] = "";
                            bUpdateDocument = true;
                        }
                    }
                    finally {
                    }
                    if (bUpdateDocument) {
                        // Save the document.
                        localStorage.setItem(scope.SESSION_ELEMENT_NAME, JSON.stringify(docum));
                    }
                };
                /// <summary>
                ///     Create the session identifier information file.
                /// </summary>
                ///
                /// <param name="store">
                ///     Isolated storage.
                /// </param>
                ViewPointAdminApp.prototype.CreateSessionIdentifierForThisComputer = function () {
                    // Create the session identifier information file in isolated storage.
                    try {
                        var scope = ViewPoint.Client.VPAdmin.ViewPointAdminApp;
                        var docum = {};
                        docum[scope.SESSION_ID_ATTRIBUTE_NAME] = helpers.guid();
                        docum[scope.SESSION_IS_IN_USE_BY_ATTRIBUTE_NAME] = "";
                        localStorage.setItem(scope.SESSION_ELEMENT_NAME, JSON.stringify(docum));
                    }
                    finally {
                    }
                };
                /// <summary>
                ///     Simply reads and returns the session identifier for this computer.
                ///
                ///     NOTE: This method does NOT acquire exclusive use of the session identifier for
                ///     this computer.
                /// </summary>
                ///
                /// <returns>
                ///     Session identifier for this computer.
                /// </returns>
                ViewPointAdminApp.prototype.GetSessionIdentifierForThisComputer = function () {
                    // Does the session identifier file exist?
                    var scope = ViewPoint.Client.VPAdmin.ViewPointAdminApp;
                    var docum = JSON.parse(localStorage.getItem(scope.SESSION_ELEMENT_NAME));
                    if (!docum) {
                        // Create the session identifier information and persist it
                        // in the session identifier information file in our isolated storage.
                        this.CreateSessionIdentifierForThisComputer();
                        docum = JSON.parse(localStorage.getItem(scope.SESSION_ELEMENT_NAME));
                        console.assert(docum != null);
                    }
                    try {
                        // Open the contents of the session identifier information file in an XML document.
                        // Return the session identifer attribute.
                        var item = docum[scope.SESSION_ID_ATTRIBUTE_NAME];
                        console.assert(item);
                        return item;
                    }
                    finally {
                    }
                };
                /// <summary>
                ///     Simply reads and returns the client identifier of the Application that
                ///     currently has exclusive access to the session identifier for this computer.
                /// </summary>
                ///
                /// <returns>
                ///     The client identifier of the Application that currently has exclusive access
                ///     to the session identifier for this computer.
                /// </returns>
                ViewPointAdminApp.prototype.GetSessionIsInUseByForThisComputer = function () {
                    var scope = ViewPoint.Client.VPAdmin.ViewPointAdminApp;
                    var docum = JSON.parse(localStorage.getItem(scope.SESSION_ELEMENT_NAME));
                    // Does the session identifier file exist?
                    if (!docum) {
                        // Create the session identifier information and persist it
                        // in the session identifier information file in our isolated storage.
                        this.CreateSessionIdentifierForThisComputer();
                        docum = JSON.parse(localStorage.getItem(scope.SESSION_ELEMENT_NAME));
                        console.assert(docum != null);
                    }
                    try {
                        // Return the client identifier of the Application that currently has exclusive access
                        // to the session identifier for this computer.
                        var item = docum[scope.SESSION_IS_IN_USE_BY_ATTRIBUTE_NAME];
                        console.assert(item);
                        return item;
                    }
                    finally {
                    }
                };
                /**end region SESSION MANAGEMENT**/
                //region PUBLISH BEGIN AND END NOTIFICATION
                ViewPointAdminApp.prototype.NotifyPublishBegin = function () {
                    if (this.OnPublishBegin != null) {
                        this.OnPublishBegin(this, null);
                    }
                };
                ViewPointAdminApp.prototype.NotifyPublishComplete = function () {
                    if (this.OnPublishComplete != null) {
                        this.OnPublishComplete(this, null);
                    }
                };
                ViewPointAdminApp.DEFAULT_PING_RATE_IN_MILLISECONDS = 2000;
                ViewPointAdminApp.MINIMUM_PING_RATE_IN_MILLISECONDS = 1000;
                ViewPointAdminApp.SESSION_ID_FILE_NAME = "FTVP_Admin_Session_Info.xml";
                ViewPointAdminApp.SESSION_ELEMENT_NAME = "Session";
                ViewPointAdminApp.SESSION_ID_ATTRIBUTE_NAME = "id";
                ViewPointAdminApp.SESSION_IS_IN_USE_BY_ATTRIBUTE_NAME = "isInUseBy";
                return ViewPointAdminApp;
            }());
            VPAdmin.ViewPointAdminApp = ViewPointAdminApp;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var AppLogin = /** @class */ (function () {
                function AppLogin() {
                    this.m_strScope = "";
                    this.m_isRuntime = null;
                    this.m_strPostbackMessage = null;
                    this.m_initParams = null;
                    this.m_strInactivityTO = 0;
                    this.m_strStatus = null;
                    this.m_UserName = null;
                    this.m_isNeedInit = true;
                }
                AppLogin.GetLoginApp = function () {
                    if (AppLogin.loginApp == null) {
                        AppLogin.loginApp = new AppLogin();
                    }
                    return AppLogin.loginApp;
                };
                AppLogin.prototype.getInitParams = function () {
                    return this.m_initParams;
                };
                AppLogin.prototype.getPostbackMessage = function () {
                    return this.m_strPostbackMessage;
                };
                AppLogin.prototype.getStrScope = function () {
                    return this.m_strScope;
                };
                AppLogin.prototype.getIsRuntime = function () {
                    return this.m_isRuntime;
                };
                AppLogin.prototype.Application_Startup = function (sender, e) {
                    this.m_initParams = e.InitParams;
                    if (this.m_initParams.hasItem("msg")) {
                        // We are in postback mode and there might be a message for us to display
                        this.m_strPostbackMessage = this.m_initParams.getItem("msg");
                    }
                    if (this.m_initParams.hasItem("application")) {
                        this.IsMEPlatform = 0 == helpers.Compare(this.m_initParams.getItem("application"), "PVPViewPoint", false, false);
                    }
                    if (this.m_initParams.hasItem("SetUrlString")) {
                        this.m_isRuntime = 0 == helpers.Compare(this.m_initParams.getItem("SetUrlString"), "Runtime", false, false);
                    }
                    if (this.m_initParams.hasItem("scope")) {
                        this.m_strScope = this.m_initParams.getItem("scope");
                    }
                    if (this.m_initParams.hasItem("inactTO")) {
                        this.m_strInactivityTO = this.m_initParams.getItem("inactTO");
                    }
                    if (this.m_initParams.hasItem("status")) {
                        this.m_strStatus = this.m_initParams.getItem("status");
                    }
                    if (this.m_initParams.hasItem("User")) {
                        this.m_UserName = this.m_initParams.getItem("User");
                    }
                    // Check to see if cookies are enabled in this browser.
                    if (!ViewPoint.Util.CommonUtilities.CookiesEnabled()) {
                        this.m_isNeedInit = false;
                        // Cookies are diabled. Inform the user that cookies need to be enabled before we can continue.
                        this.DisplayCookiesDisabledPageContent();
                        return;
                    }
                    //his.RootVisual = new ViewPoint.Client.Authentication.LoginPage();
                    var mainPage = document.getElementById('MainPageContent');
                    console.assert(mainPage != null);
                    mainPage.style.visibility = "visible";
                };
                //03-Sep-2012 OLIU Story b-04488 and Defect 220846 support cookie disable checking 
                /// <summary>
                ///     Display the "Cookies are currently disabled" page content.
                /// </summary>
                AppLogin.prototype.DisplayCookiesDisabledPageContent = function () {
                    var mainPage = document.getElementById('ErrorPageContent');
                    console.assert(mainPage != null);
                    mainPage.children['_ErrorPageHeading'].textContent = VPAdmin.ResourceBinder.getCookiesDisabledPageHeading();
                    mainPage.children['_ErrorPageMessage'].textContent = VPAdmin.ResourceBinder.getCookiesDisabledPageContents();
                    mainPage.style.visibility = "visible";
                };
                AppLogin.loginApp = null;
                return AppLogin;
            }());
            VPAdmin.AppLogin = AppLogin;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
/// <reference path="../../helpers/helpers.ts" />
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var ConnectionHelper = /** @class */ (function () {
                function ConnectionHelper(userName, userHost) {
                    this.m_Client = null;
                    this.m_ClientIdentifier = null;
                    this.m_soapHeader = null;
                    this.WebProtocol = window.location.protocol;
                    this.m_ClientIdentifier = ViewPoint.Client.VPAdmin.ConnectionHelper.GetClientIdentifier(userName, userHost);
                    console.assert(this.m_ClientIdentifier != null);
                    var host = window.location.protocol + "//" + window.location.host;
                    var href = window.location.href.indexOf("#/") > 0 ? window.location.href.substr(0, window.location.href.indexOf("#/")) : window.location.href;
                    var pathParts = href.split("/");
                    var vDir = "";
                    for (var pathPartIdx = 3; pathPartIdx < pathParts.length - 2; pathPartIdx++) {
                        vDir += pathParts[pathPartIdx] + "/";
                    }
                    this.m_svcAddress = helpers.Format("{0}/{1}VPAdminServer/Service.asmx", host, vDir ? vDir : "FTVP/");
                }
                ConnectionHelper.GetInstance = function (userName, userHost) {
                    if (ViewPoint.Client.VPAdmin.ConnectionHelper.m_Instance == null) {
                        ViewPoint.Client.VPAdmin.ConnectionHelper.CreateInstance(userName, userHost);
                    }
                    return ViewPoint.Client.VPAdmin.ConnectionHelper.m_Instance;
                };
                ConnectionHelper.CreateInstance = function (userName, hostName) {
                    if (ViewPoint.Client.VPAdmin.ConnectionHelper.m_Instance == null) {
                        ViewPoint.Client.VPAdmin.ConnectionHelper.m_Instance = new ViewPoint.Client.VPAdmin.ConnectionHelper(userName, hostName);
                    }
                };
                ConnectionHelper.GetClientIdentifier = function (userName, userHost) {
                    console.assert(!ViewPoint.Client.VPAdmin.ConnectionHelper.UniqueClientIdentifier);
                    var clientIdentifier = new utils.dictionary();
                    clientIdentifier.setItem("UniqueClientIdentifier", ViewPoint.Client.VPAdmin.ConnectionHelper.UniqueClientIdentifier);
                    clientIdentifier.setItem("UserName", userName);
                    clientIdentifier.setItem("UserHost", userHost);
                    return clientIdentifier;
                };
                return ConnectionHelper;
            }());
            VPAdmin.ConnectionHelper = ConnectionHelper;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var SecuredAdministrationControl = /** @class */ (function () {
                function SecuredAdministrationControl() {
                    this.m_UserManager = new ViewPoint.Client.VPAdmin.UserListManager();
                    this.m_GroupsAndUsersManager = new ViewPoint.Client.VPAdmin.UserAndGroupsManager();
                    this.m_Scope = null;
                }
                /// <summary>
                ///  Standard Loaded Handler. 
                ///  get the security settings and reset the gate so this method isn't called every time the user
                ///  switches tabs
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredAdministrationControl.prototype.SecuredAdministrationControl_Loaded = function () {
                    // Only load it once
                    this.GetSecuritySettings();
                };
                /// <summary>
                /// This call makes the web service method to the server to get the security settings
                /// </summary>
                SecuredAdministrationControl.prototype.GetSecuritySettings = function () {
                    // Disable control until settings have been retrieved
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    $('body').css("cursor", "wait");
                    // Not dirty
                    document.getElementById("btnSave").disabled = true;
                    document.getElementById("btnDiscard").disabled = true;
                    this.btnSaveState = true;
                    this.btnDiscardState = true;
                    try {
                        this.m_Scope = myApp.CurrentFTDScope;
                    }
                    catch (_) {
                    }
                    // NOTE: Scope is not used when retrieving the Admin security
                    this.Services.GetAdminSecuritySetting(this, this.GetAdminSecuritySettingCompleted, myApp.GetConnectionHelper().m_ClientIdentifier, this.m_Scope);
                };
                /// <summary>
                ///  Get th two global security settings via one Web Service API, then 
                ///  make a call to another Web service API for Users and Groups
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredAdministrationControl.prototype.GetAdminSecuritySettingCompleted = function (sender, e) {
                    // Check several error modalities
                    // Parse response from webservice
                    if (e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        // Check the authorization check boxes
                        document.getElementById("cbAdminAuthRequired").checked = e.getcurrentSecuritySettings();
                        ViewPoint.Client.VPAdmin.Security.GetSecurityClass().keepAdminAuthRequired = e.getcurrentSecuritySettings();
                    }
                    else if (e.geterrorMessage()) {
                        helpers.showErrorMessage(e.geterrorMessage());
                    }
                    else {
                        helpers.showErrorMessage(ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode[e.getResult()]);
                    }
                    this.GetSecurityUsersAndGroupsSettings();
                };
                /// <summary>
                /// Get the users and groups list from the server so we can show in tree
                /// </summary>
                SecuredAdministrationControl.prototype.GetSecurityUsersAndGroupsSettings = function () {
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    console.assert(myApp != null);
                    this.Services.GetSecurityUsersAndGroups(this, this.GetSecurityUsersAndGroupsCompleted, myApp.GetConnectionHelper().m_ClientIdentifier, this.m_Scope);
                };
                SecuredAdministrationControl.prototype.GetSecurityUsersAndGroupsCompleted = function (sender, e) {
                    var security = ViewPoint.Client.VPAdmin.Security.GetSecurityClass();
                    security.ctrlSecuredDisplays.GetUsersAndGroupsCompleted(sender, e);
                    // data bind: note user of hierarchical selectable templates in xaml
                    this.m_GroupsAndUsersManager.SetupUsersAndGroupsFromXml(e.getcurrentUsersAndGroups(), true);
                    this.$scope.usertree = this.m_GroupsAndUsersManager.GroupListCollection;
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    console.assert(myApp != null);
                    // Now make the call that gets the settings to apply to the groups
                    this.Services.GetFTVPAdminSecurity(this, this.GetFTVPAdminSecurity_Completed, myApp.GetConnectionHelper().m_ClientIdentifier, this.m_Scope);
                };
                /// <summary>
                /// setup the data for the treeview so that Groups that have security atrributes 
                /// for FTVP Admin will show up as checkbox checked in the treeview
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredAdministrationControl.prototype.GetFTVPAdminSecurity_Completed = function (sender, e) {
                    if (e.getError() == null && e.getAdminGroups().length > 0) {
                        var adminGroups = e.getAdminGroups();
                        for (var i = 0; i < adminGroups.length; i++) {
                            var strSetGroup = adminGroups[i].textContent.replace(/&amp;/g, '&');
                            var groups = this.m_GroupsAndUsersManager.GroupListCollection;
                            for (var j = 0; j < groups.length; j++) {
                                var group = groups[j];
                                if (helpers.Compare(strSetGroup, group.Name, true, true) == 0) {
                                    group.IsSelected = true;
                                }
                            }
                        }
                    }
                    // Set the data structure(s) to the treeview
                    this.$scope.usertree = this.m_GroupsAndUsersManager.GroupListCollection;
                    // retrieval is done, so enable control
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    $('body').css("cursor", "default");
                };
                /// <summary>
                ///  When the Apply Button is Clicked we need to send all the results to the server
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredAdministrationControl.prototype.btnSave_Click = function (sender, e) {
                    if (document.getElementById("cbAdminAuthRequired").checked) {
                        var atLeastOneGroup = false;
                        var atLeastOneUser = false;
                        var groupCount = 0;
                        var groups = this.m_GroupsAndUsersManager.GroupListCollection;
                        // First need to validate at least one group is checked
                        for (var i = 0; i < groups.length; i++) {
                            var group = groups[i];
                            if (group.IsSelected) {
                                atLeastOneGroup = true;
                                groupCount++;
                                // Now check to see if the group has at least one member
                                if (group.Members != null && group.Members.length > 0) {
                                    atLeastOneUser = true;
                                    break;
                                }
                            }
                        }
                        if (!atLeastOneGroup) {
                            // Don't allow user to save if a groupd isn't selected and security
                            VPAdmin.VPAdminUtil.ShowMessage("Select at least one user group to enable ViewPoint Administration Security.", ViewPoint.Client.Toolkit.Controls.MessageType.Warning, ViewPoint.Client.Toolkit.Controls.DialogBoxButtons.Ok);
                            return;
                        }
                        else if (!atLeastOneUser) {
                            var msg = groupCount > 1 ? "The selected user groups contain no users.  You must add a least one user to one of these groups within FactoryTalk View"
                                : "The selected user group contains no users.  You must add a user to this group within FactoryTalk View";
                            var box = VPAdmin.VPAdminUtil.ShowMessage("Warning! " + msg + " or select another group.\n\nDo you wish to continue?", ViewPoint.Client.Toolkit.Controls.MessageType.Question, ViewPoint.Client.Toolkit.Controls.DialogBoxButtons.YesNo);
                            box.OnDialogBoxYesButtonClicked.subscribe(function (sender, answer) {
                                if (answer == System.Windows.MessageBoxResult.Yes || answer == System.Windows.MessageBoxResult.OK) {
                                    this.SaveAdminSecurity();
                                }
                                else {
                                    return;
                                }
                            }, this);
                            return;
                        }
                    }
                    // We are good, so save security
                    this.SaveAdminSecurity();
                };
                /// <summary>
                ///  When the Discard Button is Clicked, reload the original settings
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredAdministrationControl.prototype.btnDiscard_Click = function (sender, e) {
                    this.GetSecuritySettings();
                    // Not dirty anymore so disable the buttons
                    document.getElementById("btnSave").disabled = true;
                    document.getElementById("btnDiscard").disabled = true;
                    this.btnSaveState = true;
                    this.btnDiscardState = true;
                };
                /// <summary>
                /// Save the admin security if validation is successful
                /// </summary>
                SecuredAdministrationControl.prototype.SaveAdminSecurity = function () {
                    // Not dirty anymore so disable the buttons
                    document.getElementById("btnSave").disabled = true;
                    document.getElementById("btnDiscard").disabled = true;
                    this.btnSaveState = true;
                    this.btnDiscardState = true;
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    this.Services.SetAdminSecuritySetting(this, this.SetAdminSecuritySettingCompleted, myApp.GetConnectionHelper().m_ClientIdentifier, this.m_Scope, document.getElementById("cbAdminAuthRequired").checked);
                };
                /// <summary>
                ///  Save some more data
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredAdministrationControl.prototype.SetAdminSecuritySettingCompleted = function (sender, e) {
                    var arrayGroups = null;
                    var groups = this.m_GroupsAndUsersManager.GroupListCollection;
                    // Okay let's iterate over our data and find out which groups are checked
                    // since we are 'two-way" databound to the treecontrol, our checkboxes
                    // are mapped to the isSelected property
                    for (var i = 0; i < groups.length; i++) {
                        var group = groups[i];
                        if (group.IsSelected) {
                            if (arrayGroups == null) {
                                // Lazy initialization - first time we need it we create it
                                arrayGroups = new Array();
                            }
                            arrayGroups.push(group.Name);
                        }
                    }
                    // Set/Save/Send the groups who have admin priveliges back to the server
                    // if there is something to save, save it
                    if (arrayGroups != null) {
                        var myApp = VPAdmin.Application.GetViewPointAdminApp();
                        console.assert(myApp != null);
                        this.Services.SetFTVPAdminSecurity(this, this.SetFTVPAdminSecurity_Completed, myApp.GetConnectionHelper().m_ClientIdentifier, this.m_Scope, arrayGroups);
                    }
                };
                /// <summary>
                /// Callback handler. Cannot do much here because silverlight databinding has taken over.
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredAdministrationControl.prototype.SetFTVPAdminSecurity_Completed = function (sender, e) {
                    // Perhaps we be doing something if the write didn't work?
                    if (e.getError() != null) {
                        helpers.showErrorMessage(e.getError().message);
                    }
                };
                /// <summary>
                /// Response to user clicks
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredAdministrationControl.prototype.cbAdminAuthRequired_Click = function (sender, e) {
                    document.getElementById("btnSave").disabled = false;
                    document.getElementById("btnDiscard").disabled = false;
                    this.btnSaveState = false;
                    this.btnDiscardState = false;
                };
                SecuredAdministrationControl.prototype.CheckBox_Clicked = function (sender, e) {
                    this.m_GroupsAndUsersManager.UpdateGroup(e);
                    document.getElementById("btnSave").disabled = false;
                    document.getElementById("btnDiscard").disabled = false;
                    this.btnSaveState = false;
                    this.btnDiscardState = false;
                };
                return SecuredAdministrationControl;
            }());
            VPAdmin.SecuredAdministrationControl = SecuredAdministrationControl;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Util;
    (function (Util) {
        var SecurityObjects;
        (function (SecurityObjects) {
            var PermissionType;
            (function (PermissionType) {
                PermissionType[PermissionType["Allow"] = 0] = "Allow";
                PermissionType[PermissionType["Deny"] = 1] = "Deny";
                PermissionType[PermissionType["NotDefined"] = 2] = "NotDefined";
            })(PermissionType = SecurityObjects.PermissionType || (SecurityObjects.PermissionType = {}));
            var PermissionName;
            (function (PermissionName) {
                PermissionName[PermissionName["ReadOnly"] = 0] = "ReadOnly";
                PermissionName[PermissionName["ReadWrite"] = 1] = "ReadWrite";
            })(PermissionName = SecurityObjects.PermissionName || (SecurityObjects.PermissionName = {}));
            /// <summary>
            ///  A permission is an atomic object in security. It describes what role, has what access (grant, deny) to what action (ReadOnly, ReadWrite)
            /// </summary>
            var Permission = /** @class */ (function () {
                function Permission() {
                    this._role = null;
                    this._action = null;
                    this._grant = null;
                }
                Object.defineProperty(Permission.prototype, "Role", {
                    get: function () {
                        return this._role;
                    },
                    set: function (value) {
                        this._role = value;
                        this.NotifyPropertyChanged("Role");
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Permission.prototype, "ActionString", {
                    get: function () {
                        switch (this.Action) {
                            case PermissionName.ReadOnly: return "ReadOnly";
                            case PermissionName.ReadWrite: return "ReadWrite";
                        }
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Permission.prototype, "Action", {
                    get: function () {
                        return this._action;
                    },
                    set: function (value) {
                        this._action = value;
                        this.NotifyPropertyChanged("Action");
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Permission.prototype, "GrantString", {
                    get: function () {
                        switch (this.Grant) {
                            case PermissionType.Allow: return "Allow";
                            case PermissionType.Deny: return "Deny";
                            case PermissionType.NotDefined: return "NotDefined";
                        }
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Permission.prototype, "Grant", {
                    get: function () {
                        return this._grant;
                    },
                    set: function (value) {
                        this._grant = value;
                        this.NotifyPropertyChanged("Grant");
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Permission.prototype, "ExplicitlySet", {
                    get: function () {
                        return this._explicitlySet;
                    },
                    set: function (value) {
                        this._explicitlySet = value;
                        this.NotifyPropertyChanged("ExplicitlySet");
                    },
                    enumerable: true,
                    configurable: true
                });
                Permission.prototype.NotifyPropertyChanged = function (name) {
                    if (this.PropertyChanged != null) {
                        this.PropertyChanged(this, name);
                    }
                };
                return Permission;
            }());
            SecurityObjects.Permission = Permission;
            var PermissionDuple = /** @class */ (function () {
                function PermissionDuple(role, readOnlyPermission, readWritePermission) {
                    this._ReadOnly = null;
                    this._ReadWrite = null;
                    this._role = null;
                    this._role = role;
                    this._ReadOnly = readOnlyPermission;
                    this._ReadWrite = readWritePermission;
                }
                Object.defineProperty(PermissionDuple.prototype, "ReadOnlyPermission", {
                    get: function () {
                        return this._ReadOnly;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(PermissionDuple.prototype, "ReadWritePermission", {
                    get: function () {
                        return this._ReadWrite;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(PermissionDuple.prototype, "Role", {
                    get: function () {
                        return this._role;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(PermissionDuple.prototype, "ReadWrite", {
                    get: function () {
                        if (this._ReadWrite.Grant == PermissionType.Allow) {
                            return true;
                        }
                        else if (this._ReadWrite.Grant == PermissionType.Deny) {
                            return false;
                        }
                        else {
                            return null;
                        }
                    },
                    set: function (value) {
                        if (value == true) {
                            this._ReadWrite.Grant = PermissionType.Allow;
                        }
                        else if (value == false) {
                            this._ReadWrite.Grant = PermissionType.Deny;
                        }
                        else {
                            this._ReadWrite.Grant = PermissionType.NotDefined;
                        }
                        this.NotifyPropertyChanged(PermissionName.ReadWrite.toString());
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(PermissionDuple.prototype, "ReadOnly", {
                    get: function () {
                        if (this._ReadOnly.Grant == PermissionType.Allow) {
                            return true;
                        }
                        else if (this._ReadOnly.Grant == PermissionType.Deny) {
                            return false;
                        }
                        else {
                            return null;
                        }
                    },
                    set: function (value) {
                        if (value == true) {
                            this._ReadOnly.Grant = PermissionType.Allow;
                        }
                        else if (value == false) {
                            this._ReadOnly.Grant = PermissionType.Deny;
                        }
                        else {
                            this._ReadOnly.Grant = PermissionType.NotDefined;
                        }
                        this.NotifyPropertyChanged(PermissionName.ReadOnly.toString());
                    },
                    enumerable: true,
                    configurable: true
                });
                PermissionDuple.prototype.NotifyPropertyChanged = function (name) {
                    if (this.PropertyChanged != null) {
                        this.PropertyChanged(this, name);
                    }
                };
                return PermissionDuple;
            }());
            SecurityObjects.PermissionDuple = PermissionDuple;
            var SecurityDupleList = /** @class */ (function () {
                function SecurityDupleList() {
                    this.dupleList = new Array();
                }
                Object.defineProperty(SecurityDupleList.prototype, "DupleList", {
                    get: function () {
                        return this.dupleList;
                    },
                    enumerable: true,
                    configurable: true
                });
                return SecurityDupleList;
            }());
            SecurityObjects.SecurityDupleList = SecurityDupleList;
            var SecurityACL = /** @class */ (function () {
                function SecurityACL() {
                    this.permissions = new Array();
                }
                Object.defineProperty(SecurityACL.prototype, "Permissions", {
                    /// <summary>
                    /// A List of Permissions
                    /// </summary>
                    get: function () {
                        return this.permissions;
                    },
                    enumerable: true,
                    configurable: true
                });
                return SecurityACL;
            }());
            SecurityObjects.SecurityACL = SecurityACL;
            var SecurityACLConverter = /** @class */ (function () {
                function SecurityACLConverter() {
                }
                // Convert a Security ACL to a SecurityDupleList
                SecurityACLConverter.ConvertACLToDupleList = function (theACL, allRoles) {
                    var dpl = new ViewPoint.Util.SecurityObjects.SecurityDupleList();
                    for (var i = 0; i < allRoles.length; i++) {
                        var strRole = allRoles[i];
                        var ro_pm = new ViewPoint.Util.SecurityObjects.Permission();
                        ro_pm.Role = strRole;
                        ro_pm.Action = PermissionName.ReadOnly;
                        ro_pm.Grant = PermissionType.NotDefined;
                        var rw_pm = new ViewPoint.Util.SecurityObjects.Permission();
                        rw_pm.Role = strRole;
                        rw_pm.Action = PermissionName.ReadOnly;
                        rw_pm.Grant = PermissionType.NotDefined;
                        var dp = new ViewPoint.Util.SecurityObjects.PermissionDuple(strRole, ro_pm, rw_pm);
                        dpl.DupleList.push(dp);
                    }
                    // Okay, now that the DupleList is built, we need to set certain fields in each duple
                    // depending on what is configured in our ACL
                    //
                    if (theACL) {
                        var permissions = theACL.Permissions;
                        // Yes this is a MxN loop, but M,N are usually pretty small (e.g. 5-10 each)
                        for (var i = 0; i < permissions.length; i++) {
                            var pm = permissions[i];
                            var duples = dpl.DupleList;
                            for (var j = 0; j < duples.length; j++) {
                                var dp = duples[j];
                                if (pm.Role == dp.Role) {
                                    if (pm.Action == PermissionName.ReadOnly) {
                                        dp.ReadOnlyPermission.Grant = pm.Grant;
                                        dp.ReadOnlyPermission.ExplicitlySet = pm.Grant != PermissionType.NotDefined;
                                    }
                                    else if (pm.Action == PermissionName.ReadWrite) {
                                        dp.ReadWritePermission.Grant = pm.Grant;
                                        dp.ReadWritePermission.ExplicitlySet = pm.Grant != PermissionType.NotDefined;
                                    }
                                }
                            }
                        }
                    }
                    return dpl;
                };
                // Convert a SecurityDupleList to a SecurityACL
                SecurityACLConverter.ConvertDupleToACL = function (theDupleList) {
                    var theACL = new ViewPoint.Util.SecurityObjects.SecurityACL();
                    var duples = theDupleList.DupleList;
                    for (var i = 0; i < duples.length; i++) {
                        var dp = duples[i];
                        var strRole = dp.Role;
                        if (dp.ReadOnlyPermission.Grant != PermissionType.NotDefined) {
                            var pm = new ViewPoint.Util.SecurityObjects.Permission();
                            pm.Role = strRole;
                            pm.Action = PermissionName.ReadOnly;
                            pm.Grant = dp.ReadOnlyPermission.Grant;
                            theACL.Permissions.push(pm);
                        }
                        if (dp.ReadWritePermission.Grant != PermissionType.NotDefined) {
                            var pm = new ViewPoint.Util.SecurityObjects.Permission();
                            pm.Role = strRole;
                            pm.Action = PermissionName.ReadWrite;
                            pm.Grant = dp.ReadWritePermission.Grant;
                            theACL.Permissions.push(pm);
                        }
                    }
                    return theACL;
                };
                // Encode a SecurityACL object into wire format
                SecurityACLConverter.ACLEncode = function (ACL) {
                    var strACL = "";
                    var permissions = ACL.Permissions;
                    for (var i = 0; i < permissions.length; i++) {
                        var pm = permissions[i];
                        var strACE = pm.Role + "|" + pm.GrantString + "|" + pm.ActionString;
                        strACL += strACE;
                        strACL += "#";
                    }
                    if (strACL) {
                        return ViewPoint.Util.SecurityObjects.SecurityACLConverter.UU_e(strACL);
                    }
                    else {
                        return null;
                    }
                };
                // decode the wire format of an ACL into a SecurityACL
                SecurityACLConverter.ACLDecode = function (wireACL) {
                    var ACL = new ViewPoint.Util.SecurityObjects.SecurityACL();
                    var strACL = ViewPoint.Util.SecurityObjects.SecurityACLConverter.UU_d(wireACL);
                    var strACEs = strACL.substr(0, strACL.length - 1).split("#");
                    for (var i = 0; i < strACEs.length; i++) {
                        var strACE = strACEs[i];
                        var pm = new ViewPoint.Util.SecurityObjects.Permission();
                        var strPm = strACE.split("|");
                        pm.Role = strPm[0];
                        var permissionType;
                        if ((function () {
                            var _tmp = ViewPoint.Util.SecurityObjects.SecurityACLConverter.TryParsePermissionType(strPm[1], permissionType);
                            permissionType = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(this)) {
                            pm.Grant = permissionType;
                            pm.ExplicitlySet = permissionType != PermissionType.NotDefined;
                        }
                        var permissionName;
                        if ((function () {
                            var _tmp = ViewPoint.Util.SecurityObjects.SecurityACLConverter.TryParsePermissionName(strPm[2], permissionName);
                            permissionName = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(this)) {
                            pm.Action = permissionName;
                        }
                        ACL.Permissions.push(pm);
                    }
                    return ACL;
                };
                SecurityACLConverter.TryParsePermissionType = function (permissionTypeValue, permissionType) {
                    permissionType = PermissionType.NotDefined;
                    if (!permissionTypeValue) {
                        return {
                            refs: [permissionType],
                            result: false
                        };
                    }
                    var values = ["Allow", PermissionType.Allow, "Deny", PermissionType.Deny, "NotDefined", PermissionType.NotDefined]; /*ViewPoint.Util.SecurityObjects.SecurityACLConverter.GetValues<PermissionType>();*/
                    for (var i = 0; i < values.length; i += 2) {
                        if (permissionTypeValue == values[i]) {
                            permissionType = values[i + 1];
                            return {
                                refs: [permissionType],
                                result: true
                            };
                        }
                    }
                    return {
                        refs: [permissionType],
                        result: false
                    };
                };
                SecurityACLConverter.TryParsePermissionName = function (permissionNameValue, permissionName) {
                    permissionName = PermissionName.ReadOnly;
                    if (!permissionNameValue) {
                        return {
                            refs: [permissionName],
                            result: false
                        };
                    }
                    var values = ["ReadOnly", PermissionName.ReadOnly, "ReadWrite", PermissionName.ReadWrite]; /*ViewPoint.Util.SecurityObjects.SecurityACLConverter.GetValues<PermissionName>();*/
                    for (var i = 0; i < values.length; i += 2) {
                        if (permissionNameValue == values[i]) {
                            permissionName = values[i + 1];
                            return {
                                refs: [permissionName],
                                result: true
                            };
                        }
                    }
                    return {
                        refs: [permissionName],
                        result: false
                    };
                };
                /* AIS_NOTE: unused function
                static GetValues<T>() {
                    var enumType = T;
                    var values = new Array();
                    var fields = JSLINQ(enumType.GetFields()).Where(function (field) {
                        return field.IsLiteral;
                    }).Select(function (field) {
                        return field;
                    });
                    var $it = fields.GetEnumerator();
                    while ( $it.MoveNext() ) {
                        var field = $it.getCurrent();
                        var value = field.GetValue(enumType);
                        values.push(value);
                    }
                    return values;
                }*/
                SecurityACLConverter.UU_d = function (s) {
                    var binaryStr = atob(s); //Warren fix DFCTS00366764
                    var cp = [];
                    for (var i = 0; i < binaryStr.length; i += 2) {
                        cp.push(binaryStr.charCodeAt(i) |
                            (binaryStr.charCodeAt(i + 1) << 8));
                    }
                    return decodeURIComponent(String.fromCharCode.apply(String, cp));
                };
                SecurityACLConverter.UU_e = function (s) {
                    var str = encodeURIComponent(s); //Warren fix DFCTS00366764
                    var cp = [];
                    for (var i = 0; i < str.length; i++) {
                        cp.push(str.charCodeAt(i));
                        cp.push(0);
                    }
                    var rawStr = String.fromCharCode.apply(String, cp);
                    return btoa(rawStr);
                };
                return SecurityACLConverter;
            }());
            SecurityObjects.SecurityACLConverter = SecurityACLConverter;
        })(SecurityObjects = Util.SecurityObjects || (Util.SecurityObjects = {}));
    })(Util = ViewPoint.Util || (ViewPoint.Util = {}));
})(ViewPoint || (ViewPoint = {}));
/// <reference path="../../../common/util/securityaclconverter.ts" />
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var SecuredDisplaysControl = /** @class */ (function () {
                function SecuredDisplaysControl() {
                    this.m_mgr = null;
                    this.m_Scope = null;
                    this.m_FTViewApplication = null;
                    this.m_SelectedStartupMacro = null;
                    this.m_strFTDApplication = null;
                    this.m_ParentLookup = new utils.dictionary();
                    this.m_bViewEffectivePermissionsMode = false;
                    this.m_currentChanges = false;
                    this.m_bFreeze = false;
                    this.m_bRuntimeDefaultTagWriteEnable = false;
                    this.m_SelectedDirectoryItem = null;
                    this.bfirstRecursion = false;
                }
                SecuredDisplaysControl.prototype.cbWriteEnable_Click = function (clicked) {
                    this.m_bRuntimeDefaultTagWriteEnable = document.getElementById("cbWriteEnable").checked;
                    if (clicked) {
                        document.getElementById("btnSave").disabled = false;
                        document.getElementById("btnDiscard").disabled = false;
                    }
                    this.btnSaveState = false;
                    this.btnDiscardState = false;
                };
                SecuredDisplaysControl.prototype.cbAllAuthRequired_Click = function (sender, e) {
                    document.getElementById("btnSave").disabled = false;
                    document.getElementById("btnDiscard").disabled = false;
                    this.btnSaveState = false;
                    this.btnDiscardState = false;
                    document.getElementById("gridPermissionList").disabled = !document.getElementById("cbAllAuthRequired").checked;
                    document.getElementById("gridPermissionList").style.visibility = document.getElementById("gridPermissionList").disabled ? "collapse" : "visible";
                    document.getElementById("permissionPanel").style.display = document.getElementById("gridPermissionList").disabled ? "none" : "block";
                    document.getElementById("permissionPanel").style.visibility = document.getElementById("gridPermissionList").style.visibility;
                    document.getElementById("DefaultSecurity").style.display = (document.getElementById("cbAllAuthRequired").checked) ? "none" : "block";
                    this.RefreshAuthRequired();
                };
                SecuredDisplaysControl.prototype.RefreshAuthRequired = function () {
                    if (document.getElementById("chkViewEffectivePermissions").checked) {
                        document.getElementById("InheritedColumn").style.visibility = "visible";
                    }
                    else {
                        document.getElementById("NormalColumn").style.visibility = "visible";
                    } //chkViewEffectivePermissions
                    if (document.getElementById("DefaultSecurity").style.display == "block") {
                        document.getElementById("InheritedColumn").style.visibility = "collapse";
                        document.getElementById("NormalColumn").style.visibility = "collapse";
                    }
                    if (document.getElementById("permissionPanel").style.visibility === 'visible') {
                        document.getElementById("permissionPanel").style.display = 'block';
                    }
                    else {
                        document.getElementById("permissionPanel").style.display = 'none';
                    }
                };
                /// <summary>
                /// Standard Loaded Handler
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.SecuredDisplaysControl_Loaded = function () {
                    // At first there's nothing to save, and nothing to discard - have 
                    // to wait till something changes
                    document.getElementById("btnSave").disabled = true;
                    document.getElementById("btnDiscard").disabled = true;
                    this.btnSaveState = true;
                    this.btnDiscardState = true;
                    this.GetSecuritySettings();
                };
                /// <summary>
                /// This call makes the web service method to the server to get the security settings
                /// </summary>
                SecuredDisplaysControl.prototype.GetSecuritySettings = function () {
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    try {
                        this.m_Scope = myApp.CurrentFTDScope;
                    }
                    catch (_) {
                    }
                    this.Services.GetRuntimeSecuritySettings(this, this.GetRuntimeSecuritySettingsCompleted, myApp.GetConnectionHelper().m_ClientIdentifier, this.m_Scope);
                };
                /// <summary>
                ///  Get the global security settings via one Web Service API
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.GetRuntimeSecuritySettingsCompleted = function (sender, e) {
                    document.getElementById("NotSetLegend").indeterminate = true;
                    // Check several error modalities
                    // Parse response from webservice
                    if (e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        // Set the checkboxes that depict if Security is on or off for Admins, Viewers
                        document.getElementById("cbAllAuthRequired").checked = e.getcurrentRuntimeSecurityEnabled();
                        ViewPoint.Client.VPAdmin.Security.GetSecurityClass().keepAuthRequired = e.getcurrentRuntimeSecurityEnabled();
                        document.getElementById("cbWriteEnable").checked = e.getcurrentRuntimeDefaultTagWriteEnable();
                        ViewPoint.Client.VPAdmin.Security.GetSecurityClass().keepEnableWriteRequired = e.getcurrentRuntimeDefaultTagWriteEnable();
                        document.getElementById("gridPermissionList").disabled = !document.getElementById("cbAllAuthRequired").checked;
                        document.getElementById("gridPermissionList").style.visibility = document.getElementById("gridPermissionList").disabled ? "collapse" : "visible";
                        document.getElementById("permissionPanel").style.visibility = document.getElementById("gridPermissionList").style.visibility;
                        document.getElementById("DefaultSecurity").style.display = (document.getElementById("cbAllAuthRequired").checked) ? "none" : "block";
                        this.RefreshAuthRequired();
                    }
                };
                /// <summary>
                /// Used in View Effective permissions Features
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.chkViewEffectivePermissions_Unchecked = function (sender, e) {
                    document.getElementById("gridPermissionList").disabled = false;
                    this.m_bViewEffectivePermissionsMode = false;
                    this.btnDiscardState = this.btnSaveState = document.getElementById("btnSave").disabled = document.getElementById("btnDiscard").disabled = !this.m_currentChanges;
                    // hide inherited legend
                    document.getElementById("InheritedColumn").style.visibility = "collapse";
                    document.getElementById("NormalColumn").style.visibility = "visible";
                    this.BuildPermissionsGridView(this.m_SelectedDirectoryItem);
                };
                /// <summary>
                /// Used in View Effective permissions Features
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.chkViewEffectivePermissions_Checked = function (sender, e) {
                    document.getElementById("gridPermissionList").disabled = true;
                    this.m_bViewEffectivePermissionsMode = true;
                    this.m_currentChanges = !document.getElementById("btnSave").disabled;
                    document.getElementById("btnDiscard").disabled = true;
                    document.getElementById("btnSave").disabled = true;
                    this.btnSaveState = true;
                    this.btnDiscardState = true;
                    // show inherited legend
                    document.getElementById("NormalColumn").style.visibility = "collapse";
                    document.getElementById("InheritedColumn").style.visibility = "visible";
                    this.BuildPermissionsGridView(this.m_SelectedDirectoryItem);
                };
                /// <summary>
                /// This is a public call that can (and is) called by other parts of this codebase
                /// to allow the currently selected application to be changed
                /// </summary>
                /// <param name="scope"></param>
                /// <param name="strApplication"></param>
                SecuredDisplaysControl.prototype.SetCurrentApplication = function (scope, strApplication) {
                    this.m_Scope = scope;
                    this.m_strFTDApplication = strApplication;
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    this.Services.GetSecuredApplication(this, this.GetSecuredApplicationCompleted, myApp.GetConnectionHelper().m_ClientIdentifier, scope, strApplication);
                };
                /// <summary>
                /// Call back function when getting the displays (via the webservice) is finished
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.GetSecuredApplicationCompleted = function (sender, e) {
                    try {
                        document.getElementById("tbItemName").textContent = "";
                    }
                    catch (e) { }
                    // We do alot of up-front error checking before
                    // we get down to business
                    try {
                        if (e.getCancelled()) {
                            var msg = VPAdmin.VPAdminUtil.GetString("helpCancelMsg");
                            msg = helpers.Format(msg, "GetSecuredApplicationService");
                            helpers.showErrorMessage(msg);
                            return;
                        }
                        if (e.getError() != null) {
                            var msg = VPAdmin.VPAdminUtil.GetString("helpErrorMsg");
                            msg = helpers.Format(msg, "GetDisplaysService");
                            var sb = new String(msg);
                            sb.concat(e.getError().message);
                            sb.concat(e.getError().getStackTrace());
                            helpers.showErrorMessage(sb.toString());
                            return;
                        }
                        if (e.getResult() != ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                            if (e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.NoManifestForApplication) {
                                document.getElementById("gridErrorInfo").style.display = "block";
                                document.getElementById("gridLoaded").style.display = "none";
                            }
                            else {
                                if (e.geterrorMessage()) {
                                    helpers.showErrorMessage(e.geterrorMessage());
                                }
                                else {
                                    helpers.showErrorMessage(ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode[e.getResult()]);
                                }
                            }
                            return;
                        }
                        // Success, so hide if necessary
                        // Set the ftViewApplication for this session with the UI
                        this.m_FTViewApplication = e.getftViewApplicationDOM();
                        this.m_SelectedStartupMacro = e.getselectedStartupMacro();
                        this.$scope.securedDisplayTree = e.getftViewApplication()[0];
                        try {
                            this.m_bFreeze = true;
                            this.SetupInitialSelectedNode(this.$scope.securedDisplayTree.Name, this.$scope.securedDisplayTree.FullXMLPath);
                            this.m_bFreeze = false;
                        }
                        catch (_) {
                        }
                    }
                    catch (e) {
                    }
                    // Take away the old event handler  and add a new one.
                };
                /// <summary>
                /// Reload the Secured Displays Page if the User has just done a publish
                /// The user might have changed the list of displays , and we can pick that up right
                /// now by reloading from the manifest via the web service call.
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.myApp_OnPublishComplete = function (sender, e) {
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    this.Services.GetSecuredApplication(this, this.GetSecuredApplicationCompleted, myApp.GetConnectionHelper().m_ClientIdentifier, this.m_Scope ? this.m_Scope : myApp.CurrentFTDScope, this.m_strFTDApplication ? this.m_strFTDApplication : myApp.CurrentFTDApplication);
                };
                /// <summary>
                /// This function enables the root node as the initial selected node 
                /// when the tree is first drawn
                /// </summary>
                /// <param name="appNode"></param>
                SecuredDisplaysControl.prototype.SetupInitialSelectedNode = function (treeNodeName, treeNodeFullName) {
                    /*TODO treeNode.setIsSelected(true);*/
                    this.$scope.permissionGrid = new Array();
                    var selname = treeNodeFullName;
                    var itemName = document.getElementById("tbItemName");
                    if (itemName)
                        itemName.textContent = treeNodeName;
                    var deObj = this.m_FTViewApplication.find("FullXMLPath:contains('" + selname + "')").filter(function () { return $(this).text() == selname; }).parent();
                    if (deObj.length) {
                        this.m_SelectedDirectoryItem = deObj;
                        this.BuildPermissionsGridView(deObj);
                    }
                };
                /// <summary>
                /// In order to draw the Permissions Grid View, We need the names of the Groups, So we have 
                /// this callback handler, from a webservice call issued ealier (was subscribed in our constructor)
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.GetUsersAndGroupsCompleted = function (sender, e) {
                    if (e.getCancelled()) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpCancelMsg");
                        msg = helpers.Format(msg, "GetSecuredApplicationService");
                        helpers.showErrorMessage(msg);
                        return;
                    }
                    if (e.getError() != null) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpErrorMsg");
                        msg = helpers.Format(msg, "GetDisplaysService");
                        var sb = new String(msg);
                        sb.concat(e.getError().message);
                        sb.concat(e.getError().getStackTrace());
                        helpers.showErrorMessage(sb.toString());
                        return;
                    }
                    if (e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        this.m_mgr = new ViewPoint.Client.VPAdmin.UserAndGroupsManager();
                        this.m_mgr.SetupUsersAndGroupsFromXml(e.getcurrentUsersAndGroups(), true);
                        try {
                            // If the tree hasn't been set yet, just ignore
                            if (this.$scope != null && this.$scope.securedDisplayTree) {
                                this.m_bFreeze = true;
                                this.SetupInitialSelectedNode(this.$scope.securedDisplayTree.Name, this.$scope.securedDisplayTree.FullXMLPath);
                                this.m_bFreeze = false;
                            }
                        }
                        catch (ex) {
                            helpers.showErrorMessage(ex.message);
                        }
                    }
                };
                /// <summary>
                ///  When selections in the treeview change, we need to redraw what is shown in the 
                ///  Permissions Grid. It's a bit of a model view controller.
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.treeApp_SelectedItemChanged = function (sender, e, item) {
                    // Don't handle if Freeze is true
                    if (this.m_bFreeze)
                        return;
                    //
                    // Need to deal with the NewValue (newly selected treeitem)
                    // since the security permisions might have chenged for the prior value
                    // and we need to stuff it away in the tag object
                    if (e != null) {
                        // Clear out the content of the datagrid
                        this.$scope.permissionGrid = new Array();
                        var selname = e;
                        document.getElementById("tbItemName").textContent = selname;
                        var deNewObj = this.m_FTViewApplication.find("FullXMLPath:contains('" + item.dataset.xml + "')").filter(function () { return $(this).text() == item.dataset.xml; }).parent();
                        this.m_SelectedDirectoryItem = deNewObj;
                        // Now Draw our UI Permsisions Grid
                        this.BuildPermissionsGridView(deNewObj);
                        $('.selecteditem').removeClass('selecteditem');
                        item.classList.add('selecteditem');
                    }
                    else {
                        this.m_SelectedDirectoryItem = null;
                    }
                };
                /// <summary>
                /// Builds the permissions gridview based on the selected DirectoryElement 
                /// (e.g. Display, Area, Application)
                /// 
                /// </summary>
                /// <param name="deNewObj"></param>
                SecuredDisplaysControl.prototype.BuildPermissionsGridView = function (deObj) {
                    if (deObj.length) {
                        try {
                            var ACL = null;
                            var strWireACL = deObj.children("WireACL").text();
                            if (strWireACL) {
                                ACL = ViewPoint.Util.SecurityObjects.SecurityACLConverter.ACLDecode(strWireACL);
                            }
                            if (this.m_mgr != null) {
                                if (this.m_bViewEffectivePermissionsMode) {
                                    var dpl = this.GenerateEffectiveDupleList(deObj);
                                    this.$scope.permissionGrid = dpl.DupleList;
                                }
                                else {
                                    var dpl = ViewPoint.Util.SecurityObjects.SecurityACLConverter.ConvertACLToDupleList(ACL, this.m_mgr.GroupListString);
                                    this.$scope.permissionGrid = dpl.DupleList;
                                }
                            }
                        }
                        catch (_) {
                        }
                    }
                };
                /// <summary>
                /// Builds the permissions gridview based on the selected DirectoryElement ,
                /// But if the Permissions in a the DupleList are empty (e.g. NotSet) for any 
                /// Item, we will walk up the Hierarchy looking for effective inherited permissions
                /// (e.g. Display, Area, Application)
                /// 
                /// </summary>
                /// <param name="deNewObj"></param>
                SecuredDisplaysControl.prototype.GenerateEffectiveDupleList = function (deObj) {
                    if (deObj.length) {
                        try {
                            var ACL = null;
                            var strWireACL = deObj.children("WireACL").text();
                            if (strWireACL) {
                                ACL = ViewPoint.Util.SecurityObjects.SecurityACLConverter.ACLDecode(strWireACL);
                            }
                            if (this.m_mgr != null) {
                                var dplist = ViewPoint.Util.SecurityObjects.SecurityACLConverter.ConvertACLToDupleList(ACL, this.m_mgr.GroupListString);
                                var duples = dplist.DupleList;
                                // Okay, we have the explicit permissions for this deObject
                                // now we have to walk through this list looking for "NOTSET" permissions.
                                // If we find any, then we will run up DeObj parent tree looking for parent ACLs that might possess
                                // Effective or Explicit permissions. 
                                for (var i = 0; i < duples.length; i++) {
                                    var dpl = duples[i];
                                    if (dpl.ReadOnlyPermission.Grant == ViewPoint.Util.SecurityObjects.PermissionType.NotDefined) {
                                        var pm = this.FindInheritedPermission(deObj, ViewPoint.Util.SecurityObjects.PermissionName.ReadOnly, dpl.ReadOnlyPermission.Role);
                                        // Assign the inherited permission
                                        if (pm)
                                            dpl.ReadOnlyPermission.Grant = pm.Grant;
                                    }
                                    if (dpl.ReadWritePermission.Grant == ViewPoint.Util.SecurityObjects.PermissionType.NotDefined) {
                                        var pm = this.FindInheritedPermission(deObj, ViewPoint.Util.SecurityObjects.PermissionName.ReadWrite, dpl.ReadWritePermission.Role);
                                        // Assign the inherited permission
                                        if (pm)
                                            dpl.ReadWritePermission.Grant = pm.Grant;
                                    }
                                }
                                return dplist;
                            }
                        }
                        catch (_) {
                        }
                    }
                    return null;
                };
                /// <summary>
                /// This algorithm walks up the tree looking for explicity permissions, once an explcit permission is found,
                /// it becomes the effective permission for the item (deObj).
                /// </summary>
                /// <param name="deObj"></param>
                /// <param name="permissionName"></param>
                /// <param name="strRoleName"></param>
                /// <returns></returns>
                SecuredDisplaysControl.prototype.FindInheritedPermission = function (deObj, permissionName, strRoleName) {
                    var parent;
                    var bSuccess;
                    if (deObj.parent().children("ftViewApplication").length) {
                        parent = null;
                        bSuccess = deObj.children("FullXMLPath").text();
                    }
                    else {
                        parent = deObj.parent();
                        bSuccess = deObj.parent().children("FullXMLPath").text();
                    }
                    if (bSuccess != "") {
                        if (parent == null) {
                            var pm = new ViewPoint.Util.SecurityObjects.Permission();
                            pm.Role = strRoleName;
                            pm.Grant = ViewPoint.Util.SecurityObjects.PermissionType.Deny;
                            pm.Action = permissionName;
                            return pm;
                        }
                        else {
                            try {
                                var ACL = null;
                                var strWireACL = $(parent).children("WireACL").text();
                                if (strWireACL) {
                                    ACL = ViewPoint.Util.SecurityObjects.SecurityACLConverter.ACLDecode(strWireACL);
                                }
                                if (this.m_mgr != null) {
                                    var dplist = ViewPoint.Util.SecurityObjects.SecurityACLConverter.ConvertACLToDupleList(ACL, this.m_mgr.GroupListString);
                                    var duples = dplist.DupleList;
                                    // Okay, we have the explicit permissions for this deObject
                                    // now we have to walk through this list looking for "NOTSET" permissions.
                                    // If we find any, then we will run up DeObj parent tree looking for parent ACLs that might possess
                                    // Effective or Explicit permissions. 
                                    for (var i = 0; i < duples.length; i++) {
                                        var dpl = duples[i];
                                        if (dpl.Role == strRoleName) {
                                            if (permissionName == ViewPoint.Util.SecurityObjects.PermissionName.ReadOnly) {
                                                if (dpl.ReadOnlyPermission.Grant == ViewPoint.Util.SecurityObjects.PermissionType.Allow || dpl.ReadOnlyPermission.Grant == ViewPoint.Util.SecurityObjects.PermissionType.Deny) {
                                                    return dpl.ReadOnlyPermission;
                                                }
                                                else if (dpl.ReadOnlyPermission.Grant == ViewPoint.Util.SecurityObjects.PermissionType.NotDefined) {
                                                    return this.FindInheritedPermission(parent, ViewPoint.Util.SecurityObjects.PermissionName.ReadOnly, dpl.ReadOnlyPermission.Role);
                                                }
                                            }
                                            else if (permissionName == ViewPoint.Util.SecurityObjects.PermissionName.ReadWrite) {
                                                if (dpl.ReadWritePermission.Grant == ViewPoint.Util.SecurityObjects.PermissionType.Allow || dpl.ReadWritePermission.Grant == ViewPoint.Util.SecurityObjects.PermissionType.Deny) {
                                                    return dpl.ReadWritePermission;
                                                }
                                                else if (dpl.ReadWritePermission.Grant == ViewPoint.Util.SecurityObjects.PermissionType.NotDefined) {
                                                    return this.FindInheritedPermission(parent, ViewPoint.Util.SecurityObjects.PermissionName.ReadWrite, dpl.ReadWritePermission.Role);
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            catch (_) {
                            }
                            return null;
                        }
                    }
                    return this.FindInheritedPermission(parent, permissionName, strRoleName);
                };
                /// <summary>
                ///  Whenever a selection is changed in the Persmissions GridView, we want to setup 
                ///  some change handlers on the "PermissionDuple" associated with the selected item. 
                ///  
                ///  This is so we can make some rules about when one permission changes, will it have an effect
                ///  on the other permsiion
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.gridPermissionList_SelectionChanged = function (sender, propertyName, check) {
                    // As long as we are not in View Effective Permissions Mode, set up event handlers for the items
                    //
                    if (!this.m_bViewEffectivePermissionsMode) {
                        var dp = null;
                        var duples = this.$scope.permissionGrid;
                        for (var i = 0; i < duples.length; i++) {
                            var duple = duples[i];
                            if (helpers.Compare(sender, duple._role, true, true) == 0) {
                                dp = duple;
                                break;
                            }
                        }
                        if (dp != null) {
                            if (propertyName == "ReadWrite")
                                dp.ReadWrite = check;
                            else
                                dp.ReadOnly = check;
                            this.dp_PropertyChanged(dp, propertyName);
                        }
                    }
                };
                /// <summary>
                /// Change Handler - ensures that certain rules about what is checked
                /// are abided by. If View is denied then so should write, if Write is allow
                /// then so should View
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.dp_PropertyChanged = function (sender, PropertyName) {
                    if (this.m_bViewEffectivePermissionsMode) {
                        return;
                    }
                    /// Whooo something changed
                    document.getElementById("btnSave").disabled = false;
                    document.getElementById("btnDiscard").disabled = false;
                    this.btnSaveState = false;
                    this.btnDiscardState = false;
                    var dp = sender;
                    if (PropertyName == "ReadWrite") {
                        // if the ReadWrite Permission Changed, make sure the ReadOnly is compatible
                        if (dp.ReadWrite == true) {
                            dp.ReadOnly = true;
                        }
                    }
                    else if (PropertyName == "ReadOnly") {
                        // if the ReadOnly Permission Changed, make sure the ReadWrite is compatible
                        if (dp.ReadOnly == false) {
                            dp.ReadWrite = false;
                        }
                        else if (dp.ReadOnly == null) {
                            // If readonly is not set, readwrite should also be notset
                            dp.ReadWrite = null;
                        }
                    }
                    var strWireACL = this.CreateWireACLFromPermissionList();
                    if (this.m_SelectedDirectoryItem != null) {
                        var wireACL = this.m_SelectedDirectoryItem.children("WireACL");
                        if (!wireACL.length) {
                            var wireACLNode = document.createElementNS("http://tempuri.org/", "WireACL");
                            wireACLNode.textContent = strWireACL;
                            this.m_SelectedDirectoryItem[0].appendChild(wireACLNode);
                        }
                        else if (strWireACL) {
                            wireACL.text(strWireACL);
                        }
                        else {
                            this.m_SelectedDirectoryItem[0].removeChild(wireACL[0]);
                        }
                    }
                };
                /// <summary>
                ///  Take the list of Permission in the gridview and make a wireACL from 
                ///  it.
                /// </summary>
                /// <returns></returns>
                SecuredDisplaysControl.prototype.CreateWireACLFromPermissionList = function () {
                    var sdpl = new ViewPoint.Util.SecurityObjects.SecurityDupleList();
                    var duples = this.$scope.permissionGrid;
                    // For the current permissions list being shown
                    for (var i = 0; i < duples.length; i++) {
                        var pd = duples[i];
                        sdpl.DupleList.push(pd);
                    }
                    var ACL = ViewPoint.Util.SecurityObjects.SecurityACLConverter.ConvertDupleToACL(sdpl);
                    var strWireACL = ViewPoint.Util.SecurityObjects.SecurityACLConverter.ACLEncode(ACL);
                    return strWireACL;
                };
                /// <summary>
                /// Response to click on the Save button
                ///  Saves any Changes away to the Server
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.butSaveIt_Click = function (sender, e) {
                    // Set these buttons back to disabled, because we are clean again
                    document.getElementById("btnDiscard").disabled = true;
                    document.getElementById("btnSave").disabled = true;
                    this.btnSaveState = true;
                    this.btnDiscardState = true;
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    this.Services.SetRuntimeSecuritySettings(this, this.SetRuntimeSecuritySettingCompleted, myApp.GetConnectionHelper().m_ClientIdentifier, this.m_Scope, document.getElementById("cbAllAuthRequired").checked, this.m_bRuntimeDefaultTagWriteEnable);
                };
                /// <summary>
                /// Response to click on the Discard button
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.butDiscardIt_Click = function (sender, e) {
                    this.GetSecuritySettings();
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    this.Services.GetSecuredApplication(this, this.GetSecuredApplicationCompleted, myApp.GetConnectionHelper().m_ClientIdentifier, this.m_Scope, this.m_strFTDApplication);
                    // Set these buttons back to disabled, because we are clean again
                    document.getElementById("btnDiscard").disabled = true;
                    document.getElementById("btnSave").disabled = true;
                    this.btnSaveState = true;
                    this.btnDiscardState = true;
                    document.getElementById("DefaultSecurity").style.display = 'block';
                    document.getElementById("DefaultSecurity").style.position = 'absolute';
                    document.getElementById("DefaultSecurity").style.top = '30%';
                    document.getElementById("cbAllAuthRequired").checked = true;
                };
                /// <summary>
                ///  Save some more data
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.SetRuntimeSecuritySettingCompleted = function (sender, e) {
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    this.Services.SetSecuredApplication(this, this.SetSecuredApplicationCompleted, myApp.GetConnectionHelper().m_ClientIdentifier, this.m_Scope, this.m_strFTDApplication, this.m_FTViewApplication, this.m_SelectedStartupMacro);
                };
                /// <summary>
                /// Completed Handler for Saving security
                /// to the ViewPoint Server
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SecuredDisplaysControl.prototype.SetSecuredApplicationCompleted = function (sender, e) {
                    if (e.getError() == null) {
                    }
                };
                return SecuredDisplaysControl;
            }());
            VPAdmin.SecuredDisplaysControl = SecuredDisplaysControl;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var Activation = /** @class */ (function () {
                function Activation() {
                    this.mLastActivationInfo = null;
                    Activation.helpUrl = VPAdmin.VPAdminUtil.CreateHelpLink(VPAdmin.VPAdminUtil.GetString("lpActivationLearn_url"));
                }
                Activation.GetActivationClass = function () {
                    if (Activation.activationClass == null) {
                        Activation.activationClass = new Activation();
                    }
                    document.getElementById('lpActivationLearn').href = Activation.helpUrl;
                    return Activation.activationClass;
                };
                Activation.prototype.Activation_Loaded = function (Services) {
                    document.getElementById('applyButton').disabled = true;
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    console.assert(myApp != null);
                    $('body').css("cursor", "wait");
                    Services.GetActivationInfo(this, this.GetActivationInfoCompleted, myApp.GetConnectionHelper().m_ClientIdentifier, true);
                };
                /// <summary>
                /// Handler function after calling AppplyActivation.
                /// It will do some error checking and call AssignActivatioInfo() to assign value to fields on screen.
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                Activation.prototype.ApplyActivationCompleted = function (sender, e) {
                    $('body').css("cursor", "default");
                    if (e.getCancelled()) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpCancelMsg");
                        msg = helpers.Format(msg, "ApplyActivationService");
                        helpers.showErrorMessage(msg);
                        return;
                    }
                    if (e.getError() != null) {
                        helpers.showErrorMessage(e.getError().message);
                        return;
                    }
                    if (e.getResult() != ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        $('body').css("cursor", "default");
                        if (e.geterrorMessage()) {
                            helpers.showErrorMessage(e.geterrorMessage());
                        }
                        else {
                            helpers.showErrorMessage(ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode[e.getResult()]);
                        }
                    }
                    else {
                        this.AssignActivatioInfo(e.getactivationInfo(), true);
                    }
                };
                /// <summary>
                /// Handler function after calling GetActivationInfo
                /// It will do some error checking and call AssignActivatioInfo() to assign value to fields on screen
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                Activation.prototype.GetActivationInfoCompleted = function (sender, e) {
                    $('body').css("cursor", "default");
                    if (e.getCancelled()) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpCancelMsg");
                        msg = helpers.Format(msg, "GetActivationInfoService");
                        helpers.showErrorMessage(msg);
                        return;
                    }
                    if (e.getError() != null) {
                        helpers.showErrorMessage(e.getError().message);
                        return;
                    }
                    if (e.getResult() != ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        $('body').css("cursor", "default");
                        if (e.geterrorMessage()) {
                            helpers.showErrorMessage(e.geterrorMessage());
                        }
                        else {
                            helpers.showErrorMessage(ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode[e.getResult()]);
                        }
                    }
                    else {
                        this.AssignActivatioInfo(e.getactivationInfo(), false);
                    }
                };
                Activation.prototype.SwitchGraceMessage = function (isGrace) {
                    var gracePartVisibility = isGrace ? "visible" : "collapse";
                    var nonGracPartVisibility = isGrace ? "collapse" : "visible";
                    document.getElementById('serverLicenseGrid').style.visibility = nonGracPartVisibility;
                    if (nonGracPartVisibility == "collapse") {
                        document.getElementById('serverLicenseGrid').style.display = "none";
                    }
                    else if (nonGracPartVisibility == "visible") {
                        document.getElementById('serverLicenseGrid').style.display = "block";
                    }
                    document.getElementById('graceMessageBlockPart1').style.visibility = document.getElementById('graceMessageBlockPart2').style.visibility = gracePartVisibility;
                };
                /// <summary>
                /// Assign value from activationInfo to field on screen. statuBox field value will depend on isFromApplyActivation
                /// </summary>
                /// <param name="activationInfo"></param>
                /// <param name="isFromApplyActivation"></param>
                Activation.prototype.AssignActivatioInfo = function (activationInfo, isFromApplyActivation) {
                    document.getElementById('totalNumLicensesField').textContent = activationInfo.getTotalNumberOfLicense().toString();
                    document.getElementById('availableLicensesField').textContent = activationInfo.getTotalNumberAvailable().toString();
                    document.getElementById('assignLicenseTextBox').value = activationInfo.getLicensesProposedToGet().toString();
                    document.getElementById('inUseLicenseTextBlock').textContent = activationInfo.getLicensesCurrentlyInUse().toString();
                    this.SwitchGraceMessage(activationInfo.getIsGraceMode());
                    if (activationInfo.getIsGraceMode()) {
                        document.getElementById('totalNumLicensesField').textContent = "0";
                        document.getElementById('availableLicensesField').textContent = "0";
                        if (activationInfo.getIsGracePeriodExpired()) {
                            document.getElementById('graceMessageBlockPart1').textContent = VPAdmin.ResourceBinder.getString("msgGracePeriodExpired");
                            document.getElementById('graceMessageBlockPart2').style.visibility = "collapse";
                        }
                        else {
                            document.getElementById('graceMessageBlockPart1').textContent = VPAdmin.ResourceBinder.getString("msgGracePeriodPart1");
                            document.getElementById('graceMessageBlockPart2').textContent = VPAdmin.ResourceBinder.getString("msgGracePeriodPart2");
                        }
                        return;
                    }
                    var statusBox = document.getElementById('statusBox');
                    if (isFromApplyActivation) {
                        if (activationInfo.getLicensesCurrentlyAcquired() < activationInfo.getLicensesProposedToGet()) {
                            if (this.mLastActivationInfo != null) {
                                var numNewLicensesGot = activationInfo.getLicensesCurrentlyAcquired() - this.mLastActivationInfo.getLicensesProposedToGet();
                                if (numNewLicensesGot <= 0) {
                                    var msg = VPAdmin.VPAdminUtil.GetString("msgActivationAssignNotEnoughNone");
                                    statusBox.textContent = helpers.Format(msg, activationInfo.getLicensesCurrentlyAcquired());
                                }
                                else if (numNewLicensesGot == 1) {
                                    var msg = VPAdmin.VPAdminUtil.GetString("msgActivationAssignNotEnoughSingle");
                                    statusBox.textContent = helpers.Format(msg, numNewLicensesGot, activationInfo.getLicensesCurrentlyAcquired());
                                }
                                else {
                                    var msg = VPAdmin.VPAdminUtil.GetString("msgActivationAssignNotEnough");
                                    statusBox.textContent = helpers.Format(msg, numNewLicensesGot, activationInfo.getLicensesCurrentlyAcquired());
                                }
                            }
                        }
                        else if (activationInfo.getLicensesCurrentlyAcquired() > activationInfo.getLicensesProposedToGet()) {
                            var msg = VPAdmin.VPAdminUtil.GetString("msgActivationCanNotRelease");
                            statusBox.textContent = helpers.Format(msg, activationInfo.getLicensesCurrentlyInUse(), activationInfo.getLicensesCurrentlyAcquired());
                        }
                        else {
                            var msg = VPAdmin.VPAdminUtil.GetString("msgActivationAssignSuccess");
                            statusBox.textContent = helpers.Format(msg, activationInfo.getLicensesCurrentlyAcquired());
                        }
                    }
                    else {
                        var msg = VPAdmin.VPAdminUtil.GetString("msgActivationGetSuccess");
                        statusBox.textContent = helpers.Format(msg, activationInfo.getLicensesCurrentlyAcquired());
                    }
                    this.mLastActivationInfo = activationInfo;
                };
                /// <summary>
                /// Handler mouse click of Apply button. It will validate input value to make sure is either 0 or a positive integer
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                Activation.prototype.ApplyButton_Click = function (Services) {
                    var button = document.getElementById("applyButton");
                    var assignLicenseTextBox = document.getElementById('assignLicenseTextBox');
                    var totalNumLicensesField = document.getElementById('totalNumLicensesField');
                    console.assert(button != null);
                    if (!assignLicenseTextBox.value) {
                        var msg = VPAdmin.VPAdminUtil.GetString("msgActivationInputEmpty");
                        msg = helpers.Format(msg, ViewPoint.Client.VPAdmin.Activation.MIN_LICENSES_PER_SERVER, totalNumLicensesField.textContent);
                        VPAdmin.VPAdminUtil.ShowMessage(msg);
                        if (this.mLastActivationInfo != null) {
                            assignLicenseTextBox.value = this.mLastActivationInfo.getLicensesProposedToGet().toString();
                        }
                    }
                    else {
                        var inNumberOfLicenses;
                        var maxNumberOfLicenses;
                        var isInputNumeric = (function () {
                            var _tmp = helpers.TryParse(assignLicenseTextBox.value, inNumberOfLicenses);
                            inNumberOfLicenses = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(this);
                        var isMaxNumeric = (function () {
                            var _tmp = helpers.TryParse(totalNumLicensesField.textContent, maxNumberOfLicenses);
                            maxNumberOfLicenses = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(this);
                        if (isInputNumeric && isMaxNumeric && inNumberOfLicenses >= 0) {
                            if (inNumberOfLicenses < ViewPoint.Client.VPAdmin.Activation.MIN_LICENSES_PER_SERVER) {
                                var msg = VPAdmin.VPAdminUtil.GetString("msgActivationInputEmpty");
                                msg = helpers.Format(msg, ViewPoint.Client.VPAdmin.Activation.MIN_LICENSES_PER_SERVER, totalNumLicensesField.textContent);
                                VPAdmin.VPAdminUtil.ShowMessage(msg);
                                if (this.mLastActivationInfo != null) {
                                    assignLicenseTextBox.value = this.mLastActivationInfo.getLicensesProposedToGet().toString();
                                }
                            }
                            else if (inNumberOfLicenses > maxNumberOfLicenses) {
                                var msg = VPAdmin.VPAdminUtil.GetString("msgActivationInputTooLarger");
                                msg = helpers.Format(msg, ViewPoint.Client.VPAdmin.Activation.MIN_LICENSES_PER_SERVER, totalNumLicensesField.textContent);
                                VPAdmin.VPAdminUtil.ShowMessage(msg);
                                if (this.mLastActivationInfo != null) {
                                    assignLicenseTextBox.value = this.mLastActivationInfo.getLicensesProposedToGet().toString();
                                }
                            }
                            else {
                                var myApp = VPAdmin.Application.GetViewPointAdminApp();
                                console.assert(myApp != null);
                                Services.ApplyActivation(this, this.ApplyActivationCompleted, myApp.GetConnectionHelper().m_ClientIdentifier, true, inNumberOfLicenses);
                                button.disabled = true;
                                $('body').css("cursor", "wait");
                            }
                        }
                        else {
                            var msg = VPAdmin.VPAdminUtil.GetString("msgActivationInputInvalid");
                            msg = helpers.Format(msg, ViewPoint.Client.VPAdmin.Activation.MIN_LICENSES_PER_SERVER, totalNumLicensesField.textContent);
                            VPAdmin.VPAdminUtil.ShowMessage(msg);
                            if (this.mLastActivationInfo != null) {
                                assignLicenseTextBox.value = this.mLastActivationInfo.getLicensesProposedToGet().toString();
                            }
                        }
                    }
                };
                /// <summary>
                /// Trap KeyDown event for input textbox so that only numeric input is allowed
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                Activation.prototype.assignLicenseTextBox_KeyDown = function (sender, e) {
                    /*TODOif ((Keyboard.getModifiers() & ModifierKeys.Shift) != 0) {
                        e.setHandled(true);
                        return;
                    }
                    if (Key.D0 <= e.getKey() && e.getKey() <= Key.D9) {
                        return;
                    }
                    if (Key.NumPad0 <= e.getKey() && e.getKey() <= Key.NumPad9) {
                        return;
                    }
                    e.setHandled(true);*/
                };
                Activation.prototype.assignLicenseTextBox_GotFocus = function (sender, e) {
                    document.getElementById('applyButton').disabled = false;
                };
                Activation.activationClass = null;
                Activation.helpUrl = "";
                Activation.MIN_LICENSES_PER_SERVER = 1;
                return Activation;
            }());
            VPAdmin.Activation = Activation;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var LoginTab = /** @class */ (function () {
                function LoginTab() {
                }
                LoginTab.GetLoginClass = function () {
                    if (LoginTab.loginClass == null) {
                        LoginTab.loginClass = new LoginTab();
                    }
                    return LoginTab.loginClass;
                };
                LoginTab.prototype.LoginTab_Loaded = function (sender, e) {
                    var MyApp = ViewPoint.Client.VPAdmin.AppLogin.GetLoginApp();
                    //LogonTypeTxt.Text = (MyApp.getIsRuntime())?"Application":"Administration";
                    try {
                        if (MyApp.IsMEPlatform || MyApp.getStrScope().StartsWith("$Local")) {
                            document.getElementById("cbScope").selectedIndex = 1;
                        }
                        else {
                            document.getElementById("cbScope").selectedIndex = 0;
                        }
                    }
                    catch (e) { }
                    // If it is the runtime application disable the Scope Combobox.
                    if (MyApp.IsMEPlatform || MyApp.getIsRuntime()) {
                        document.getElementById("cbScope").disabled = true;
                    }
                    if (MyApp.getPostbackMessage()) {
                        //loginMsg.Text = MyApp.getPostbackMessage();
                        //loginMsg.Opacity = 1;
                        document.getElementById("loginMsg").textContent = MyApp.getPostbackMessage();
                    }
                    if (MyApp.m_isNeedInit) {
                        //txu.Focus();
                        document.getElementById("cbRemember").style.visibility = MyApp.IsMEPlatform ? "collapse" : "visible";
                    }
                    try {
                        if (MyApp.m_initParams["User"]) {
                            //txu.Text = MyApp.getInitParams()["User"];
                        }
                    }
                    catch (_) {
                    }
                };
                LoginTab.prototype.txp_KeyDown = function (sender, e) {
                    //if (e.getKey() == Key.Enter) {
                    this.SubmitLogin();
                    //}
                };
                LoginTab.prototype.butLogin_Click = function (sender, e) {
                    this.SubmitLogin();
                };
                LoginTab.prototype.Encrypt = function (key) {
                    return ViewPoint.Util.ViewPointHelper.EncryptIt(key, 1);
                };
                LoginTab.prototype.SubmitLogin = function () {
                    var username = document.getElementById("login-username").value;
                    var userpsw = document.getElementById("login-password").value;
                    var etdr = document.getElementById("cbScope").selectedIndex ? "Local" : "Network";
                    var etrm = document.getElementById("cbRemember").checked ? "true" : "false";
                    var etxp = this.Encrypt(userpsw);
                    var etxu = this.Encrypt(username);
                    try {
                        parent.document.getElementById("etxu").setAttribute("value", etxu.toString()); //alert(etxu.toString());
                        parent.document.getElementById("etxp").setAttribute("value", etxp.toString()); //alert(etxp.toString());
                        parent.document.getElementById("etdr").setAttribute("value", etdr.toString()); //alert(etdr.toString());
                        parent.document.getElementById("etrm").setAttribute("value", etrm.toString()); //alert(etrm.toString());
                    }
                    catch (e) {
                        alert(e);
                    }
                    try {
                        var form = parent.document.getElementById("form1");
                        form.submit();
                    }
                    catch (e) {
                        alert(e);
                    }
                };
                LoginTab.loginClass = null;
                return LoginTab;
            }());
            VPAdmin.LoginTab = LoginTab;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var ProgressMsg;
            (function (ProgressMsg) {
                ProgressMsg[ProgressMsg["progress1"] = 0] = "progress1";
                ProgressMsg[ProgressMsg["progress2"] = 1] = "progress2";
                ProgressMsg[ProgressMsg["progress3"] = 2] = "progress3";
                ProgressMsg[ProgressMsg["progress4"] = 3] = "progress4";
                ProgressMsg[ProgressMsg["progress5"] = 4] = "progress5";
                ProgressMsg[ProgressMsg["progress6"] = 5] = "progress6";
                ProgressMsg[ProgressMsg["interrupted"] = 6] = "interrupted";
            })(ProgressMsg = VPAdmin.ProgressMsg || (VPAdmin.ProgressMsg = {}));
            var Publish = /** @class */ (function () {
                function Publish(Services, DisplaysTree) {
                    this.m_RowHeight = 24;
                    this.m_currentTry = 0;
                    this.ResetProgress = function (setNew) {
                        for (var i = 0; i < this.DisplayTree.length; i++) {
                            this.DisplayTree[i].Deployed = false;
                            if (setNew) {
                                this.DisplayTree[i].PublishStatus = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString(ViewPoint.Client.VPAdmin.WebService.ProgressType[ViewPoint.Client.VPAdmin.WebService.ProgressType.NewPublish]);
                            }
                        }
                    };
                    this.StartAnimation = function () {
                        try {
                            if (this.m_LastUpdated.PublishStatus.EndsWith("..."))
                                this.m_LastUpdated.PublishStatus = this.m_LastUpdated.PublishStatus.substr(0, this.m_LastUpdated.PublishStatus.length - 3);
                            else
                                this.m_LastUpdated.PublishStatus += ".";
                        }
                        catch (e) {
                        }
                    };
                    this.StopAnimation = function () {
                        try {
                            var n = this.m_LastUpdated.PublishStatus.indexOf(".");
                            if (0 < n) {
                                this.m_LastUpdated.PublishStatus.substr(0, n);
                            }
                        }
                        catch (e) {
                        }
                    };
                    this.m_StartFromEventIndex = 0;
                    this.m_RowHeight = 24;
                    this.m_ProgressEventsResultHandled = null;
                    this.m_currentTry = 0;
                    this.m_CurrentRow = 0;
                    this.m_LastProgressTime = null;
                    this.m_LastProgressdata = null;
                    this.m_CurProgressNum = 0;
                    this.m_CurStatus = null;
                    this.m_DotTimer = null;
                    this.m_DotTimerStarted = null;
                    this.m_LastUpdated = null;
                    this.InitImages();
                    this.Services = Services;
                    this.DisplayTree = DisplaysTree.PublishTable;
                    var vpAdminApp = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp();
                    this.SetStatus({ ProgressType: ViewPoint.Client.VPAdmin.WebService.ProgressType.Manifest });
                    vpAdminApp.btnPublish.textContent = VPAdmin.VPAdminUtil.GetString("btnPublish");
                    vpAdminApp.btnPublishWebM.textContent = VPAdmin.VPAdminUtil.GetString("btnPublishWebM");
                    this.btnPublish_Click(null, null);
                    this.publishIsFinish = undefined;
                }
                Publish.prototype.StartPublishDisplay = function () {
                    $('body').css("cursor", "wait");
                    this.ResetProgress(true);
                    this.Services.PublishDisplays(this, this.PublishDisplaysServiceCompleted, this.ftViewApplication, this.forceRepublish);
                };
                Object.defineProperty(Publish.prototype, "CanSwitch", {
                    /// <summary>
                    /// A flag that determinate if user can switch to other displays
                    /// (e.g. during publish, we won't allow user to switch to select display screen)
                    /// </summary>
                    get: function () {
                        var buttonContent = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().btnPublish.textContent;
                        var publishString = VPAdmin.VPAdminUtil.GetString("btnPublish");
                        var doneStrig = VPAdmin.VPAdminUtil.GetString("btnOpenApplication");
                        var isPublishButton = helpers.Compare(buttonContent, publishString, false, false, true) == 0;
                        var isDoneButton = helpers.Compare(buttonContent, doneStrig, false, false, true) == 0;
                        return (isPublishButton || isDoneButton);
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Publish.prototype, "Progress", {
                    set: function (value) {
                        ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().progressBar.value = Math.round(value);
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Publish.prototype, "Status", {
                    set: function (value) {
                        ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().lblCurrentStatus.textContent = value;
                    },
                    enumerable: true,
                    configurable: true
                });
                Publish.prototype.InitImages = function () {
                };
                Publish.prototype.btnPublish_Click = function (sender, e) {
                    var btnPublish = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().btnPublish;
                    var btnPublishContent = btnPublish.textContent;
                    if (btnPublishContent != null && helpers.Compare(btnPublishContent, VPAdmin.VPAdminUtil.GetString("btnPublish"), false, false, true) == 0) {
                        this.Status = VPAdmin.VPAdminUtil.GetString(ProgressMsg[ProgressMsg.progress1].toString());
                        btnPublish.disabled = false;
                        btnPublish.textContent = VPAdmin.VPAdminUtil.GetString("btnCancel");
                        this.SetBtnAnchorDisabled(ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().rpAppButtonSelectDisplayBack, true);
                        ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().hlErrors.style.visibility = "collapse";
                        ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().showErrorReport = false;
                        /* Not Necessary
                            if (this.OnPublish != null) {
                            this.OnPublish(sender,e);
                        }*/
                    }
                    else if (helpers.Compare(btnPublish.textContent, VPAdmin.VPAdminUtil.GetString("btnOpenApplication"), false, false, true) == 0) {
                        var uri = btnPublish["Tag"];
                        if (uri) {
                            btnPublish.href = ViewPoint.Client.VPAdmin.VPAdminUtil.SCHEME_AND_SERVER + uri;
                        }
                    }
                    else {
                        btnPublish.disabled = true;
                        /*if (this.OnCancel != null) {
                            this.OnCancel(sender,e);
                        }*/
                        this.Services.StopPublishDisplays(this, this.StopPublishDisplaysCompleted);
                        $('body').css("cursor", "default");
                        return "Cancel";
                    }
                };
                /// <summary>
                /// Set the Progress lablel on screen
                /// </summary>
                /// <param name="data"></param>
                Publish.prototype.SetStatus = function (data) {
                    switch (data.ProgressType) {
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.Manifest:
                            this.Status = VPAdmin.VPAdminUtil.GetString(ProgressMsg[ProgressMsg.progress1].toString()).trim();
                            break;
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.Analyzing:
                            this.Status = VPAdmin.VPAdminUtil.GetString(ProgressMsg[ProgressMsg.progress2].toString()).trim();
                            break;
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.Gft2XamlConversion:
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.Gft2XamlConversionStarted:
                            this.Status = VPAdmin.VPAdminUtil.GetString(ProgressMsg[ProgressMsg.progress3].toString()).trim();
                            break;
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.Xaml2RamleConvertion:
                            this.Status = VPAdmin.VPAdminUtil.GetString(ProgressMsg[ProgressMsg.progress4].toString()).trim();
                            break;
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.Uploading:
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.UploadingCompleted:
                            this.Status = VPAdmin.VPAdminUtil.GetString(ProgressMsg[ProgressMsg.progress5].toString()).trim();
                            break;
                        default:
                            this.SetMessage(data.Message);
                            break;
                    }
                };
                /// <summary>
                /// Helper function for SetStatus
                /// </summary>
                /// <param name="message"></param>
                Publish.prototype.SetMessage = function (message) {
                    if (helpers.Compare("Start", message, false, false, true) == 0 || helpers.Compare("Finish", message, false, false, true) == 0) {
                        return;
                    }
                    this.Status = message;
                };
                /// <summary>
                /// Call back function when publish function is finished
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                Publish.prototype.PublishDisplaysServiceCompleted = function (sender, e) {
                    if (e.getCancelled()) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpCancelMsg");
                        msg = helpers.Format(msg, "PublishDisplaysService");
                        helpers.showErrorMessage(msg);
                        this.RecoverError();
                        return;
                    }
                    if (e.getError() != null) {
                        var msg = VPAdmin.VPAdminUtil.GetString("publishNetworkError");
                        ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(msg, ViewPoint.Client.Toolkit.Controls.MessageType.Error);
                        this.RecoverError();
                        return;
                    }
                    if (e.getResult() != ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        $('body').css("cursor", "default");
                        if (e.geterrorMessage()) {
                            ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(e.geterrorMessage(), ViewPoint.Client.Toolkit.Controls.MessageType.Error);
                            var result = new ViewPoint.Client.VPAdmin.WebService.ClientPublishResult();
                            result.setStopped(true);
                            this.UpdateOnComplete(result);
                        }
                        else {
                            ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode[e.getResult()], ViewPoint.Client.Toolkit.Controls.MessageType.Error);
                        }
                        // If the background update could not be interrupted, simply reset the state
                        // of the client for a "re-publish".
                        if (e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.BackgroundUpdateCouldNotBeCancelled || e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.PublishInProgress) {
                            this.SetupForRepublish();
                        }
                    }
                    else {
                        this.m_StartFromEventIndex = 0;
                        // start the timer to get publish progress
                        var self = this;
                        this.m_Timer = window.setInterval(function () { self.TimerCallbackHandler(null, null); }, 1000);
                        // initial the flag
                        this.m_ProgressEventsResultHandled = true;
                        // start dot animation
                        this.StartDotTimer();
                    }
                };
                /// <summary>
                /// Setup the UI state for a "re-publish".
                /// </summary>
                Publish.prototype.SetupForRepublish = function () {
                    this.ResetProgress(false);
                    this.ResetStatus();
                    this.Status = VPAdmin.VPAdminUtil.GetString(ProgressMsg[ProgressMsg.interrupted].toString());
                    ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().hlErrors.style.visibility = "collapse";
                    ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().showErrorReport = false;
                    var btnPublish = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().btnPublish;
                    btnPublish.textContent = VPAdmin.VPAdminUtil.GetString("btnPublish");
                    btnPublish.disabled = false;
                    this.SetBtnAnchorDisabled(ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().rpAppButtonSelectDisplayBack, false);
                };
                /// <summary>
                /// Call back function when publish function is cancelled
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                Publish.prototype.StopPublishDisplaysCompleted = function (sender, e) {
                    this.StopDotTimer();
                    if (e.getCancelled()) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpCancelMsg");
                        msg = helpers.Format(msg, "StopPublishDisplays");
                        helpers.showErrorMessage(msg);
                        return;
                    }
                    if (e.getError() != null) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpErrorMsg");
                        msg = helpers.Format(msg, "StopPublishDisplays");
                        var sb = new String(msg);
                        sb.concat(e.getError().message);
                        sb.concat(e.getError().getStackTrace());
                        helpers.showErrorMessage(sb.toString());
                        return;
                    }
                    if (e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        /*TODO var mainPage = VPAdminUtil.GetMainPage();
                        console.assert(mainPage != null);
                        var displays = mainPage.getDisplays();
                        console.assert(displays != null);
                        displays.ResetProgress(false);
                        this.UpdateGridSafely(displays);*/
                        this.ResetProgress(false);
                        this.ResetStatus();
                    }
                    else if (e.geterrorMessage()) {
                        helpers.showErrorMessage(e.geterrorMessage());
                    }
                    else {
                        helpers.showErrorMessage(ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode[e.getResult()]);
                    }
                };
                /// <summary>
                /// Call back function when getting the publish result is finished
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                Publish.prototype.GetPublishResultServiceCompleted = function (sender, e) {
                    $('body').css("cursor", "default");
                    if (e.getCancelled()) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpCancelMsg");
                        msg = helpers.Format(msg, "GetPublishResultService");
                        helpers.showErrorMessage(msg);
                        return;
                    }
                    if (e.getError() != null) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpErrorMsg");
                        msg = helpers.Format(msg, "GetPublishResultService");
                        var sb = new String(msg);
                        sb.concat(e.getError().message);
                        sb.concat(e.getError().getStackTrace());
                        helpers.showErrorMessage(sb.toString());
                        return;
                    }
                    if (e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        var publishResult = e.getclientPublishResult()[0];
                        console.assert(publishResult != null);
                        //  var mainPage = VPAdminUtil.GetMainPage();
                        // console.assert(mainPage != null);
                        // var displays = mainPage.getDisplays();
                        // console.assert(displays != null);
                        this.SetDeployed(publishResult);
                        // this.UpdateGridSafely(displays);
                        this.UpdateOnComplete(publishResult);
                        // Set the value of m_securityGroupsToLoad to allow updated tree on security settings screen 
                        ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass().m_securityGroupsToLoad = true;
                        if (!publishResult.Stopped && publishResult.Succeed && publishResult.NumberOfError <= 0) {
                            // reset the force republish flag in Select Display screen                    
                            //TODO: VPAdminUtil.GetMainPage().PgApp2.forceRePublishCheckBox.IsChecked = false;
                        }
                    }
                    else if (e.geterrorMessage()) {
                        helpers.showErrorMessage(e.geterrorMessage());
                        // Update the UI state of the page.
                        if (e.getclientPublishResult() != null) {
                            this.UpdateOnComplete(e.getclientPublishResult());
                        }
                        else {
                            var result = new ViewPoint.Client.VPAdmin.WebService.ClientPublishResult();
                            result.setStopped(true);
                            this.UpdateOnComplete(result);
                        }
                    }
                    else {
                        helpers.showErrorMessage(ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode[e.getResult()]);
                        // Update the UI state of the page.
                        if (e.getclientPublishResult() != null) {
                            this.UpdateOnComplete(e.getclientPublishResult());
                        }
                        else {
                            var result = new ViewPoint.Client.VPAdmin.WebService.ClientPublishResult();
                            result.setStopped(true);
                            this.UpdateOnComplete(result);
                        }
                    }
                    var pResult = e.getclientPublishResult();
                    if (pResult[0].Succeed) {
                        this.ctrlSecuredDisplays = new VPAdmin.SecuredDisplaysControl();
                        this.ctrlSecuredDisplays.Services = this.Services;
                        var myApp = VPAdmin.Application.GetViewPointAdminApp();
                        try {
                            this.ctrlSecuredDisplays.m_Scope = myApp.CurrentFTDScope;
                        }
                        catch (_) {
                        }
                        this.ctrlSecuredDisplays.myApp_OnPublishComplete(null, null);
                    }
                };
                /// <summary>
                /// Call back function when getting the publish progress is finished
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                Publish.prototype.GetEventsServiceCompleted = function (sender, e) {
                    // stop the timer while processing the data ...
                    window.clearInterval(this.m_Timer);
                    if (e.getCancelled()) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpCancelMsg");
                        msg = helpers.Format(msg, "GetEventsService");
                        helpers.showErrorMessage(msg);
                        this.StopDotTimer();
                        this.RecoverError();
                        return;
                    }
                    if (e.getError() != null) {
                        if (this.m_currentTry >= ViewPoint.Client.VPAdmin.Publish.NUM_OF_RETRY) {
                            var msg = VPAdmin.VPAdminUtil.GetString("publishNetworkError");
                            //helpers.showErrorMessage(msg);
                            var errormsg = ViewPoint.Client.Toolkit.Controls.DialogBox.ShowModal(msg, 2, 0);
                            $('#' + errormsg.DialogName).css('z-index', '1500');
                            this.StopDotTimer();
                            this.RecoverError();
                        }
                        else {
                            this.m_currentTry++;
                            this.m_ProgressEventsResultHandled = true;
                            var self = this;
                            this.m_Timer = window.setInterval(function () { self.TimerCallbackHandler(null, null); }, 1000);
                        }
                        return;
                    }
                    this.m_currentTry = 0;
                    if (e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.PublishInProgress || e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.PublishErrorProgressContinue || e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.PublishNotStart || e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.PublishCompleted) {
                        //var $it = e.getpdList().GetEnumerator();
                        // Process the return data ...
                        try {
                            for (var i = 0; i < e.getpdList().length; i++) {
                                this.HandleProgressData(e.getpdList()[i]);
                            }
                        }
                        catch (_) { }
                        this.m_StartFromEventIndex = e.getnextEventIndex();
                        // Keep polling only if the process is not completed yet
                        if (e.getResult() != ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.PublishCompleted) {
                            this.m_ProgressEventsResultHandled = true;
                            var self = this;
                            this.m_Timer = window.setInterval(function () { self.TimerCallbackHandler(null, null); }, 1000);
                        }
                        else {
                            this.StopDotTimer();
                            var myApp = VPAdmin.Application.GetViewPointAdminApp();
                            console.assert(myApp != null);
                            //myApp.GetConnectionHelper().TryGetPublishResult();
                            this.Services.GetPublishResult(this, this.GetPublishResultServiceCompleted);
                        }
                    }
                    else {
                        this.StopDotTimer();
                        ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode[e.getResult()], ViewPoint.Client.Toolkit.Controls.MessageType.Error);
                    }
                };
                /// <summary>
                /// Function to re-activate all the buttons and links etc. when error happen during publishing
                /// </summary>
                Publish.prototype.RecoverError = function () {
                    $('body').css("cursor", "default");
                    this.Status = VPAdmin.VPAdminUtil.GetString(ProgressMsg[ProgressMsg.interrupted].toString());
                    ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().hlErrors.style.visibility = "collapse";
                    ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().showErrorReport = false;
                    var btnPublish = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().btnPublish;
                    btnPublish.textContent = VPAdmin.VPAdminUtil.GetString("btnOpenApplication");
                    ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().btnPublish = btnPublish;
                    btnPublish.disabled = false;
                    this.SetBtnAnchorDisabled(ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().rpAppButtonSelectDisplayBack, false);
                    //restores the functionality after publish
                    ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().home.setAttribute('style', 'background: #A51C21;pointer-events: auto;');
                    ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().lpAppSelect.setAttribute('style', 'pointer-events: auto;');
                    ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().lpAppSelectDisplay.setAttribute('style', 'pointer-events: auto;');
                };
                /// <summary>
                /// Timer call back function of polling for publish progress
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="ea"></param>
                Publish.prototype.TimerCallbackHandler = function (sender, ea) {
                    if (this.m_ProgressEventsResultHandled) {
                        this.m_ProgressEventsResultHandled = false;
                        var myApp = VPAdmin.Application.GetViewPointAdminApp();
                        console.assert(myApp != null);
                        //myApp.GetConnectionHelper().TryGetProgressEvents(this.m_StartFromEventIndex);
                        this.Services.GetProgressEvents(this, this.GetEventsServiceCompleted, this.m_StartFromEventIndex);
                    }
                };
                /// <summary>
                /// Update publishing progress with input progressData
                /// </summary>
                /// <param name="progressData"></param>
                Publish.prototype.HandleProgressData = function (progressData) {
                    //var mainPage = VPAdminUtil.GetMainPage();
                    //console.assert(mainPage != null);
                    //var displays = mainPage.getDisplays();
                    // console.assert(displays != null);
                    this.m_LastProgressTime = new Date();
                    this.m_LastProgressdata = progressData;
                    this.SetStatus(this.m_LastProgressdata);
                    switch (this.m_LastProgressdata.ProgressType) {
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.Uploading:
                            //displays.UpdateAllDisplays(this.m_LastProgressdata);
                            this.UpdateAllDisplays(this.m_LastProgressdata);
                            break;
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.UploadingCompleted:
                            //displays.UpdateAllDisplays(this.m_LastProgressdata);
                            this.UpdateAllDisplays(this.m_LastProgressdata);
                            this.StopDotTimer();
                            break;
                        default:
                            this.UpdateDisplay(this.m_LastProgressdata);
                            //this.ReStartDotTimer();
                            break;
                    }
                    this.UpdateProgressBar(this.m_LastProgressdata);
                    //this.UpdateGridSafely(displays);
                };
                Publish.prototype.UpdateDisplay = function (progressData) {
                    if (progressData.FullName) {
                        for (var i = 0; i < this.DisplayTree.length; i++) {
                            var treeFullName = this.DisplayTree[i].FullName.replace(' ', '_');
                            var progressDataFullName = progressData.FullName.replace(' ', '_');
                            if (treeFullName == progressDataFullName) {
                                this.DisplayTree[i].PublishStatus = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString(ViewPoint.Client.VPAdmin.WebService.ProgressType[progressData.ProgressType]);
                                if (this.m_LastUpdatedFullName != progressData.FullName) {
                                    this.StopAnimation();
                                    this.m_LastUpdated = this.DisplayTree[i];
                                    this.m_LastUpdatedFullName = treeFullName;
                                }
                            }
                        }
                    }
                    /* This code was come from DisplayItemCollection
                   UpdateDisplay(progress,index) {
                  if (progress.getFullName())return {
                      refs : [index],
                      result : false
                  }
                  var name = progress.getFullName().Replace(" ","_");
                  for(var i = 0;i < Count;i++) {
                      var di = this[i];
                      if (name == di.getFullName().Replace(" ","_")) {
                          di.setProgress(progress.getProgressType());
                          if (null != this.m_LastUpdated)this.m_LastUpdated.StopAnimate();
                          this.m_LastUpdated = di;
                          index = i;
                          if (null != OnProgressUpdated)OnProgressUpdated(di,null);
                          return {
                              refs : [index],
                              result : true
                          }
                      }
                  }
                  return {
                      refs : [index],
                      result : false
                  }
              }
                  */
                };
                Publish.prototype.UpdateAllDisplays = function (progressData) {
                    for (var i = 0; i < this.DisplayTree.length; i++) {
                        this.DisplayTree[i].PublishStatus = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString(ViewPoint.Client.VPAdmin.WebService.ProgressType[progressData.ProgressType]);
                    }
                    /*This code was come from DisplayItemCollection
                       UpdateAllDisplays(progress) {
                       var $it = this.GetEnumerator();
                       while ( $it.MoveNext() ) {
                           var di = $it.getCurrent();
                           di.setProgress(progress.getProgressType());
                       }
                      }
                   */
                };
                Publish.prototype.SetDeployed = function (result) {
                    for (var i = 0; i < this.DisplayTree.length; i++) {
                        this.DisplayTree[i].Deployed = result.Succeed && !result.Stopped;
                        if (result.Stopped) {
                            this.DisplayTree[i].PublishStatus = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString(ViewPoint.Client.VPAdmin.WebService.ProgressType[ViewPoint.Client.VPAdmin.WebService.ProgressType.Cancelled]);
                        }
                        else if (result.Succeed) {
                            this.DisplayTree[i].PublishStatus = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString(ViewPoint.Client.VPAdmin.WebService.ProgressType[ViewPoint.Client.VPAdmin.WebService.ProgressType.UploadingCompleted]);
                        }
                    }
                    /* This code was come from DisplayItemCollection
                     var $it = this.GetEnumerator();
                    while ( $it.MoveNext() ) {
                        var di = $it.getCurrent();
                        (helpers.asType(di.getContent(),ViewPoint.Client.VPAdmin.WebService.GraphicsDisplay)).setDeployed(result.getSucceed() && !result.getStopped());
                        if (result.getStopped()) {
                            di.setProgress(ProgressType.Cancelled);
                        } else if (result.getSucceed()) {
                            di.setProgress(ProgressType.UploadingCompleted);
                        }
                    }
                    this.StopAnimation();
                    */
                };
                /// <summary>
                /// Function to update the progress bar
                /// </summary>
                /// <param name="pd"></param>
                /// <param name="displays"></param>
                Publish.prototype.UpdateProgressBar = function (pd) {
                    switch (pd.ProgressType) {
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.Manifest:
                            this.m_CurStatus = ViewPoint.Client.VPAdmin.WebService.ProgressType.Manifest;
                            this.Progress = (this.m_CurProgressNum++) * 10 / this.DisplayTree.length;
                            break;
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.Analyzing:
                            if (ViewPoint.Client.VPAdmin.WebService.ProgressType.Manifest == this.m_CurStatus) {
                                this.m_CurStatus = ViewPoint.Client.VPAdmin.WebService.ProgressType.Analyzing;
                                this.m_CurProgressNum = 0;
                            }
                            this.Progress = 10 + (this.m_CurProgressNum++) * 10 / this.DisplayTree.length;
                            break;
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.Gft2XamlConversion:
                            if (ViewPoint.Client.VPAdmin.WebService.ProgressType.Analyzing == this.m_CurStatus) {
                                this.m_CurStatus = ViewPoint.Client.VPAdmin.WebService.ProgressType.Gft2XamlConversion;
                                this.m_CurProgressNum = 0;
                            }
                            this.Progress = 20 + (this.m_CurProgressNum++) * 30 / this.DisplayTree.length;
                            break;
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.Xaml2RamleConvertion:
                            if (ViewPoint.Client.VPAdmin.WebService.ProgressType.Gft2XamlConversionStarted == this.m_CurStatus || ViewPoint.Client.VPAdmin.WebService.ProgressType.Gft2XamlConversion == this.m_CurStatus) {
                                this.m_CurStatus = ViewPoint.Client.VPAdmin.WebService.ProgressType.Xaml2RamleConvertion;
                                this.m_CurProgressNum = 0;
                            }
                            this.Progress = 50 + (this.m_CurProgressNum++) * 10 / this.DisplayTree.length;
                            break;
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.Uploading:
                            this.Progress = pd.Progress;
                            break;
                        case ViewPoint.Client.VPAdmin.WebService.ProgressType.UploadingCompleted:
                            this.Progress = 100;
                            break;
                    }
                };
                Publish.prototype.UpdateGridSafely = function (displays) {
                    /*TODO displays.UpdateGrid(grid2);*/
                    this.EnsureVisible(this.m_CurrentRow);
                };
                Publish.prototype.EnsureVisible = function (row) {
                    var h = this.m_RowHeight * (row + 1);
                    /*TODO if (h > scrViewer2.ActualHeight) {
                        scrViewer2.ScrollToVerticalOffset(h - scrViewer2.ActualHeight + 24);
                    } else {
                        scrViewer2.ScrollToVerticalOffset(0);
                    }*/
                };
                Publish.prototype.UpdateOnComplete = function (result) {
                    var btnPublish = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().btnPublish;
                    var btnPublishWebM = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().btnPublishWebM;
                    btnPublishWebM.href = ViewPoint.Client.VPAdmin.VPAdminUtil.SCHEME_AND_SERVER + VPAdmin.VPAdminUtil.GetString("mobileWeb_url");
                    var lblCurrentStatus = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().lblCurrentStatus;
                    var hlErrors = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().hlErrors;
                    if (result.Stopped) {
                        lblCurrentStatus.textContent = VPAdmin.VPAdminUtil.GetString(ProgressMsg[ProgressMsg.interrupted].toString());
                        ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().btnPublish = btnPublish;
                        hlErrors.style.visibility = "collapse";
                        ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().showErrorReport = false;
                        btnPublish.textContent = VPAdmin.VPAdminUtil.GetString("btnPublish");
                        btnPublish.disabled = false;
                        //this.OnBack(this,null);
                    }
                    else {
                        if (null != result.DeploymentStatus) {
                            lblCurrentStatus.textContent = result.DeploymentStatus;
                        }
                        if (null != result.ErrorReportPath) {
                            hlErrors.style.visibility = "visible";
                            ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().showErrorReport = true;
                            hlErrors.href = result.ErrorReportPath;
                        }
                        else {
                            hlErrors.style.visibility = "collapse";
                            ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().showErrorReport = false;
                        }
                        if (null != result.DeployURL) {
                            btnPublish["Tag"] = result.DeployURL;
                            $("#btnPublishWebM").removeClass("hide");
                        }
                    }
                    this.publishIsFinish = result;
                    this.SetPublish(result);
                };
                Publish.prototype.SetPublish = function (result) {
                    try {
                        var btnPublish = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().btnPublish;
                        if (helpers.Compare(ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().lblCurrentStatus.textContent, VPAdmin.VPAdminUtil.GetString(ProgressMsg[ProgressMsg.interrupted].toString()), false, false, true) == 0 || result.NumberOfError > 0) {
                            btnPublish.disabled = true;
                        }
                        else {
                            btnPublish.disabled = false;
                            document.getElementById("nextArrow").style.display = "block";
                        }
                        btnPublish.textContent = VPAdmin.VPAdminUtil.GetString("btnOpenApplication");
                        ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().btnPublish = btnPublish;
                        this.SetBtnAnchorDisabled(ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().rpAppButtonSelectDisplayBack, false);
                        //restores the functionality after publish
                        ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().home.setAttribute('style', 'background: #A51C21;pointer-events: auto;');
                        ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().lpAppSelect.setAttribute('style', 'pointer-events: auto;');
                        ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().lpAppSelectDisplay.setAttribute('style', 'pointer-events: auto;');
                    }
                    catch (e) {
                        console.log("Finish publish, but the page of publish displays is not loaded");
                    }
                };
                Publish.prototype.ResetStatus = function () {
                    this.Status = "";
                    ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().hlErrors.style.visibility = "collapse";
                    ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().showErrorReport = false;
                };
                //region functions to handle Dot (...) animation
                Publish.prototype.StopDotTimer = function () {
                    if (this.m_DotTimer != null) {
                        if (this.m_DotTimerStarted) {
                            window.clearInterval(this.m_DotTimer);
                            this.m_DotTimerStarted = false;
                        }
                    }
                };
                Publish.prototype.ReStartDotTimer = function () {
                    window.clearInterval(this.m_DotTimer);
                    var self = this;
                    this.m_DotTimer = window.setInterval(function () { self.OnDotTimerTick(null, null); }, ViewPoint.Client.VPAdmin.Publish.MS500);
                };
                Publish.prototype.StartDotTimer = function () {
                    if (this.m_DotTimer == null) {
                        var self = this;
                        this.m_DotTimer = window.setInterval(function () { self.OnDotTimerTick(null, null); }, ViewPoint.Client.VPAdmin.Publish.MS500);
                    }
                    this.m_DotTimerStarted = true;
                };
                Publish.prototype.OnDotTimerTick = function (sender, e) {
                    //if ((date - this.m_LastProgressTime) > ViewPoint.Client.VPAdmin.Publish.MS500) {
                    if (this.m_LastProgressdata == null)
                        return;
                    if (this.m_LastProgressdata.Message.StartsWith("Starting Conversion")) {
                        //this.AddDot();
                        this.StopAnimation();
                    }
                    else {
                        this.StartAnimation();
                    }
                    //}
                };
                Publish.prototype.SetBtnAnchorDisabled = function (anchor, disabled) {
                    anchor.disabled = disabled;
                    if ((navigator.userAgent.toLowerCase().indexOf("chrome") < 0) || (navigator.userAgent.toLowerCase().indexOf("firefox") < 0)) {
                        if (disabled) {
                            anchor.className = "btn btn-anchor-disabled";
                        }
                        else {
                            anchor.className = "btn btn-default";
                        }
                    }
                };
                Publish.NUM_OF_RETRY = 10;
                Publish.MS500 = 500;
                return Publish;
            }());
            VPAdmin.Publish = Publish;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var SettingsPage = /** @class */ (function () {
                function SettingsPage() {
                }
                SettingsPage.GetSettingClass = function () {
                    if (SettingsPage.SettingClass == null) {
                        SettingsPage.SettingClass = new SettingsPage();
                    }
                    return SettingsPage.SettingClass;
                };
                SettingsPage.prototype.SettingsPage_Loaded = function () {
                    var MyApp = ViewPoint.Client.VPAdmin.AppLogin.GetLoginApp();
                    var strITO = MyApp.m_strInactivityTO;
                    var nITO = Number(strITO);
                    if (nITO == 0) {
                        document.getElementById("ITO").disabled = true;
                        document.getElementById("ITO").value = "";
                        document.getElementById("cbEnable").checked = false;
                        document.getElementById("cbEnable").autofocus = true;
                    }
                    else {
                        document.getElementById("ITO").value = strITO;
                        document.getElementById("ITO").autofocus = true;
                        document.getElementById("cbEnable").checked = true;
                    }
                    if (MyApp.m_UserName != "") {
                        var strUser = "User : " + MyApp.m_UserName;
                        document.getElementById("username").textContent = strUser;
                    }
                    // Set the "Apply" button to be disabled
                    document.getElementById("submit").disabled = true;
                    //Build Message
                    var strMsg;
                    if (MyApp.m_strStatus == null) {
                        strMsg = "";
                    }
                    else if (MyApp.m_strStatus == SettingsPage.PostStatusCode_Success) {
                        if (nITO == 0) {
                            strMsg = "Inactivity Timeout is disabled.";
                        }
                        else {
                            strMsg = "Inactivity Timeout set to " + strITO;
                            if (nITO > 1) {
                                strMsg = strMsg + " minutes";
                            }
                            else {
                                strMsg = strMsg + " minute";
                            }
                        }
                    }
                    else if (MyApp.m_strStatus == SettingsPage.PostStatusCode_InvalidParam) {
                        strMsg = "Invalid value";
                        document.getElementById("loginMsg").style.color = 'red';
                    }
                    else if (MyApp.m_strStatus == SettingsPage.PostStatusCode_InternalServerErr) {
                        strMsg = "Error occurred while setting the Inactivity Timeout";
                    }
                    else if (MyApp.m_strStatus == SettingsPage.PostStatusCode_Overflow) {
                        strMsg = "Overflow (maximum allowed timeout is 71,582 minutes)";
                    }
                    else {
                        strMsg = "Error occurred while setting the Inactivity Timeout";
                    }
                    document.getElementById("loginMsg").textContent = strMsg;
                };
                SettingsPage.prototype.butEnable_Click = function () {
                    var checked = document.getElementById("cbEnable").checked;
                    if (checked) {
                        document.getElementById("ITO").disabled = false;
                        document.getElementById("ITO").value = "20";
                        document.getElementById("submit").disabled = false;
                        document.getElementById("loginMsg").textContent = "";
                    }
                    else {
                        document.getElementById("ITO").disabled = true;
                        document.getElementById("submit").disabled = false;
                        document.getElementById("ITO").value = "";
                        document.getElementById("loginMsg").textContent = "";
                    }
                };
                SettingsPage.prototype.input_KeyDown = function (e) {
                    var keynum;
                    if (window.event) {
                        keynum = e.keyCode;
                    }
                    else if (e.which) {
                        keynum = e.which;
                    }
                    if (keynum == 13) {
                        this.butApply_Click();
                    }
                    if ((keynum >= 48 && keynum <= 57) || (keynum >= 96 && keynum <= 105) || (keynum == 8 || keynum == 9) || keynum == 46) {
                        document.getElementById("submit").disabled = false;
                        document.getElementById("loginMsg").textContent = "";
                    }
                    else {
                        e.preventDefault();
                    }
                };
                SettingsPage.prototype.butDefault_Click = function () {
                    document.getElementById("cbEnable").checked = true;
                    document.getElementById("ITO").value = SettingsPage.DEFAULT_INACT_TIMEOUT;
                    document.getElementById("ITO").disabled = false;
                    document.getElementById("submit").disabled = false;
                    document.getElementById("loginMsg").textContent = "";
                };
                SettingsPage.prototype.butApply_Click = function () {
                    // Get Current value of the Inactivity Timeout
                    var strInTO = document.getElementById("ITO").value.trim();
                    if (isNaN(Number(strInTO))) {
                        var strMsg = "Invalid value";
                        document.getElementById("loginMsg").textContent = strMsg;
                        document.getElementById("loginMsg").style.color = 'red';
                    }
                    else {
                        var nInTO = Number(strInTO);
                        if (nInTO < 0 || nInTO > SettingsPage.MAX_INACT_TIMEOUT) {
                            var strMsg = "Overflow (maximum allowed timeout is 71,582 minutes)";
                            document.getElementById("loginMsg").textContent = strMsg;
                            document.getElementById("loginMsg").style.color = 'red';
                        }
                        else {
                            // set the hidden input field to the postback page
                            document.getElementById("inputITO").value = strInTO;
                            // Finally - Submit a postback
                            parent.document.getElementById("form1").submit();
                        }
                    }
                };
                SettingsPage.SettingClass = null;
                /// <summary>
                /// Default value of the Inactivity Timeout in minutes
                /// </summary>
                SettingsPage.DEFAULT_INACT_TIMEOUT = "20";
                /// <summary>
                /// Maximum allowed timeout value in minutes.
                /// Note: converting 71,582 minutes to milliseconds is going to give 71582 * 60000 = 4,294,920,000 ms;
                /// it means that 71,582 is a maximum value in minutes, that can be converted to
                /// milliseconds so that there is no overflow. 
                /// </summary>
                SettingsPage.MAX_INACT_TIMEOUT = 71582;
                SettingsPage.PostStatusCode_Success = "0";
                SettingsPage.PostStatusCode_InvalidParam = "1";
                SettingsPage.PostStatusCode_MissingData = "2";
                SettingsPage.PostStatusCode_InternalServerErr = "3";
                SettingsPage.PostStatusCode_Overflow = "4";
                return SettingsPage;
            }());
            VPAdmin.SettingsPage = SettingsPage;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var Security = /** @class */ (function () {
                function Security() {
                    this.m_strCurrentApplication = "";
                    Security.helpUrl = VPAdmin.VPAdminUtil.CreateHelpLink(VPAdmin.VPAdminUtil.GetString("lpSecLearn_Url"));
                    Security.securityWarningHelpUrl = VPAdmin.VPAdminUtil.CreateHelpLink(VPAdmin.VPAdminUtil.GetString("lpSecurityWarningLink_url"));
                    this.ActiveTab = 0;
                    this.keepAuthRequired = false;
                    this.keepAdminAuthRequired = false;
                    this.keepSecuredDisplaysTab = false;
                    this.keepEnableWriteRequired = false;
                    this.keepPermissions = false;
                    this.securityboxHeight = 0;
                    this.ctrlViewPointAdmin = new VPAdmin.SecuredAdministrationControl();
                    this.ctrlSecuredDisplays = new VPAdmin.SecuredDisplaysControl();
                }
                Security.GetSecurityClass = function () {
                    if (Security.securityClass == null) {
                        Security.securityClass = new Security();
                    }
                    document.getElementById('lpSecLearn').href = Security.helpUrl;
                    document.getElementById('lpSecurityWarningLink').href = Security.securityWarningHelpUrl;
                    return Security.securityClass;
                };
                Security.prototype.SecurityTab_Loaded = function (Services, $scope) {
                    this.ctrlViewPointAdmin.Services = Services;
                    this.ctrlSecuredDisplays.Services = Services;
                    this.ctrlViewPointAdmin.$scope = $scope;
                    this.ctrlSecuredDisplays.$scope = $scope;
                    // Only load the security tab once
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    var strCurrentApplication = myApp.CurrentFTDApplication;
                    if (!strCurrentApplication)
                        strCurrentApplication = "undefined";
                    if (this.m_strCurrentApplication || helpers.Compare(this.m_strCurrentApplication, strCurrentApplication, true, false) != 0) {
                        this.m_strCurrentApplication = strCurrentApplication;
                        this.SetupSecuredDisplaysTab(myApp.CurrentFTDScope, myApp.CurrentFTDApplication);
                    }
                    /*TODO // Setup Change Handlers for Application and Scope
                    myApp.CurrentApplicationChanged += new ViewPoint.Client.VPAdmin.CurrentApplicationChangedEventHandler(this.MyApp_CurrentApplicationChanged);
                    myApp.CurrentScopeChanged += new CurrentScopeChangedEventHandler(this.myApp_CurrentScopeChanged);*/
                    // Setup MouseClick handlers on The Red Arrowed Text items on the LHP
                    this.ctrlViewPointAdmin.SecuredAdministrationControl_Loaded();
                    this.ctrlSecuredDisplays.SecuredDisplaysControl_Loaded();
                };
                Security.prototype.myApp_CurrentScopeChanged = function (sender, e) {
                    // When the Scope Changes, we need to re-read the Users and Groups List
                    // Also the Secured Displays Control needs to be reset to nothing, since the Application
                    // tht it used to be displaying is probably no longer relevant
                    this.ctrlViewPointAdmin.GetSecuritySettings();
                    this.ctrlSecuredDisplays.GetSecuritySettings();
                };
                Security.prototype.MyApp_CurrentApplicationChanged = function (sender, e) {
                    this.m_strCurrentApplication = e.getNewFTDApplication();
                    this.SetupSecuredDisplaysTab(e.getNewScope(), e.getNewFTDApplication());
                };
                Security.prototype.spSecuredDisplaysTab_MouseLeftButtonDown = function (sender, e) {
                    this.ActiveTab = 1;
                    document.getElementById("btnSave").disabled = this.ctrlSecuredDisplays.btnSaveState;
                    document.getElementById("btnDiscard").disabled = this.ctrlSecuredDisplays.btnDiscardState;
                };
                Security.prototype.spVPAdminTab_MouseLeftButtonDown = function (sender, e) {
                    this.ActiveTab = 0;
                    document.getElementById("btnSave").disabled = this.ctrlViewPointAdmin.btnSaveState;
                    document.getElementById("btnDiscard").disabled = this.ctrlViewPointAdmin.btnDiscardState;
                };
                Security.prototype.SetupSecuredDisplaysTab = function (scope, strCurrentApplication) {
                    this.ctrlSecuredDisplays.SetCurrentApplication(scope, strCurrentApplication);
                };
                Security.securityClass = null;
                Security.helpUrl = "";
                Security.securityWarningHelpUrl = "";
                return Security;
            }());
            VPAdmin.Security = Security;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
///
HTMLSelectElement.prototype.Clear = function () {
    while (this.options.length > 0) {
        this.remove(0);
    }
};
HTMLSelectElement.prototype.SetItems = function (items) {
    for (var i = 0; i < items.length; i++) {
        var opt = items[i];
        var el = document.createElement("option");
        el.textContent = opt;
        el.value = opt;
        this.appendChild(el);
    }
};
String.prototype.EndsWith = function (value) {
    return this.indexOf(value, this.length - value.length) !== -1;
};
String.prototype.StartsWith = function (value) {
    return this.indexOf(value) == 0;
};
/// <reference path="../../../helpers/extensions.ts" />
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var SelectApp = /** @class */ (function () {
                function SelectApp() {
                    this.sendEvents = true;
                    this.sendEvents = true;
                    this.m_HasApplicationLoaded = false;
                    this.m_securityGroupsToLoad = true;
                    this.isLoaded = false;
                    this.InitImages();
                    this.apps = [
                        {
                            appType: "Site Edition (Network Distributed)", index: 0
                        },
                        {
                            appType: "Site Edition (Network Station)", index: 1
                        },
                        {
                            appType: "Site Edition (Local)", index: 2
                        }
                    ];
                    this.showerrormessage = false;
                }
                SelectApp.GetSelectAppClass = function () {
                    if (SelectApp.selectAppClass == null) {
                        SelectApp.selectAppClass = new SelectApp();
                    }
                    return SelectApp.selectAppClass;
                };
                Object.defineProperty(SelectApp.prototype, "ApplicationListModified", {
                    get: function () {
                        var result = this.m_ApplicationListModified;
                        // reset after it is returned
                        this.m_ApplicationListModified = false;
                        return result;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(SelectApp.prototype, "Scope", {
                    get: function () {
                        switch (document.getElementById('comboSelectScope').selectedIndex) {
                            case 2: return ViewPoint.Client.VPAdmin.WebService.Scope.Local;
                            // case 0
                            // case 1
                            default: return ViewPoint.Client.VPAdmin.WebService.Scope.Global;
                        }
                    },
                    enumerable: true,
                    configurable: true
                });
                /// <summary>
                /// Call when this page is loaded and it will try to get all applications
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SelectApp.prototype.SelectApp_Loaded = function (scope) {
                    //VPAdminUtil.GetMainPage().setCursor(Cursors.getWait()); 
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    console.assert(myApp != null);
                    var comboSelectScope = document.getElementById('comboSelectScope');
                    if (myApp.UserScope != null) {
                        if (myApp.UserScope == ViewPoint.Client.VPAdmin.WebService.Scope.Local) {
                            this.selectedAppIndex = 2;
                            myApp.CurrentFTDPlatform = ViewPoint.Client.VPAdmin.WebService.TargetPlatform.StandAlone;
                            comboSelectScope.disabled = true;
                        }
                        else {
                            this.apps = [{
                                    appType: ViewPoint.Client.VPAdmin.SelectApp.SEDistributedText, index: 0
                                },
                                {
                                    appType: ViewPoint.Client.VPAdmin.SelectApp.SEStationText, index: 1
                                }];
                            if (myApp.CurrentFTDPlatform == ViewPoint.Client.VPAdmin.WebService.TargetPlatform.StandAlone) {
                                this.selectedAppIndex = 0;
                                myApp.CurrentFTDPlatform = ViewPoint.Client.VPAdmin.WebService.TargetPlatform.Distributed;
                            }
                            this.selectedAppIndex = myApp.CurrentFTDPlatform;
                        }
                    }
                    else {
                        //incase while the first run time the scope and platform is not match.
                        if (myApp.CurrentFTDScope == VPAdmin.WebService.Scope.Local && myApp.CurrentFTDPlatform != ViewPoint.Client.VPAdmin.WebService.TargetPlatform.StandAlone)
                            myApp.CurrentFTDPlatform = ViewPoint.Client.VPAdmin.WebService.TargetPlatform.StandAlone;
                        this.selectedAppIndex = myApp.CurrentFTDPlatform;
                    }
                    //myApp.GetConnectionHelper().TryGetApplications(myApp.CurrentFTDScope,comboSelectScope.selectedIndex);
                    this.m_HasApplicationLoaded = true;
                };
                SelectApp.prototype.InitImages = function () {
                };
                /// <summary>
                /// Handle event on Scope dropdown change
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SelectApp.prototype.comboSelectScope_SelectionChanged = function (e) {
                    // don't get applications until it is completely initialize
                    if (VPAdmin.VPAdminUtil.GetMainPage() != null && this.sendEvents) {
                        var myApp = VPAdmin.Application.GetViewPointAdminApp();
                        console.assert(myApp != null);
                        var selScope = ViewPoint.Client.VPAdmin.WebService.Scope.Global;
                        var comboSelectScope = document.getElementById('comboSelectScope');
                        var selPlatform = ViewPoint.Client.VPAdmin.WebService.TargetPlatform.Distributed;
                        if (comboSelectScope.selectedIndex == 0) {
                            selScope = ViewPoint.Client.VPAdmin.WebService.Scope.Global;
                            selPlatform = ViewPoint.Client.VPAdmin.WebService.TargetPlatform.Distributed;
                        }
                        else if (comboSelectScope.selectedIndex == 1) {
                            selScope = ViewPoint.Client.VPAdmin.WebService.Scope.Global;
                            selPlatform = ViewPoint.Client.VPAdmin.WebService.TargetPlatform.Station;
                        }
                        else if (comboSelectScope.selectedIndex == 2) {
                            selScope = ViewPoint.Client.VPAdmin.WebService.Scope.Local;
                            selPlatform = ViewPoint.Client.VPAdmin.WebService.TargetPlatform.StandAlone;
                        }
                        // Setting the Scope proerty here will fire an envent that will update a bunch of banners
                        myApp.CurrentFTDScope = selScope;
                        myApp.CurrentFTDPlatform = selPlatform;
                        // myApp.GetConnectionHelper().TryGetApplications(this.Scope,selPlatform,true);
                    }
                };
                /// <summary>
                /// Call back function when getting application web call is finished
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                ///
                SelectApp.prototype.LoadApplicationServiceCompleted = function (sender, e) {
                    var myApp = VPAdmin.Application.GetViewPointAdminApp();
                    if (e.getCancelled()) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpCancelMsg");
                        msg = helpers.Format(msg, "LoadApplicationService");
                        helpers.showErrorMessage(msg);
                        return;
                    }
                    if (e.getError() != null) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpErrorMsg");
                        msg = helpers.Format(msg, "LoadApplicationService");
                        var sb = new String(msg);
                        sb = sb.concat(e.getError().message);
                        sb = sb.concat(e.getError().getStackTrace());
                        helpers.showErrorMessage(sb.toString());
                        return;
                    }
                    if (e.getFTDServerComputerName()) {
                        myApp.CurrentFTDServerName = e.getFTDServerComputerName();
                    }
                    var comboSelectScope = document.getElementById('comboSelectScope');
                    var comboSelectApplication = document.getElementById('comboSelectApplication');
                    if (e.getResult() != ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        if (e.geterrorMessage()) {
                            ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(e.geterrorMessage());
                        }
                        else {
                            var errorMsg = VPAdmin.VPAdminUtil.GetString("msgResultUnableToLoadApplication"); //"There are no '{0}' applications in the directory."; /*TODO Resource.getmsgResultUnableToLoadApplication();*/
                            errorMsg = helpers.Format(errorMsg, comboSelectScope[comboSelectScope.selectedIndex].textContent);
                            ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(errorMsg);
                        }
                        return;
                    }
                    // This next bit of code sets the selected item in the Applications
                    // combobox to be the last currently selected application  fropm a previous
                    // session.
                    if (e.getcurrentApplication()) {
                        var i = 0;
                        for (var index = 0; index < comboSelectApplication.options.length; index++) {
                            if (helpers.Compare(e.getcurrentApplication(), comboSelectApplication.options[index].value, false, false, true) == 0) {
                                comboSelectApplication.selectedIndex = i;
                                break;
                            }
                            i++;
                        }
                        myApp.CurrentFTDApplication = e.getcurrentApplication();
                    }
                    else {
                        comboSelectApplication.selectedIndex = 0;
                        var itm = comboSelectApplication.options[0];
                        myApp.CurrentFTDApplication = itm.value;
                    }
                    this.m_HasApplicationLoaded = true;
                    comboSelectApplication.disabled = false;
                    document.getElementById("nextArrow").style.visibility = "visible";
                    this.appNames = e.getapplicationNames();
                };
                SelectApp.selectAppClass = null;
                SelectApp.SEStationText = "Site Edition (Network Station)";
                SelectApp.SEDistributedText = "Site Edition (Network Distributed)";
                return SelectApp;
            }());
            VPAdmin.SelectApp = SelectApp;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var SelectDisplays = /** @class */ (function () {
                /*OnBack;
                OnNext;
                OnTabChanged;*/
                function SelectDisplays() {
                }
                SelectDisplays.GetSelectDisplayClass = function () {
                    if (SelectDisplays.selectDisplayClass == null) {
                        SelectDisplays.selectDisplayClass = new SelectDisplays();
                    }
                    return SelectDisplays.selectDisplayClass;
                };
                SelectDisplays.prototype.InitImages = function () {
                };
                /// <summary>
                /// Call back function when getting the displays is finished
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                SelectDisplays.prototype.GetDisplaysServiceCompleted = function (sender, e) {
                    if (e.getCancelled()) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpCancelMsg");
                        msg = helpers.Format(msg, "GetDisplaysService");
                        var box = ViewPoint.Client.Toolkit.Controls.DialogBox.ShowModal(msg, ViewPoint.Client.Toolkit.Controls.MessageType.Error, ViewPoint.Client.Toolkit.Controls.DialogBoxButtons.Ok);
                        $('#' + box.DialogName).css('z-index', '1500');
                        $('body').css("cursor", "default");
                        return;
                    }
                    if (e.getError() != null) {
                        var msg = VPAdmin.VPAdminUtil.GetString("helpErrorMsg");
                        msg = helpers.Format(msg, "GetDisplaysService");
                        var sb = new String(msg);
                        sb.concat(e.getError().message);
                        sb.concat(e.getError().getStackTrace());
                        var box = ViewPoint.Client.Toolkit.Controls.DialogBox.ShowModal(sb.toString(), ViewPoint.Client.Toolkit.Controls.MessageType.Error, ViewPoint.Client.Toolkit.Controls.DialogBoxButtons.Ok);
                        $('#' + box.DialogName).css('z-index', '1500');
                        $('body').css("cursor", "default");
                        return;
                    }
                    if (e.getResult() != ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        if (e.geterrorMessage()) {
                            var box = ViewPoint.Client.Toolkit.Controls.DialogBox.ShowModal(e.geterrorMessage(), ViewPoint.Client.Toolkit.Controls.MessageType.Error, ViewPoint.Client.Toolkit.Controls.DialogBoxButtons.Ok);
                            $('#' + box.DialogName).css('z-index', '1500');
                        }
                        else {
                            var box = ViewPoint.Client.Toolkit.Controls.DialogBox.ShowModal(ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode[e.getResult()], ViewPoint.Client.Toolkit.Controls.MessageType.Error, ViewPoint.Client.Toolkit.Controls.DialogBoxButtons.Ok);
                            $('#' + box.DialogName).css('z-index', '1500');
                        }
                        $('body').css("cursor", "default");
                        return;
                    }
                };
                SelectDisplays.selectDisplayClass = null;
                return SelectDisplays;
            }());
            VPAdmin.SelectDisplays = SelectDisplays;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var WebServer = /** @class */ (function () {
                function WebServer() {
                    this.bannerControlService = null;
                    this.remove = "";
                    this.removing = "";
                    WebServer.helpUrl = VPAdmin.VPAdminUtil.CreateHelpLink(VPAdmin.VPAdminUtil.GetString("lpSvrLearn_url"));
                }
                WebServer.GetWebServerClass = function () {
                    if (WebServer.webServerClass == null) {
                        WebServer.webServerClass = new WebServer();
                    }
                    document.getElementById('lpSvrLearn').href = WebServer.helpUrl;
                    return WebServer.webServerClass;
                };
                WebServer.prototype.Init = function () {
                    var localComputerName = window.location.host;
                    var webprotocol = window.location.protocol;
                    if (localComputerName) {
                        document.getElementById('lbWebserverName').textContent = localComputerName;
                        document.getElementById('lbBaseURL').textContent = webprotocol + "//" + localComputerName + "/FTVP";
                    }
                    var port = window.location.port;
                    document.getElementById('lbClientPort').textContent = !port ? "80" : port;
                };
                /// <summary>
                /// Load configuartion when initializing the page
                /// </summary>
                WebServer.prototype.LoadConfigurations = function (Services) {
                    this.ChangeApplyAndDiscardButtonsStatus(true);
                    $('body').css("cursor", "wait");
                    Services.GetServerSettingConfigurations(this, this.LoadServerSettingConfigurationsCompleted);
                };
                /// <summary>
                /// Reload configuartion by clicking the discard button.
                /// </summary>
                WebServer.prototype.ReloadConfigurations = function (Services) {
                    this.ChangeApplyAndDiscardButtonsStatus(true);
                    $('body').css("cursor", "wait");
                    Services.GetServerSettingConfigurations(this, this.ReloadServerSettingConfigurationsCompleted);
                };
                /// <summary>
                /// Handler function after calling GetServerSettingConfigurations for reload configuartion by clicking the discard button.
                /// It will do some error checking and GetServerSettingConfigurations() to assign value to fields on screen
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                WebServer.prototype.ReloadServerSettingConfigurationsCompleted = function (sender, e, status) {
                    $('body').css("cursor", "default");
                    if (e.getCancelled()) {
                        this.ShowsStatusMessage(true, false, '');
                        return;
                    }
                    if (e.getError() != null) {
                        this.ShowsStatusMessage(true, false, '');
                        return;
                    }
                    if (e.getResult() != ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        this.ShowsStatusMessage(true, false, '');
                    }
                    else {
                        this.AssignGetServerSettingConfigurations(sender, e, status);
                        var message = VPAdmin.VPAdminUtil.GetString('msgWebServerDiscardServerConfigSuccess');
                        this.ShowsStatusMessage(true, true, message);
                    }
                };
                /// <summary>
                /// Handler function after calling GetServerSettingConfigurations by initing the page.
                /// It will do some error checking and GetServerSettingConfigurations() to assign value to fields on screen
                /// </summary>
                /// <param name="sender"></param>
                /// <param name="e"></param>
                WebServer.prototype.LoadServerSettingConfigurationsCompleted = function (sender, e, status) {
                    $('body').css("cursor", "default");
                    if (e.getCancelled()) {
                        this.ShowsStatusMessage(true, false, '');
                        return;
                    }
                    if (e.getError() != null) {
                        this.ShowsStatusMessage(true, false, '');
                        return;
                    }
                    if (e.getResult() != ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        this.ShowsStatusMessage(true, false, '');
                    }
                    else {
                        this.AssignGetServerSettingConfigurations(sender, e, status);
                    }
                };
                WebServer.prototype.AssignGetServerSettingConfigurations = function (sender, data, status) {
                    var enableInactivityTime = data.getEnableInactivityTime().toLowerCase() === 'true';
                    var enableAutomaticPublish = data.getEnableAutomaticPublish().toLowerCase() === 'true';
                    var automaticPublishRate = data.getAutomaticPublishRate();
                    var inactivityPeriod = data.getInactivityPeriod();
                    var liveDataPollingRate = data.getLiveDataPollingRate();
                    var enableStatusBar = data.getEnableStatusBar().toLowerCase() === 'true';
                    var enableBanner = data.getEnableBanner().toLowerCase() === 'true';
                    this.GetHTMLInputElement('enableInactivityTimeoutChxBox').checked = enableInactivityTime;
                    this.GetHTMLInputElement('inactivityPeriodTextBox').value = inactivityPeriod.toString();
                    if (enableInactivityTime) {
                        this.GetHTMLInputElement('inactivityPeriodTextBox').disabled = false;
                    }
                    else {
                        this.GetHTMLInputElement('inactivityPeriodTextBox').disabled = true;
                    }
                    this.GetHTMLInputElement('enableAutomaticPublishChxBox').checked = enableAutomaticPublish;
                    this.GetHTMLInputElement('automaticPublishRateTextBox').value = automaticPublishRate.toString();
                    if (enableAutomaticPublish) {
                        this.GetHTMLInputElement('automaticPublishRateTextBox').disabled = false;
                    }
                    else {
                        this.GetHTMLInputElement('automaticPublishRateTextBox').disabled = true;
                    }
                    this.GetHTMLInputElement('liveDataPollingRateTextBox').value = liveDataPollingRate.toString();
                    this.GetHTMLInputElement('enableStatusBarChxBox').checked = enableStatusBar;
                    this.GetHTMLInputElement('enableBannerChxBox').checked = enableBanner;
                };
                /// <summary>
                /// Handler mouse click of Apply button to apply configurations to the server.
                /// </summary>
                WebServer.prototype.ApplyButtonClick = function (Services) {
                    var enableInactivityTimeoutChxBox = this.GetHTMLInputElement('enableInactivityTimeoutChxBox');
                    var inactivityPeriodTimeoutTextBox = this.GetHTMLInputElement('inactivityPeriodTextBox');
                    var enableAutomaticPublishChxBox = this.GetHTMLInputElement('enableAutomaticPublishChxBox');
                    var automaticPublishRateTextBox = this.GetHTMLInputElement('automaticPublishRateTextBox');
                    var liveDataPollingRateTextBox = this.GetHTMLInputElement('liveDataPollingRateTextBox');
                    var enableStatusBarChxBox = this.GetHTMLInputElement('enableStatusBarChxBox');
                    var enableBannerChxBox = this.GetHTMLInputElement('enableBannerChxBox');
                    var enableInactivityTimeout = enableInactivityTimeoutChxBox.checked;
                    var inactivityPeriod = inactivityPeriodTimeoutTextBox.value;
                    var enableAutomaticPublish = enableAutomaticPublishChxBox.checked;
                    var automaticPublishRate = automaticPublishRateTextBox.value;
                    var liveDataPollingRate = liveDataPollingRateTextBox.value;
                    var enableStatusBar = enableStatusBarChxBox.checked;
                    var enableBanner = enableBannerChxBox.checked;
                    $('body').css("cursor", "wait");
                    Services.SetServerSettingConfigurations(this, this.SetServerSettingConfigurationsCompleted, enableInactivityTimeout, enableAutomaticPublish, automaticPublishRate, inactivityPeriod, liveDataPollingRate, enableStatusBar, enableBanner);
                };
                WebServer.prototype.SetServerSettingConfigurationsCompleted = function (sender, e) {
                    $('body').css("cursor", "default");
                    if (e.getCancelled()) {
                        this.ShowsStatusMessage(true, false, '');
                        return;
                    }
                    if (e.getError() != null) {
                        this.ShowsStatusMessage(true, false, '');
                        return;
                    }
                    if (e.getResult() != ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        this.ShowsStatusMessage(true, false, '');
                    }
                    else {
                        this.SetServerSettingConfigurationsSuccess(sender, e, status);
                    }
                };
                WebServer.prototype.SetServerSettingConfigurationsSuccess = function (sender, data, status) {
                    this.ChangeApplyAndDiscardButtonsStatus(true);
                    var message = VPAdmin.VPAdminUtil.GetString('msgWebServerApplyServerConfigSuccess');
                    this.ShowsStatusMessage(true, true, message);
                };
                /// <summary>
                /// Handler function after textbox got focus
                /// </summary>
                WebServer.prototype.AssignTextBoxGotFocus = function () {
                    this.ChangeApplyAndDiscardButtonsStatus(false);
                };
                /// <summary>
                /// Handler function after clicking the checkbox of enable inactivity timeout.
                /// </summary>
                WebServer.prototype.EnableInactivityTimeoutCheckBoxClicked = function () {
                    var enableInactivityTimeoutChxBox = this.GetHTMLInputElement('enableInactivityTimeoutChxBox');
                    var inactivityPeriodTextBox = this.GetHTMLInputElement('inactivityPeriodTextBox');
                    var enableInactivityTimeout = enableInactivityTimeoutChxBox.checked;
                    if (enableInactivityTimeout) {
                        inactivityPeriodTextBox.disabled = false;
                    }
                    else {
                        inactivityPeriodTextBox.disabled = true;
                    }
                    this.ChangeApplyAndDiscardButtonsStatus(false);
                };
                /// <summary>
                /// Handler function after clicking the checkbox of enable status bar.
                /// </summary>
                WebServer.prototype.EnableStatusBarCheckBoxClicked = function () {
                    this.ChangeApplyAndDiscardButtonsStatus(false);
                };
                /// <summary>
                /// Handler function after clicking the checkbox of enable banner.
                /// </summary>
                WebServer.prototype.EnableBannerCheckBoxClicked = function () {
                    this.ChangeApplyAndDiscardButtonsStatus(false);
                };
                /// <summary>
                /// Handler function after clicking the checkbox of enable automatic publish timeout.
                /// </summary>
                WebServer.prototype.EnableAutomaticPublishCheckBoxClicked = function () {
                    var enableAutomaticPublishChxBox = this.GetHTMLInputElement('enableAutomaticPublishChxBox');
                    var automaticPublishRateTextBox = this.GetHTMLInputElement('automaticPublishRateTextBox');
                    var enableAutomaticPublish = enableAutomaticPublishChxBox.checked;
                    if (enableAutomaticPublish) {
                        automaticPublishRateTextBox.disabled = false;
                    }
                    else {
                        automaticPublishRateTextBox.disabled = true;
                    }
                    this.ChangeApplyAndDiscardButtonsStatus(false);
                };
                WebServer.prototype.ReleaseVPViewClientButtonClick = function (Services, BannerControlService, remove, removing) {
                    this.bannerControlService = BannerControlService;
                    this.remove = remove;
                    this.removing = removing;
                    var vpAdminApp = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp();
                    var clientIdentifier = vpAdminApp.GetConnectionHelper().m_ClientIdentifier;
                    this.ChangeReleaseVPViewClientButtonAndLabelStatus(true);
                    Services.ReleaseVPViewClient(this, this.ReleaseVPViewClientButtonClickCallback, clientIdentifier, "");
                };
                WebServer.prototype.ReleaseVPViewClientButtonClickCallback = function (sender, e) {
                    this.ChangeReleaseVPViewClientButtonAndLabelStatus(false);
                    if (e.getResult() == ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode.Success) {
                        this.bannerControlService.SelectedAppName = "";
                        this.bannerControlService.SelectedAppType = "";
                    }
                };
                WebServer.prototype.ChangeReleaseVPViewClientButtonAndLabelStatus = function (isDisable) {
                    var releaseVPViewClientButton = document.getElementById('releaseVPViewClient');
                    releaseVPViewClientButton.disabled = isDisable;
                    if (isDisable) {
                        $('body').css("cursor", "wait");
                        releaseVPViewClientButton.textContent = this.removing;
                    }
                    else {
                        $('body').css("cursor", "default");
                        releaseVPViewClientButton.textContent = this.remove;
                    }
                };
                WebServer.prototype.ChangeApplyAndDiscardButtonsStatus = function (isDisable) {
                    var webServerConfigApplyButton = document.getElementById('webServerConfigApplyButton');
                    var webServerConfigDiscardButton = document.getElementById('webServerConfigDiscardButton');
                    webServerConfigApplyButton.disabled = isDisable;
                    webServerConfigDiscardButton.disabled = isDisable;
                    if (!isDisable) {
                        this.ShowsStatusMessage(false, false, '');
                    }
                };
                WebServer.prototype.GetHTMLInputElement = function (id) {
                    return document.getElementById(id);
                };
                WebServer.prototype.ShowsStatusMessage = function (isShow, isSuccess, message) {
                    var messageElement = document.getElementById('operationStatusMessage');
                    if (isShow) {
                        messageElement.style.visibility = 'visible';
                        if (isSuccess) {
                            messageElement.style.color = 'black';
                        }
                        else {
                            messageElement.style.color = '#EE1F23';
                        }
                        messageElement.textContent = message;
                    }
                    else {
                        messageElement.style.visibility = 'collapse';
                    }
                };
                WebServer.webServerClass = null;
                WebServer.helpUrl = "";
                return WebServer;
            }());
            VPAdmin.WebServer = WebServer;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var utils;
(function (utils) {
    var dictionary = /** @class */ (function () {
        function dictionary() {
            this.length = 0;
            this.length = 0;
            this.items = new Array();
        }
        dictionary.prototype.removeItem = function (in_key) {
            var tmp_previous;
            if (typeof (this.items[in_key]) != 'undefined') {
                this.length--;
                var tmp_previous = this.items[in_key];
                delete this.items[in_key];
            }
            return tmp_previous;
        };
        dictionary.prototype.getItem = function (in_key) {
            return this.items[in_key];
        };
        dictionary.prototype.setItem = function (in_key, in_value) {
            var tmp_previous;
            if (typeof (in_value) != 'undefined') {
                if (typeof (this.items[in_key]) == 'undefined') {
                    this.length++;
                }
                else {
                    tmp_previous = this.items[in_key];
                }
                this.items[in_key] = in_value;
            }
            return tmp_previous;
        };
        dictionary.prototype.hasItem = function (in_key) {
            return typeof (this.items[in_key]) != 'undefined';
        };
        dictionary.prototype.clear = function () {
            for (var i in this.items) {
                delete this.items[i];
            }
            this.length = 0;
        };
        dictionary.prototype.TryGetValue = function (key, value) {
            value = this.getItem(key);
            return {
                refs: [value],
                result: value != undefined
            };
        };
        return dictionary;
    }());
    utils.dictionary = dictionary;
})(utils || (utils = {}));
/// <reference path="../../helpers/utils/dictionary.ts" />
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var IDs;
            (function (IDs) {
                // Resource
                IDs[IDs["Analysing"] = 0] = "Analysing";
                IDs[IDs["betaMessage"] = 1] = "betaMessage";
                IDs[IDs["btnCancel"] = 2] = "btnCancel";
                IDs[IDs["btnGo"] = 3] = "btnGo";
                IDs[IDs["btnOpenApplication"] = 4] = "btnOpenApplication";
                IDs[IDs["btnPublish"] = 5] = "btnPublish";
                IDs[IDs["cancel"] = 6] = "cancel";
                IDs[IDs["Cancelled"] = 7] = "Cancelled";
                IDs[IDs["cbForceRepublish"] = 8] = "cbForceRepublish";
                IDs[IDs["disable"] = 9] = "disable";
                IDs[IDs["disabled"] = 10] = "disabled";
                IDs[IDs["enable"] = 11] = "enable";
                IDs[IDs["enabled"] = 12] = "enabled";
                IDs[IDs["Gft2XamlConversion"] = 13] = "Gft2XamlConversion";
                IDs[IDs["gridColAdmin"] = 14] = "gridColAdmin";
                IDs[IDs["gridColDesc"] = 15] = "gridColDesc";
                IDs[IDs["gridColInitial"] = 16] = "gridColInitial";
                IDs[IDs["gridColName"] = 17] = "gridColName";
                IDs[IDs["gridColSelect"] = 18] = "gridColSelect";
                IDs[IDs["gridColStatus"] = 19] = "gridColStatus";
                IDs[IDs["gridColUserName"] = 20] = "gridColUserName";
                IDs[IDs["gridColViewer"] = 21] = "gridColViewer";
                IDs[IDs["h1Activation"] = 22] = "h1Activation";
                IDs[IDs["h2Activation"] = 23] = "h2Activation";
                IDs[IDs["helpCancelMsg"] = 24] = "helpCancelMsg";
                IDs[IDs["helperError"] = 25] = "helperError";
                IDs[IDs["helpErrorMsg"] = 26] = "helpErrorMsg";
                IDs[IDs["helpLink_url"] = 27] = "helpLink_url";
                IDs[IDs["hpActivationMessage"] = 28] = "hpActivationMessage";
                IDs[IDs["hpIntroduction"] = 29] = "hpIntroduction";
                IDs[IDs["hpLearnButton"] = 30] = "hpLearnButton";
                IDs[IDs["hpLearnTask"] = 31] = "hpLearnTask";
                IDs[IDs["hpLearnTitle"] = 32] = "hpLearnTitle";
                IDs[IDs["hpMainTitle"] = 33] = "hpMainTitle";
                IDs[IDs["hpNoButton"] = 34] = "hpNoButton";
                IDs[IDs["hpStartButton"] = 35] = "hpStartButton";
                IDs[IDs["hpStartTask"] = 36] = "hpStartTask";
                IDs[IDs["hpStartTitle"] = 37] = "hpStartTitle";
                IDs[IDs["hpYesButton"] = 38] = "hpYesButton";
                IDs[IDs["interrupted"] = 39] = "interrupted";
                IDs[IDs["lbl1Activation"] = 40] = "lbl1Activation";
                IDs[IDs["lbl2Activation"] = 41] = "lbl2Activation";
                IDs[IDs["lbl3Activation"] = 42] = "lbl3Activation";
                IDs[IDs["lbl4Activation"] = 43] = "lbl4Activation";
                IDs[IDs["lblActivation"] = 44] = "lblActivation";
                IDs[IDs["lblBannerAppName"] = 45] = "lblBannerAppName";
                IDs[IDs["lblBannerAppType"] = 46] = "lblBannerAppType";
                IDs[IDs["lblBannerDirectory"] = 47] = "lblBannerDirectory";
                IDs[IDs["lblErrors"] = 48] = "lblErrors";
                IDs[IDs["lblSelectSec"] = 49] = "lblSelectSec";
                IDs[IDs["lblSelectWeb"] = 50] = "lblSelectWeb";
                IDs[IDs["lblStatus"] = 51] = "lblStatus";
                IDs[IDs["lblTest"] = 52] = "lblTest";
                IDs[IDs["learnMore"] = 53] = "learnMore";
                IDs[IDs["learnMore_url"] = 54] = "learnMore_url";
                IDs[IDs["LicenseString1"] = 55] = "LicenseString1";
                IDs[IDs["LicenseString2"] = 56] = "LicenseString2";
                IDs[IDs["lpActivationLearn"] = 57] = "lpActivationLearn";
                IDs[IDs["lpActivationLearn_url"] = 58] = "lpActivationLearn_url";
                IDs[IDs["lpAppLearn"] = 59] = "lpAppLearn";
                IDs[IDs["lpAppLearn_url"] = 60] = "lpAppLearn_url";
                IDs[IDs["lpAppLearnSelectDisplay"] = 61] = "lpAppLearnSelectDisplay";
                IDs[IDs["lpAppLearnSelectDisplay_url"] = 62] = "lpAppLearnSelectDisplay_url";
                IDs[IDs["lpAppPublish"] = 63] = "lpAppPublish";
                IDs[IDs["lpAppSelect"] = 64] = "lpAppSelect";
                IDs[IDs["lpAppSelectDisplay"] = 65] = "lpAppSelectDisplay";
                IDs[IDs["lpAppTaskWebReady"] = 66] = "lpAppTaskWebReady";
                IDs[IDs["lpPubLearn"] = 67] = "lpPubLearn";
                IDs[IDs["lpPubLearn_url"] = 68] = "lpPubLearn_url";
                IDs[IDs["lpSecurityLearn"] = 69] = "lpSecurityLearn";
                IDs[IDs["lpSvrLearn"] = 70] = "lpSvrLearn";
                IDs[IDs["lpSvrLearn_url"] = 71] = "lpSvrLearn_url";
                IDs[IDs["lpWhatIsThis"] = 72] = "lpWhatIsThis";
                IDs[IDs["lpWhatIsThis_url"] = 73] = "lpWhatIsThis_url";
                IDs[IDs["Manifest"] = 74] = "Manifest";
                IDs[IDs["msgActivationAssignNotEnough"] = 75] = "msgActivationAssignNotEnough";
                IDs[IDs["msgActivationAssignNotEnoughNone"] = 76] = "msgActivationAssignNotEnoughNone";
                IDs[IDs["msgActivationAssignNotEnoughSingle"] = 77] = "msgActivationAssignNotEnoughSingle";
                IDs[IDs["msgActivationAssignSuccess"] = 78] = "msgActivationAssignSuccess";
                IDs[IDs["msgActivationCanNotRelease"] = 79] = "msgActivationCanNotRelease";
                IDs[IDs["msgActivationGetSuccess"] = 80] = "msgActivationGetSuccess";
                IDs[IDs["msgActivationInputEmpty"] = 81] = "msgActivationInputEmpty";
                IDs[IDs["msgActivationInputInvalid"] = 82] = "msgActivationInputInvalid";
                IDs[IDs["msgActivationInputTooLarger"] = 83] = "msgActivationInputTooLarger";
                IDs[IDs["msgGracePeriodExpired"] = 84] = "msgGracePeriodExpired";
                IDs[IDs["msgGracePeriodPart1"] = 85] = "msgGracePeriodPart1";
                IDs[IDs["msgGracePeriodPart2"] = 86] = "msgGracePeriodPart2";
                IDs[IDs["msgMessageBoxHeader"] = 87] = "msgMessageBoxHeader";
                IDs[IDs["msgNoApplicationSelected"] = 88] = "msgNoApplicationSelected";
                IDs[IDs["msgNotAvailable"] = 89] = "msgNotAvailable";
                IDs[IDs["msgResultUnableToLoadApplication"] = 90] = "msgResultUnableToLoadApplication";
                IDs[IDs["NewPublish"] = 91] = "NewPublish";
                IDs[IDs["None"] = 92] = "None";
                IDs[IDs["noStartUpDisplay"] = 93] = "noStartUpDisplay";
                IDs[IDs["progress1"] = 94] = "progress1";
                IDs[IDs["progress2"] = 95] = "progress2";
                IDs[IDs["progress3"] = 96] = "progress3";
                IDs[IDs["progress4"] = 97] = "progress4";
                IDs[IDs["progress5"] = 98] = "progress5";
                IDs[IDs["progress6"] = 99] = "progress6";
                IDs[IDs["publish"] = 100] = "publish";
                IDs[IDs["publishNetworkError"] = 101] = "publishNetworkError";
                IDs[IDs["rpAppButtonActivationApply"] = 102] = "rpAppButtonActivationApply";
                IDs[IDs["rpAppButtonPublish"] = 103] = "rpAppButtonPublish";
                IDs[IDs["rpAppButtonSelectApp"] = 104] = "rpAppButtonSelectApp";
                IDs[IDs["rpAppButtonSelectDisplay"] = 105] = "rpAppButtonSelectDisplay";
                IDs[IDs["rpAppButtonSelectDisplayBack"] = 106] = "rpAppButtonSelectDisplayBack";
                IDs[IDs["rpAppGridSelectDisplay"] = 107] = "rpAppGridSelectDisplay";
                IDs[IDs["rpAppInitialDisplay"] = 108] = "rpAppInitialDisplay";
                IDs[IDs["rpAppSelect"] = 109] = "rpAppSelect";
                IDs[IDs["rpAppSelectType"] = 110] = "rpAppSelectType";
                IDs[IDs["rpPubViewError"] = 111] = "rpPubViewError";
                IDs[IDs["rpSvrBaseURL"] = 112] = "rpSvrBaseURL";
                IDs[IDs["rpSvrClientPort"] = 113] = "rpSvrClientPort";
                IDs[IDs["rpSvrWebserverName"] = 114] = "rpSvrWebserverName";
                IDs[IDs["tbAbout"] = 115] = "tbAbout";
                IDs[IDs["tbActivation"] = 116] = "tbActivation";
                IDs[IDs["tbApp1"] = 117] = "tbApp1";
                IDs[IDs["tbApp2"] = 118] = "tbApp2";
                IDs[IDs["tbHome"] = 119] = "tbHome";
                IDs[IDs["tbPublish"] = 120] = "tbPublish";
                IDs[IDs["tbSecurity"] = 121] = "tbSecurity";
                IDs[IDs["tbServer"] = 122] = "tbServer";
                IDs[IDs["Uploading"] = 123] = "Uploading";
                IDs[IDs["UploadingCompleted"] = 124] = "UploadingCompleted";
                IDs[IDs["WinHeader"] = 125] = "WinHeader";
                IDs[IDs["WinHeaderBETA"] = 126] = "WinHeaderBETA";
                IDs[IDs["Xaml2RamleConvertion"] = 127] = "Xaml2RamleConvertion";
                // ResourceSecurity
                IDs[IDs["btnAddUser"] = 128] = "btnAddUser";
                IDs[IDs["btnDiscard"] = 129] = "btnDiscard";
                IDs[IDs["btnSave"] = 130] = "btnSave";
                IDs[IDs["cbAdminAuthRequired"] = 131] = "cbAdminAuthRequired";
                IDs[IDs["cbAllAuthRequired"] = 132] = "cbAllAuthRequired";
                IDs[IDs["cbWriteEnable"] = 133] = "cbWriteEnable";
                IDs[IDs["cpAdminAuthTooltip"] = 134] = "cpAdminAuthTooltip";
                IDs[IDs["errDomainUserInvalid"] = 135] = "errDomainUserInvalid";
                IDs[IDs["errDuplicateUser"] = 136] = "errDuplicateUser";
                IDs[IDs["errUserEmpty"] = 137] = "errUserEmpty";
                IDs[IDs["errUserInvalid"] = 138] = "errUserInvalid";
                IDs[IDs["gridColAdministrator"] = 139] = "gridColAdministrator";
                IDs[IDs["gridColGroup"] = 140] = "gridColGroup";
                IDs[IDs["gridColUser"] = 141] = "gridColUser";
                IDs[IDs["gridColViewer_Security"] = 142] = "gridColViewer_Security";
                IDs[IDs["groupFactoryTalk"] = 143] = "groupFactoryTalk";
                IDs[IDs["groupWindowsLinked"] = 144] = "groupWindowsLinked";
                IDs[IDs["lbGroupUser"] = 145] = "lbGroupUser";
                IDs[IDs["lbSecDisplays"] = 146] = "lbSecDisplays";
                IDs[IDs["lpAddUserToGroup"] = 147] = "lpAddUserToGroup";
                IDs[IDs["lpAddWindowsLinkedUser"] = 148] = "lpAddWindowsLinkedUser";
                IDs[IDs["lpSecLearn_Url"] = 149] = "lpSecLearn_Url";
                IDs[IDs["lpTypeDomainUser"] = 150] = "lpTypeDomainUser";
                IDs[IDs["lpUserLogInfo"] = 151] = "lpUserLogInfo";
                IDs[IDs["txtWriteEnable"] = 152] = "txtWriteEnable";
                // ResourceSession
                IDs[IDs["CookiesDisabledPageContents"] = 153] = "CookiesDisabledPageContents";
                IDs[IDs["CookiesDisabledPageHeading"] = 154] = "CookiesDisabledPageHeading";
                IDs[IDs["ServerInUseNoHostPageContents"] = 155] = "ServerInUseNoHostPageContents";
                IDs[IDs["ServerInUseNoUserOrHostPageContents"] = 156] = "ServerInUseNoUserOrHostPageContents";
                IDs[IDs["ServerInUseNoUserPageContents"] = 157] = "ServerInUseNoUserPageContents";
                IDs[IDs["ServerInUsePageContents"] = 158] = "ServerInUsePageContents";
                IDs[IDs["ServerInUsePageHeading"] = 159] = "ServerInUsePageHeading";
                IDs[IDs["ServerNotAvailablePageContents"] = 160] = "ServerNotAvailablePageContents";
                IDs[IDs["ServerNotAvailablePageHeading"] = 161] = "ServerNotAvailablePageHeading";
                // ResourceAbout
                IDs[IDs["AboutCompany"] = 162] = "AboutCompany";
                IDs[IDs["AboutProduct"] = 163] = "AboutProduct";
                IDs[IDs["AboutTrademark"] = 164] = "AboutTrademark";
                IDs[IDs["AboutCopyright"] = 165] = "AboutCopyright";
                // ResourceHelp
                IDs[IDs["RootDirectory"] = 166] = "RootDirectory";
                // Warning message for the Administracion Security checked
                IDs[IDs["lpSecurityWarining"] = 167] = "lpSecurityWarining";
                IDs[IDs["lpSecurityWarningLink_url"] = 168] = "lpSecurityWarningLink_url";
                IDs[IDs["mobileEnable"] = 169] = "mobileEnable";
                IDs[IDs["lpReleaseNote"] = 170] = "lpReleaseNote";
                IDs[IDs["lpReleaseNote_url"] = 171] = "lpReleaseNote_url";
                IDs[IDs["btnPublishWebM"] = 172] = "btnPublishWebM";
                IDs[IDs["mobileWeb_url"] = 173] = "mobileWeb_url";
                IDs[IDs["h2WebServer"] = 174] = "h2WebServer";
                IDs[IDs["lbWebServerInactivityPeriod"] = 175] = "lbWebServerInactivityPeriod";
                IDs[IDs["lbWebServerInactivityPeriodUnit"] = 176] = "lbWebServerInactivityPeriodUnit";
                IDs[IDs["lbWebServerLiveDataPollingRate"] = 177] = "lbWebServerLiveDataPollingRate";
                IDs[IDs["lbWebServerLiveDataPollingRateUnit"] = 178] = "lbWebServerLiveDataPollingRateUnit";
                IDs[IDs["lbWebServerEnableInactivityTimeout"] = 179] = "lbWebServerEnableInactivityTimeout";
                IDs[IDs["lbWebServerEnableAutomaticPublish"] = 180] = "lbWebServerEnableAutomaticPublish";
                IDs[IDs["lbWebServerAutomaticPublishRate"] = 181] = "lbWebServerAutomaticPublishRate";
                IDs[IDs["lbWebServerAutomaticPublishRateUnit"] = 182] = "lbWebServerAutomaticPublishRateUnit";
                IDs[IDs["lbWebServerServerSettingApply"] = 183] = "lbWebServerServerSettingApply";
                IDs[IDs["lbWebServerServerSettingDiscard"] = 184] = "lbWebServerServerSettingDiscard";
                IDs[IDs["lbWebServerInactivityPeriodValidRange"] = 185] = "lbWebServerInactivityPeriodValidRange";
                IDs[IDs["lbWebServerLiveDataPollingRateValidRange"] = 186] = "lbWebServerLiveDataPollingRateValidRange";
                IDs[IDs["lbWebServerAutomaticPublishRateValidRange"] = 187] = "lbWebServerAutomaticPublishRateValidRange";
                IDs[IDs["msgWebServerApplyServerConfigSuccess"] = 188] = "msgWebServerApplyServerConfigSuccess";
                IDs[IDs["msgWebServerApplyServerConfigFail"] = 189] = "msgWebServerApplyServerConfigFail";
                IDs[IDs["msgWebServerDiscardServerConfigSuccess"] = 190] = "msgWebServerDiscardServerConfigSuccess";
                IDs[IDs["msgWebServerDisacrdServerConfigFail"] = 191] = "msgWebServerDisacrdServerConfigFail";
                IDs[IDs["screenFolderPermissionReject"] = 192] = "screenFolderPermissionReject";
                IDs[IDs["lbReleaseVPViewClient"] = 193] = "lbReleaseVPViewClient";
                IDs[IDs["lbReleaseVPViewClientLabel"] = 194] = "lbReleaseVPViewClientLabel";
                IDs[IDs["lbReleaseVPViewClientRemoving"] = 195] = "lbReleaseVPViewClientRemoving";
                IDs[IDs["lblEnableStatusBar"] = 196] = "lblEnableStatusBar";
                IDs[IDs["lblEnableBanner"] = 197] = "lblEnableBanner";
            })(IDs = VPAdmin.IDs || (VPAdmin.IDs = {}));
            var Resource = /** @class */ (function () {
                function Resource() {
                }
                // Move to a resource file
                Resource.resources = [
                    // Resource
                    /* 0 */ "Analyzing",
                    /* 1 */ "This is a Beta version of the FactoryTalk ViewPoint software that cannot be used in a production environment.",
                    /* 2 */ "Cancel",
                    /* 3 */ "Go",
                    /* 4 */ "Open classic Web",
                    /* 5 */ "Re-publish",
                    /* 6 */ "Cancel",
                    /* 7 */ "Canceled",
                    /* 8 */ "Re-publish all selected displays",
                    /* 9 */ "Disable",
                    /* 10 */ "Disabled",
                    /* 11 */ "Enable",
                    /* 12 */ "Enabled",
                    /* 13 */ "Preparing",
                    /* 14 */ "Administrator",
                    /* 15 */ "Description",
                    /* 16 */ "Initial Display",
                    /* 17 */ "Name",
                    /* 18 */ "Web Enable",
                    /* 19 */ "Status",
                    /* 20 */ "User or Group",
                    /* 21 */ "Viewer",
                    /* 22 */ "FactoryTalk Activation",
                    /* 23 */ "FactoryTalk ViewPoint Server",
                    /* 24 */ "{0} action canceled",
                    /* 25 */ "Error",
                    /* 26 */ "{0} action has error(s)",
                    /* 27 */ "index.htm",
                    /* 28 */ "Type the number of licenses you want this FactoryTalk ViewPoint Server to have, and then click Apply.",
                    /* 29 */ "You are steps away from viewing displays from a FactoryTalk View application in a standard Web browser.  All you have to do is select the application, select the displays and then publish the displays to the FactoryTalk ViewPoint Server.",
                    /* 30 */ "Learn more",
                    /* 31 */ "To learn more about FactoryTalk ViewPoint before you get started, click here.",
                    /* 32 */ "Want to learn more?",
                    /* 33 */ "Welcome to FactoryTalk ViewPoint",
                    /* 34 */ "Decline",
                    /* 35 */ "Publish displays to Web",
                    /* 36 */ "To select and then publish FactoryTalk View displays to the Web, click here.",
                    /* 37 */ "Ready to get started?",
                    /* 38 */ "Accept",
                    /* 39 */ "Publishing canceled.",
                    /* 40 */ "Total number of ViewPoint licenses:",
                    /* 41 */ "Number of available ViewPoint licenses:",
                    /* 42 */ "Number of licenses to assign:",
                    /* 43 */ "Number of licenses in use:",
                    /* 44 */ "Activation",
                    /* 45 */ "Application Name:",
                    /* 46 */ "Application Type:",
                    /* 47 */ "FactoryTalk Directory:",
                    /* 48 */ "View publishing report",
                    /* 49 */ "Security Settings",
                    /* 50 */ "Server Settings",
                    /* 51 */ "Status:",
                    /* 52 */ "Connect to the FactoryTalk ViewPoint Server",
                    /* 53 */ "Learn more",
                    /* 54 */ "index.htm",
                    /* 55 */ "This software and documentation are subject to a license.",
                    /* 56 */ "In summary, Rockwell Automation, Inc. grants you a transferable license to install, and use the software on a single processing unit, and to make a copy for backup only.",
                    /* 57 */ "Learn about activation",
                    /* 58 */ "161102.htm",
                    /* 59 */ "Learn about selecting applications",
                    /* 60 */ "161107.htm",
                    /* 61 */ "Learn about selecting displays",
                    /* 62 */ "161108.htm",
                    /* 63 */ "Publish displays",
                    /* 64 */ "Select an application",
                    /* 65 */ "Select displays",
                    /* 66 */ "Follow these 3 steps to make a FactoryTalk View application Web-ready:",
                    /* 67 */ "Learn about publishing displays",
                    /* 68 */ "161197.htm",
                    /* 69 */ "Learn about security",
                    /* 70 */ "Learn about Web server",
                    /* 71 */ "196555.htm",
                    /* 72 */ "What is this?",
                    /* 73 */ "161110.htm",
                    /* 74 */ "Initializing",
                    /* 75 */ "The activation server can only provide '{0}' more licenses. '{1}' licenses are currently assigned.",
                    /* 76 */ "The activation server cannot provide any licenses. '{0}' licenses are currently assigned.",
                    /* 77 */ "The activation server can only provide '{0}' more license. '{1}' licenses are currently assigned.",
                    /* 78 */ "'{0}' licenses are currently assigned.",
                    /* 79 */ "'{0}' licenses are in use and cannot be released. '{1}' licenses are currently assigned.",
                    /* 80 */ "'{0}' licenses are currently assigned.",
                    /* 81 */ "{0} is the minimum number of licenses that can be assigned. Enter a number from {0} through '{1}.'",
                    /* 82 */ "{0} is the minimum number of licenses that can be assigned. Enter a number from {0} through '{1}.'",
                    /* 83 */ "The number entered is more than the total held at the activation server. Enter a number from {0} through '{1}.'",
                    /* 84 */ "The FactoryTalk ViewPoint Server is unable to obtain or provide any client licenses. Please ensure that the FactoryTalk Activation Server is set up to provide ViewPoint licenses.",
                    /* 85 */ "The FactoryTalk Activation server either is unavailable or has no ViewPoint licenses.",
                    /* 86 */ "The FactoryTalk ViewPoint Server can only provide three temporary client licenses for up to seven days. Please set up the activation server to provide the necessary licenses.",
                    /* 87 */ "ViewPoint Administration",
                    /* 88 */ "Select a FactoryTalk View application.",
                    /* 89 */ "N/A",
                    /* 90 */ "There are no '{0}' applications in the directory.",
                    /* 91 */ "Initializing",
                    /* 92 */ "None",
                    /* 93 */ "Select at least one display to publish.",
                    /* 94 */ "Initializing...",
                    /* 95 */ "Analyzing...",
                    /* 96 */ "Preparing...",
                    /* 97 */ "Optimizing...",
                    /* 98 */ "Checking for display updates...",
                    /* 99 */ "Publishing...",
                    /* 100 */ "Publish",
                    /* 101 */ "Unable to finish publishing. The network is disconnected. Contact your System Administrator or try publishing again later.",
                    /* 102 */ "Apply",
                    /* 103 */ "Publish displays",
                    /* 104 */ "Select an application",
                    /* 105 */ "Select graphic displays",
                    /* 106 */ "Select graphic displays",
                    /* 107 */ "Select a startup macro:",
                    /* 108 */ "Initial display name:",
                    /* 109 */ "Select the application:",
                    /* 110 */ "Select a FactoryTalk View application type:",
                    /* 111 */ "View publishing report",
                    /* 112 */ "Base URL:",
                    /* 113 */ "Web client port:",
                    /* 114 */ "Web server name:",
                    /* 115 */ "About",
                    /* 116 */ "Activation",
                    /* 117 */ "Publish Displays to Web",
                    /* 118 */ "Publish Displays to Web",
                    /* 119 */ "Home",
                    /* 120 */ "Publish Displays to Web",
                    /* 121 */ "Security Settings",
                    /* 122 */ "Server Settings",
                    /* 123 */ "Publishing",
                    /* 124 */ "Done",
                    /* 125 */ "FactoryTalk ViewPoint",
                    /* 126 */ "FactoryTalk ViewPoint (Beta)",
                    /* 127 */ "Optimizing",
                    // ResourceSecurity
                    /* 128 */ "Add User",
                    /* 129 */ "Discard",
                    /* 130 */ "Save",
                    /* 131 */ "Enable Administration Security",
                    /* 132 */ "Enable Application Security",
                    /* 133 */ "Enable Write",
                    /* 134 */ "Please add a user with Administrator rights to enable this option",
                    /* 135 */ "Unable to add '{0}'. The domain or user name is invalid, or the domain is unavailable.",
                    /* 136 */ "Unable to add '{0}'. This Windows-linked user already exists in the list.",
                    /* 137 */ "Enter a valid Windows domain and user name.",
                    /* 138 */ "Enter a valid Windows domain and user name.",
                    /* 139 */ "Administrator",
                    /* 140 */ "Group",
                    /* 141 */ "User",
                    /* 142 */ "Viewer",
                    /* 143 */ "FactoryTalk",
                    /* 144 */ "Windows-Linked",
                    /* 145 */ "Groups and Users",
                    /* 146 */ "Select Displays to edit security settings",
                    /* 147 */ "Add users to the ViewPoint Administrators or Viewers group:",
                    /* 148 */ "Add a Windows-linked user to the list:",
                    /* 149 */ "161117.htm",
                    /* 150 */ "Type the user name using the syntax Domain\User.",
                    /* 151 */ "Require users to log on to open:",
                    /* 152 */ "Application security is currently disabled.  The default display behavior for an unsecured application is read only(View permission).\r\nClick the Enable Write checkbox and then click Save to allow tag writes for all displays.",
                    // ResourceSession
                    /* 153 */ "Cookies are currently disabled in this browser. FactoryTalk ViewPoint requires cookie support. Please enable cookies using Internet Options and try again.\r\n",
                    /* 154 */ "Cookies are disabled",
                    /* 155 */ "User '{0}'  is already connected to Administration on this FactoryTalk ViewPoint Server. Only one user at a time can connect to Administration on a single ViewPoint Server.\r\n\r\nContact your System Administrator or try connecting again later.\r\n",
                    /* 156 */ "Another Web browser is already connected to Administration on this FactoryTalk ViewPoint Server. Only one user at a time can connect to Administration on a single ViewPoint Server.\r\n\r\nContact your System Administrator or try connecting again later.\r\n",
                    /* 157 */ "A Web browser on computer '{0}' is already connected to Administration on this FactoryTalk ViewPoint Server'. Only one user at a time can connect to Administration on a single ViewPoint Server.\r\n\r\nContact your System Administrator or try connecting again later.\r\n",
                    /* 158 */ "A Web browser on computer '{0}' is already connected to Administration on this FactoryTalk ViewPoint Server'. Only one user at a time can connect to Administration on a single ViewPoint Server.\r\n\r\nContact your System Administrator or try connecting again later.\r\n",
                    /* 159 */ "Unable to connect to FactoryTalk ViewPoint Administration",
                    /* 160 */ "The network is disconnected.\r\nContact your System Administrator or try connecting again later.\r\n",
                    /* 161 */ "Unable to connect to FactoryTalk ViewPoint Administration",
                    // ResourceAbout
                    /* 162 */ "Rockwell Automation Inc.",
                    /* 163 */ "FactoryTalk ® ViewPoint",
                    /* 164 */ "FactoryTalk ® ViewPoint is registered trademark of Rockwell Automation Inc.",
                    /* 165 */ "Copyright © 2020 Rockwell Automation Technologies, Inc. All rights reserved.",
                    /* 166 */ "FTVP/",
                    /* 167 */ "HTTPS is recommended for secure commnuications.",
                    /* 168 */ "276751.htm",
                    /* 169 */ "Mobile Enable",
                    /* 170 */ "Release Notes",
                    /* 171 */ "index.htm",
                    /* 172 */ "Open mobile Web",
                    /* 173 */ "/FTVP/m",
                    /* 174 */ "FactoryTalk ViewPoint Server",
                    /* 175 */ "Inactivity period:",
                    /* 176 */ "Minutes",
                    /* 177 */ "Tag update rate:",
                    /* 178 */ "Milliseconds",
                    /* 179 */ "Enable inactivity time",
                    /* 180 */ "Enable automatic display synchronization",
                    /* 181 */ "Automatic change detection rate:",
                    /* 182 */ "Minutes",
                    /* 183 */ "Apply",
                    /* 184 */ "Discard",
                    /* 185 */ "(Valid Range: 1-99)",
                    /* 186 */ "(Valid Range: 250-120000)",
                    /* 187 */ "(Valid Range: 5-60)",
                    /* 188 */ "The settings are saved and applied to the FactoryTalk ViewPoint server.",
                    /* 189 */ "Cannot apply the settings to the FactoryTalk ViewPoint server. The server may have stopped responding or the network is disconnected. Please contact your server administrator.",
                    /* 190 */ "The FactoryTalk View Point server settings are reverted to the previously saved settings.",
                    /* 191 */ "Cannot revert the FactoryTalk ViewPoint server settings to the previously saved settings. The server may have stopped responding or the network is disconnected. Please contact your server administrator.",
                    /* 192 */ "Security setting does not apply to the screen folder.",
                    /* 193 */ "Remove application",
                    /* 194 */ "Remove application from ViewPoint server",
                    /* 195 */ "Removing......",
                    /* 196 */ "Show the status bar on the classic web client",
                    /* 197 */ "Show the header bar on the classic web client"
                ];
                return Resource;
            }());
            VPAdmin.Resource = Resource;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
/// <reference path="../../helpers/utils/dictionary.ts" />
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var ResourceBinder = /** @class */ (function () {
                function ResourceBinder() {
                }
                ResourceBinder.init = function () {
                    ResourceBinder.m_Resource = new utils.dictionary();
                    for (var r in VPAdmin.Resource.resources) {
                        ResourceBinder.m_Resource.setItem(r, VPAdmin.Resource.resources[r]);
                    }
                };
                ResourceBinder.getString = function (name) {
                    if (ResourceBinder.m_Resource == null)
                        ResourceBinder.init();
                    return ResourceBinder.m_Resource.getItem(VPAdmin.IDs[name]);
                };
                ResourceBinder.getResource = function (id) {
                    if (ResourceBinder.m_Resource == null)
                        ResourceBinder.init();
                    return ResourceBinder.m_Resource.getItem(id);
                };
                ResourceBinder.getCookiesDisabledPageContents = function () {
                    if (ResourceBinder.m_Resource == null)
                        ResourceBinder.init();
                    return ResourceBinder.m_Resource.getItem(VPAdmin.IDs.CookiesDisabledPageContents);
                };
                ResourceBinder.getCookiesDisabledPageHeading = function () {
                    if (ResourceBinder.m_Resource == null)
                        ResourceBinder.init();
                    return ResourceBinder.m_Resource.getItem(VPAdmin.IDs.CookiesDisabledPageHeading);
                };
                ResourceBinder.getServerInUseNoHostPageContents = function () {
                    if (ResourceBinder.m_Resource == null)
                        ResourceBinder.init();
                    return ResourceBinder.m_Resource.getItem(VPAdmin.IDs.ServerInUseNoHostPageContents);
                };
                ResourceBinder.getServerInUseNoUserOrHostPageContents = function () {
                    if (ResourceBinder.m_Resource == null)
                        ResourceBinder.init();
                    return ResourceBinder.m_Resource.getItem(VPAdmin.IDs.ServerInUseNoUserOrHostPageContents);
                };
                ResourceBinder.getServerInUseNoUserPageContents = function () {
                    if (ResourceBinder.m_Resource == null)
                        ResourceBinder.init();
                    return ResourceBinder.m_Resource.getItem(VPAdmin.IDs.ServerInUseNoUserPageContents);
                };
                ResourceBinder.getServerInUsePageContents = function () {
                    if (ResourceBinder.m_Resource == null)
                        ResourceBinder.init();
                    return ResourceBinder.m_Resource.getItem(VPAdmin.IDs.ServerInUsePageContents);
                };
                ResourceBinder.getServerInUsePageHeading = function () {
                    if (ResourceBinder.m_Resource == null)
                        ResourceBinder.init();
                    return ResourceBinder.m_Resource.getItem(VPAdmin.IDs.ServerInUsePageHeading);
                };
                ResourceBinder.getServerNotAvailablePageContents = function () {
                    if (ResourceBinder.m_Resource == null)
                        ResourceBinder.init();
                    return ResourceBinder.m_Resource.getItem(VPAdmin.IDs.ServerNotAvailablePageContents);
                };
                ResourceBinder.getServerNotAvailablePageHeading = function () {
                    if (ResourceBinder.m_Resource == null)
                        ResourceBinder.init();
                    return ResourceBinder.m_Resource.getItem(VPAdmin.IDs.ServerNotAvailablePageHeading);
                };
                ResourceBinder.m_Resource = null;
                return ResourceBinder;
            }());
            VPAdmin.ResourceBinder = ResourceBinder;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var UserListManager = /** @class */ (function () {
                function UserListManager() {
                    this.m_UserList = new Array();
                }
                Object.defineProperty(UserListManager.prototype, "UserList", {
                    get: function () {
                        return this.m_UserList;
                    },
                    enumerable: true,
                    configurable: true
                });
                /* AIS_NOTE: unused function
                /// <summary>
                /// Group and sort user data
                /// </summary>
                SetupUserListFromXml(xmlData) {
                    if (this.m_UserList.length > 0) {
                        this.m_UserList.clear();
                    }
                    var textReader = new System.IO.StringReader(xmlData);
                    var xUserDoc = XDocument.Load(textReader);
                    var windowsUserList = new System.Collections.Generic.List();
                    var factoryTalkUserList = new System.Collections.Generic.List();
                    var windowsUserObjectList = new System.Collections.Generic.List();
                    var factoryTalkObjectList = new System.Collections.Generic.List();
                    var $it = xUserDoc.Elements("SecuritySettings").Elements("UserGroups").Nodes().GetEnumerator();
                    // Bind data grid from xml - GroupTypes
                    while ( $it.MoveNext() ) {
                        var xElUserGroup = $it.getCurrent();
                        var userGroup = xElUserGroup.Attribute("Name").getValue().trim();
                        var $it = xElUserGroup.Elements("Users").Nodes().GetEnumerator();
                        //Users
                        while ( $it.MoveNext() ) {
                            var xElUser = $it.getCurrent();
                            var name = xElUser.Attribute("Name").getValue().trim();
                            //DFCTS00220233 we want to filter this one out
                            if (name == "$AnonymousLogon") {
                                continue;
                            }
                            var user = new ViewPoint.Client.VPAdmin.User(userGroup,xElUser.Attribute("Name").getValue().trim(),Convert.ToInt16(xElUser.Attribute("Viewer").getValue()),Convert.ToInt16(xElUser.Attribute("Administrator").getValue()));
                            user.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(this.user_PropertyChanged);
                            // Windows-linked users
                            if (user.getName().Contains("\\")) {
                                windowsUserList.Add(user.getName().trim());
                                windowsUserObjectList.Add(user);
                            } else {
                                factoryTalkUserList.Add(user.getName().trim());
                                factoryTalkObjectList.Add(user);
                            }
                        }
                    }
                    this.AppendSortedUserList(windowsUserList,windowsUserObjectList);
                    this.AppendSortedUserList(factoryTalkUserList,factoryTalkObjectList);
                }*/
                UserListManager.prototype.user_PropertyChanged = function (sender, e) {
                    if (this.UserItemPropertyChanged != null) {
                        this.UserItemPropertyChanged(sender, e.getPropertyName());
                    }
                };
                return UserListManager;
            }());
            VPAdmin.UserListManager = UserListManager;
            var Group = /** @class */ (function () {
                function Group() {
                    this._Name = null;
                    this._Members = new Array();
                    this._IsSelected = false;
                }
                Object.defineProperty(Group.prototype, "Name", {
                    get: function () {
                        return this._Name;
                    },
                    set: function (value) {
                        this._Name = value;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Group.prototype, "Members", {
                    get: function () {
                        return this._Members;
                    },
                    set: function (value) {
                        this._Members = value;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Group.prototype, "IsSelected", {
                    get: function () {
                        return this._IsSelected;
                    },
                    set: function (value) {
                        this._IsSelected = value;
                    },
                    enumerable: true,
                    configurable: true
                });
                Group.prototype.SortMembers = function () {
                    this._Members.sort(function (a, b) {
                        var nameA = a._Name.toLowerCase(), nameB = b._Name.toLowerCase();
                        if (nameA < nameB)
                            return -1;
                        if (nameA > nameB)
                            return 1;
                        return 0; //default return value (no sorting)
                    });
                    this._Members.sort();
                };
                return Group;
            }());
            VPAdmin.Group = Group;
            var User = /** @class */ (function () {
                function User(group, name) {
                    this._Name = name;
                    this._Viewer = null;
                    this._Admin = null;
                    this._Membership = null;
                }
                Object.defineProperty(User.prototype, "Name", {
                    /// <summary>
                    /// Group
                    /// </summary>
                    //public string Group
                    //{
                    //    get;
                    //    set;
                    //}
                    /// <summary>
                    /// Name
                    /// </summary>
                    get: function () {
                        return this._Name;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(User.prototype, "Viewer", {
                    /// <summary>
                    /// Viewer
                    /// </summary>
                    get: function () {
                        return this._Viewer;
                    },
                    /// <summary>
                    /// Viewer
                    /// </summary>
                    set: function (value) {
                        this._Viewer = value;
                        if (this.PropertyChanged != null) {
                            this.PropertyChanged(this, "Viewer");
                        }
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(User.prototype, "Administrator", {
                    /// <summary>
                    /// Administrator
                    /// </summary>
                    get: function () {
                        return this._Admin;
                    },
                    /// <summary>
                    /// Administrator
                    /// </summary>
                    set: function (value) {
                        this._Admin = value;
                        if (this.PropertyChanged != null) {
                            this.PropertyChanged(this, "Administrator");
                        }
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(User.prototype, "Membersip", {
                    /// <summary>
                    /// Membership (Roles) this User belongs to
                    /// </summary>
                    get: function () {
                        return this._Membership;
                    },
                    /// <summary>
                    /// Membership (Roles) this User belongs to
                    /// </summary>
                    set: function (value) {
                        this._Membership = value;
                    },
                    enumerable: true,
                    configurable: true
                });
                return User;
            }());
            VPAdmin.User = User;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var UserAndGroupsManager = /** @class */ (function () {
                function UserAndGroupsManager() {
                    this.m_GroupList = new Array();
                }
                Object.defineProperty(UserAndGroupsManager.prototype, "GroupListCollection", {
                    get: function () {
                        return this.m_GroupList;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(UserAndGroupsManager.prototype, "GroupListString", {
                    get: function () {
                        var strList = new Array();
                        var groups = this.GroupListCollection;
                        for (var i = 0; i < groups.length; i++) {
                            var gp = groups[i];
                            strList.push(gp.Name);
                        }
                        return strList;
                    },
                    enumerable: true,
                    configurable: true
                });
                /// <summary>
                /// Group and sort user data
                /// </summary>
                UserAndGroupsManager.prototype.SetupUsersAndGroupsFromXml = function (xmlData, bAllowUsers) {
                    if (this.m_GroupList.length > 0) {
                        this.m_GroupList = new Array();
                    }
                    try {
                        var xUsersAndGroupsDoc = $.parseXML(xmlData);
                        var tempGroupList = new Array();
                        var userGroups = $(xUsersAndGroupsDoc).find("UserGroups UserGroup");
                        // Bind data grid from xml - GroupTypes
                        for (var i = 0; i < userGroups.length; i++) {
                            var xElUserGroup = userGroups[i];
                            var userGroup = xElUserGroup.attributes["Name"].textContent.trim();
                            // Get rid of ViewPoint Viewers test, since there won't be a ViewPoint Viewers Group
                            // unless customer wants one.
                            if (userGroup == "All Users" || userGroup == "ViewPoint Viewers") {
                                continue;
                            }
                            var grp = new ViewPoint.Client.VPAdmin.Group();
                            grp.Name = userGroup;
                            tempGroupList.push(grp);
                            if (bAllowUsers) {
                                var users = $(xElUserGroup).find("Users User");
                                //Users
                                for (var j = 0; j < users.length; j++) {
                                    var xElUser = users[j];
                                    var name = xElUser.attributes["Name"].textContent.trim();
                                    //DFCTS00220233 we want to filter this one out
                                    if (name == "$AnonymousLogon") {
                                        continue;
                                    }
                                    var user = new ViewPoint.Client.VPAdmin.User(userGroup, xElUser.attributes["Name"].textContent.trim());
                                    if (grp.Members == null) {
                                        grp.Members = new Array();
                                    }
                                    grp.Members.push(user);
                                }
                                // Sort members
                                if (grp.Members != null) {
                                    grp.SortMembers();
                                }
                            }
                        }
                        // create sorted group list
                        this.m_GroupList = tempGroupList;
                        this.SortGroups();
                    }
                    catch (ex) {
                        helpers.showErrorMessage("Error reading/parsing xml users and groups\n" + ex.message.toString());
                    }
                };
                UserAndGroupsManager.prototype.SortGroups = function () {
                    this.m_GroupList.sort(function (a, b) {
                        var nameA = a._Name.toLowerCase(), nameB = b._Name.toLowerCase();
                        if (nameA < nameB)
                            return -1;
                        if (nameA > nameB)
                            return 1;
                        return 0; //default return value (no sorting)
                    });
                    this.m_GroupList.sort();
                };
                UserAndGroupsManager.prototype.UpdateGroup = function (groupName) {
                    var groups = this.m_GroupList;
                    for (var i = 0; i < groups.length; i++) {
                        var group = groups[i];
                        if (helpers.Compare(groupName, group._Name, true, true) == 0) {
                            group.IsSelected = !group.IsSelected;
                            break;
                        }
                    }
                };
                return UserAndGroupsManager;
            }());
            VPAdmin.UserAndGroupsManager = UserAndGroupsManager;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var WebService;
            (function (WebService) {
                var ClientIdentifier = /** @class */ (function () {
                    function ClientIdentifier() {
                        this.ExtensionData1Field = null;
                        this.UniqueClientIdentifierField = null;
                        this.UserHostField = null;
                        this.UserNameField = null;
                    }
                    Object.defineProperty(ClientIdentifier.prototype, "ExtensionData1", {
                        get: function () {
                            return this.ExtensionData1Field;
                        },
                        set: function (value) {
                            if ((this.ExtensionData1Field === value != true)) {
                                this.ExtensionData1Field = value;
                                this.RaisePropertyChanged("ExtensionData1");
                            }
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(ClientIdentifier.prototype, "UniqueClientIdentifier", {
                        get: function () {
                            return this.UniqueClientIdentifierField;
                        },
                        set: function (value) {
                            if ((this.UniqueClientIdentifierField === value != true)) {
                                this.UniqueClientIdentifierField = value;
                                this.RaisePropertyChanged("UniqueClientIdentifier");
                            }
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(ClientIdentifier.prototype, "UserHost", {
                        get: function () {
                            return this.UserHostField;
                        },
                        set: function (value) {
                            if ((this.UserHostField === value != true)) {
                                this.UserHostField = value;
                                this.RaisePropertyChanged("UserHost");
                            }
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(ClientIdentifier.prototype, "UserName", {
                        get: function () {
                            return this.UserNameField;
                        },
                        set: function (value) {
                            if ((this.UserNameField === value != true)) {
                                this.UserNameField = value;
                                this.RaisePropertyChanged("UserName");
                            }
                        },
                        enumerable: true,
                        configurable: true
                    });
                    ClientIdentifier.prototype.RaisePropertyChanged = function (propertyName) {
                        var propertyChanged = this.PropertyChanged;
                        if ((propertyChanged != null)) {
                            propertyChanged(this, propertyName);
                        }
                    };
                    return ClientIdentifier;
                }());
                WebService.ClientIdentifier = ClientIdentifier;
                var ConfigServiceStatusCode;
                (function (ConfigServiceStatusCode) {
                    ConfigServiceStatusCode[ConfigServiceStatusCode["Success"] = 0] = "Success";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["UnableToLoadApplication"] = 1] = "UnableToLoadApplication";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["UnknownScopeValue"] = 2] = "UnknownScopeValue";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["UnknownApplicationName"] = 3] = "UnknownApplicationName";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["ApplicationHasNotLoaded"] = 4] = "ApplicationHasNotLoaded";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["UnableToOpenApplication"] = 5] = "UnableToOpenApplication";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["DisplaysHaveNotLoaded"] = 6] = "DisplaysHaveNotLoaded";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["InitialDisplayNotProvided"] = 7] = "InitialDisplayNotProvided";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["PublishNotStart"] = 8] = "PublishNotStart";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["PublishInProgress"] = 9] = "PublishInProgress";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["PublishErrorProgressStop"] = 10] = "PublishErrorProgressStop";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["PublishErrorProgressContinue"] = 11] = "PublishErrorProgressContinue";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["PublishCompleted"] = 12] = "PublishCompleted";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["EventListNotAvailable"] = 13] = "EventListNotAvailable";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["WindowsServiceNotAvailable"] = 14] = "WindowsServiceNotAvailable";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["WebServiceNotAvailable"] = 15] = "WebServiceNotAvailable";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["SessionIsCurrentlyInUseByAnotherClient"] = 16] = "SessionIsCurrentlyInUseByAnotherClient";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["SessionIsNotInUse"] = 17] = "SessionIsNotInUse";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["SessionIsAlreadyActive"] = 18] = "SessionIsAlreadyActive";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["SessionHasBeenRenewed"] = 19] = "SessionHasBeenRenewed";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["BackgroundUpdateCouldNotBeCancelled"] = 20] = "BackgroundUpdateCouldNotBeCancelled";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["BackgroundUpdateCurrentlyInProgress"] = 21] = "BackgroundUpdateCurrentlyInProgress";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["LicenseSessionOrClientIDIsNullOrEmpty"] = 22] = "LicenseSessionOrClientIDIsNullOrEmpty";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["LicenseAllInUse"] = 23] = "LicenseAllInUse";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["LicenseAlreadyAssignedForThisSessionAndClientID"] = 24] = "LicenseAlreadyAssignedForThisSessionAndClientID";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["NoRunningViewApplication"] = 25] = "NoRunningViewApplication";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["ClientIPAddressNotAvailable"] = 26] = "ClientIPAddressNotAvailable";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["NoLicensesAllocatedForThisClientComputer"] = 27] = "NoLicensesAllocatedForThisClientComputer";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["WebServerProtectionFailed"] = 28] = "WebServerProtectionFailed";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["ApplicationNotRunning"] = 29] = "ApplicationNotRunning";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["LoginRequired"] = 30] = "LoginRequired";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["NotImplemented"] = 31] = "NotImplemented";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["NoManifestForApplication"] = 32] = "NoManifestForApplication";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["SecuredObjectNotFound"] = 33] = "SecuredObjectNotFound";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["NotAuthorized"] = 34] = "NotAuthorized";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["SessionHasExpired"] = 35] = "SessionHasExpired";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["SessionNotFound"] = 36] = "SessionNotFound";
                    ConfigServiceStatusCode[ConfigServiceStatusCode["ServerSettingException"] = 37] = "ServerSettingException";
                })(ConfigServiceStatusCode = WebService.ConfigServiceStatusCode || (WebService.ConfigServiceStatusCode = {}));
                var Scope;
                (function (Scope) {
                    Scope[Scope["Local"] = 0] = "Local";
                    Scope[Scope["Global"] = 1] = "Global";
                })(Scope = WebService.Scope || (WebService.Scope = {}));
                var TargetPlatform;
                (function (TargetPlatform) {
                    TargetPlatform[TargetPlatform["Distributed"] = 0] = "Distributed";
                    TargetPlatform[TargetPlatform["Station"] = 1] = "Station";
                    TargetPlatform[TargetPlatform["StandAlone"] = 2] = "StandAlone";
                    TargetPlatform[TargetPlatform["MEStandAlone"] = 3] = "MEStandAlone";
                })(TargetPlatform = WebService.TargetPlatform || (WebService.TargetPlatform = {}));
                var ProgressType;
                (function (ProgressType) {
                    ProgressType[ProgressType["Common"] = 0] = "Common";
                    ProgressType[ProgressType["Manifest"] = 1] = "Manifest";
                    ProgressType[ProgressType["Analyzing"] = 2] = "Analyzing";
                    ProgressType[ProgressType["Uploading"] = 3] = "Uploading";
                    ProgressType[ProgressType["UploadingCompleted"] = 4] = "UploadingCompleted";
                    ProgressType[ProgressType["Gft2XamlConversionStarted"] = 5] = "Gft2XamlConversionStarted";
                    ProgressType[ProgressType["Gft2XamlConversion"] = 6] = "Gft2XamlConversion";
                    ProgressType[ProgressType["Xaml2RamleConvertion"] = 7] = "Xaml2RamleConvertion";
                    ProgressType[ProgressType["Cancelled"] = 8] = "Cancelled";
                    ProgressType[ProgressType["NewPublish"] = 9] = "NewPublish";
                })(ProgressType = WebService.ProgressType || (WebService.ProgressType = {}));
                var ClientPublishResult = /** @class */ (function () {
                    function ClientPublishResult() {
                        /*this.ExtensionData1Field = null;
                        this.DeployURLField = null;
                        this.DeploymentStatusField = null;
                        this.ErrorReportPathField = null;
                        this.FinishPageField = null;
                        this.NumberOfErrorField = 0;
                        this.NumberOfWarningField = 0;*/
                        this.Stopped = null;
                        this.Succeed = null;
                    } /*
                    getExtensionData1() {
                        return this.ExtensionData1Field;
                    }
                    setExtensionData1(value) {
                        if ((this.ExtensionData1Field === value != true)) {
                            this.ExtensionData1Field = value;
                            this.RaisePropertyChanged("ExtensionData1");
                        }
                    }
                    getDeployURL() {
                        return this.DeployURLField;
                    }
                    setDeployURL(value) {
                        if ((this.DeployURLField === value != true)) {
                            this.DeployURLField = value;
                            this.RaisePropertyChanged("DeployURL");
                        }
                    }
                    getDeploymentStatus() {
                        return this.DeploymentStatusField;
                    }
                    setDeploymentStatus(value) {
                        if ((this.DeploymentStatusField === value != true)) {
                            this.DeploymentStatusField = value;
                            this.RaisePropertyChanged("DeploymentStatus");
                        }
                    }
                    getErrorReportPath() {
                        return this.ErrorReportPathField;
                    }
                    setErrorReportPath(value) {
                        if ((this.ErrorReportPathField === value != true)) {
                            this.ErrorReportPathField = value;
                            this.RaisePropertyChanged("ErrorReportPath");
                        }
                    }
                    getFinishPage() {
                        return this.FinishPageField;
                    }
                    setFinishPage(value) {
                        if ((this.FinishPageField === value != true)) {
                            this.FinishPageField = value;
                            this.RaisePropertyChanged("FinishPage");
                        }
                    }
                    getNumberOfError() {
                        return this.NumberOfErrorField;
                    }
                    setNumberOfError(value) {
                        if ((this.NumberOfErrorField.Equals(value) != true)) {
                            this.NumberOfErrorField = value;
                            this.RaisePropertyChanged("NumberOfError");
                        }
                    }
                    getNumberOfWarning() {
                        return this.NumberOfWarningField;
                    }
                    setNumberOfWarning(value) {
                        if ((this.NumberOfWarningField.Equals(value) != true)) {
                            this.NumberOfWarningField = value;
                            this.RaisePropertyChanged("NumberOfWarning");
                        }
                    }
                    getStopped() {
                        return this.StoppedField;
                    }*/
                    ClientPublishResult.prototype.setStopped = function (value) {
                        this.Stopped = value;
                    }; /*
                    getSucceed() {
                        return this.SucceedField;
                    }
                    setSucceed(value) {
                        if ((this.SucceedField.Equals(value) != true)) {
                            this.SucceedField = value;
                            this.RaisePropertyChanged("Succeed");
                        }
                    }
                    RaisePropertyChanged(propertyName) {
                        var propertyChanged = this.PropertyChanged;
                        if ((propertyChanged != null)) {
                            propertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
                        }
                    }*/
                    return ClientPublishResult;
                }());
                WebService.ClientPublishResult = ClientPublishResult;
            })(WebService = VPAdmin.WebService || (VPAdmin.WebService = {}));
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
/// <reference path="../../../helpers/helpers.ts" />
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var VPAdmin;
        (function (VPAdmin) {
            var CurrentPage;
            (function (CurrentPage) {
                CurrentPage[CurrentPage["SelectApp"] = 0] = "SelectApp";
                CurrentPage[CurrentPage["SelectDisplays"] = 1] = "SelectDisplays";
                CurrentPage[CurrentPage["Publish"] = 2] = "Publish";
            })(CurrentPage = VPAdmin.CurrentPage || (VPAdmin.CurrentPage = {}));
            var VPAdminUtil = /** @class */ (function () {
                function VPAdminUtil() {
                }
                /* AIS_NOTE: unused function
                /// <summary>
                /// Function to get image resource from Resource file
                /// </summary>
                /// <param name="imageLoc"></param>
                /// <returns>Will return null if image can't be found</returns>
                public static GetImageResource(imageLoc) {
                    var uriPath = String.Format(CultureInfo.getInvariantCulture(),"ViewPoint.Client.VPAdmin;component/{0}",imageLoc);
                    var imageStream = Application.GetResourceStream(new System.Uri(uriPath,UriKind.Relative));
                    if (imageStream != null) {
                        var image = new System.Windows.Media.Imaging.BitmapImage();
                        image.SetSource(imageStream.getStream());
                        return image;
                    } else {
                        return null;
                    }
                }*/
                /// <summary>
                /// Function to get string from Resource file
                /// </summary>
                /// <param name="stringId"></param>
                /// <returns>Will return null if string can't be found</returns>
                VPAdminUtil.GetString = function (stringId) {
                    var result = null;
                    try {
                        result = VPAdmin.ResourceBinder.getString(stringId);
                    }
                    catch (_) {
                    }
                    return result;
                };
                /* AIS_NOTE: unused function
                static GetApplication() {
                    return helpers.asType(Application.getCurrent(),ViewPointAdminApp);
                }*/
                VPAdminUtil.GetMainPage = function () {
                    return document.getElementById("MainPageContent");
                };
                /// <summary>
                /// Set cookie with given key and value pair
                /// </summary>
                /// <param name="key"></param>
                /// <param name="value"></param>
                VPAdminUtil.SetCookie = function (key, value) {
                    var expireDate = new Date();
                    expireDate.setFullYear(expireDate.getFullYear() + 100);
                    var newCookie = key + "=" + value + ";expires=" + expireDate.toDateString();
                    document.cookie = newCookie;
                };
                /// <summary>
                /// Get cookie value with give key, will return null it can't find it
                /// </summary>
                /// <param name="key"></param>
                /// <returns></returns>
                VPAdminUtil.GetCookie = function (key) {
                    var cookies = document.cookie.split(";");
                    for (var c in cookies) {
                        var cookie = cookies[c];
                        var cKey = cookie.substring(0, cookie.indexOf("="));
                        var cValue = cookie.substring(cookie.indexOf("=") + 1);
                        if (cKey && cValue) {
                            if (helpers.Compare(cKey.trim(), key, false, false, true) == 0)
                                return cValue;
                        }
                    }
                    return null;
                };
                /// <summary>
                /// Create http help link base on the suffix of the link content
                /// </summary>
                /// <param name="linkContent"></param>
                /// <returns></returns>
                VPAdminUtil.CreateHelpLink = function (linkContent) {
                    var link;
                    var host = window.location.protocol + "//" + window.location.host;
                    var pathParts = window.location.href.split("/");
                    //var parLenght;
                    //(pathParts.length <= 5) ? parLenght = pathParts.length - 1 : parLenght = pathParts.length - 2;
                    //for (var pathPartIdx = 3; pathPartIdx < parLenght; pathPartIdx++) {
                    //    vDir += pathParts[pathPartIdx] + "/";
                    //}
                    var vDir = VPAdminUtil.GetString("RootDirectory");
                    link = helpers.Format("{0}/{1}help/FactoryTalk ViewPoint/!SSL!/Administration/{2}", host, vDir, linkContent);
                    return link;
                };
                /// <summary>
                /// Create http release note base on the suffix of the link content
                /// </summary>
                /// <param name="linkContent"></param>
                /// <returns></returns>
                VPAdminUtil.CreateReleaseNoteLink = function (linkContent) {
                    var link;
                    var host = window.location.protocol + "//" + window.location.host;
                    var vDir = VPAdminUtil.GetString("RootDirectory");
                    link = helpers.Format("{0}/{1}ReleaseNotes/{2}", host, vDir, linkContent);
                    return link;
                };
                /// <summary>
                /// Use SilverLight MessageBox to show a dialog with message header
                /// </summary>
                /// <param name="message"></param>
                VPAdminUtil.ShowMessage = function (message, messagetype, buttons) {
                    var header = VPAdminUtil.GetString("msgMessageBoxHeader");
                    if (buttons === undefined)
                        buttons = ViewPoint.Client.Toolkit.Controls.DialogBoxButtons.Ok;
                    if (messagetype === undefined)
                        messagetype = ViewPoint.Client.Toolkit.Controls.MessageType.None;
                    var box = new ViewPoint.Client.Toolkit.Controls.DialogBox(message, messagetype, buttons);
                    if (messagetype === ViewPoint.Client.Toolkit.Controls.MessageType.None) {
                        box.Title = header;
                        $('#Title').text(header);
                    }
                    box.CenterOnScreen();
                    //box.DialogName = "DialogBoxRoot";
                    ViewPoint.Client.Toolkit.Controls.DialogBox.CurrentDialogBox = box;
                    if (header) {
                        box.ShowModal(header);
                    }
                    else {
                        box.ShowModal();
                    }
                    $('#' + box.DialogName).css('z-index', '1500');
                    return box;
                };
                /* AIS_NOTE: unused function
                public static GetBrush(name) {
                    var o = ViewPoint.Client.VPAdmin.VPAdminUtil.GetMedia(name);
                    if (null == o || !(helpers.isType(o,System.Windows.Media.Brush)))return new System.Windows.Media.SolidColorBrush(Colors.getWhite());
                    return o;
                }*/
                /* AIS_NOTE: unused function
                public static GetMedia(name) {
                    if (Application.getCurrent().getResources().Contains(name))return Application.getCurrent().getResources()[name];
                    var $it = Application.getCurrent().getResources().getMergedDictionaries().GetEnumerator();
                    while ( $it.MoveNext() ) {
                        var rd = $it.getCurrent();
                        if (rd.Contains(name))return rd[name];
                    }
                    return null;
                }*/
                VPAdminUtil.DIRECT_TO_PUBLISH = "DirectToPublish";
                VPAdminUtil.SCHEME_AND_SERVER = window.location.protocol + "//" + window.location.host;
                return VPAdminUtil;
            }());
            VPAdmin.VPAdminUtil = VPAdminUtil;
        })(VPAdmin = Client.VPAdmin || (Client.VPAdmin = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
//# sourceMappingURL=ViewPoint.Client.VPAdmin.js.map